                        zeusemulate "48K"               ;

                        org $8000                       ;

AppStart                ld a,2                          ;
                        call 5633                       ;

Lp                      ld de,sString                   ;
                        ld bc,lString                   ;
                        call 8252                       ;
                        jp Lp                           ;

sString                 db "Hello World "               ;
lString                 equ $-sString                   ;

AppLength               equ *-AppStart                  ;

Zeus_PC                 equ AppStart                    ;

; We need a loading screen for mode 1 files

                        import_bin "Mode1.scr",$4000

; Save this as a mode 1 tzx

                        output_tzx "Mode1.tzx","Mode1","",AppStart,AppLength,1

; Save this as a mode 1 tap

                        output_tap "Mode1.tap","Mode1","",AppStart,AppLength,1

/* From the History/Documentation

    MODE 1 (Uses a custom loader. 48K, or first 48K of a 128K model)

    Zeus can also automatically generate a "PROGRAM" block containing a tape loader, and add the
    code as a data block after it... this uses a loader like the ones I used to use in the 80's
    that load the screen at the same time as they load the data.

    This mode cannot be used on the 16K Spectrum, and on the 128K models it cannot load to the pages
    that do not map into main memory normally. (For 128K loading see mode 3, below).

    output_tzx "pc filename","tape filename","comment",Start,Length, 1 ,ExecuteAddr
    or it supports some options, mainly you can change the border colours
    output_tzx "pc filename","tape filename","comment",Start,Length, 1 ,ExecuteAddr,Options

    To use this loader sensibly you should have a loading screen loaded in memory at $4000 .. $5AFF
    for it to use... how Zeus chooses to load the screen depends on how much of it contains visible
    pixels; if entire lines of pixels are $00 Zeus will not load them.

    For example, if you have an assembler source for a game that starts at $8000, is $2000 bytes
    long and you have a loading screen for it in a file called "screen.scr" then Zeus can generate
    a tzx file with a nice loading screen using the commands:

    import_bin "screen.scr",$4000 ; This gets the loading screen and puts it in memory in place
    output_tzx "game.tzx","mygame","(c) Etc",$8000,$2000,1,$8000 ; Generate the tzx file
    where the 1 indicates this is the required TZX format.

    To load a program generated using Zeus use LOAD "" on your Spectrum or emulator.

    The "Options" optional parameter allows you to set the colours used while the loader is operating.
    Options is a 32-bit value containing six 4-bit fields. These are as follows:

    Bits    | 31 .. 24  | 23 .. 20 | 19 .. 16 | 15 .. 12 | 11 ..  8 |  7 ..  4 |  3 ..  0 |
    Effect  | Not Used  | Line INC | Line XOR | Loader A | Loader B | Leader A | Leader B |

    Where Leader A and B are the colours used while reading the tape leader, Loader A and B are the
    colours used while reading the data, and the loader colours are modified at the end of each
    video line by the Line XOR and Line INC values... the XOR and INC values interact with each
    other... if you don't want the border flashing on each bit-cycle make the A and B values the
    same. For example these colours are particularly repulsive.

    output_tzx "tony","tony","Hideous!",$7F00,$4000,1,$7F00,$00123456

    The most significant byte is reserved for other loader options to be added in future. Set it
    to zero for the moment.

    Use LOAD "" to load this. Or will load automatically on most emulators.

*/

