; Spectrum equates

ScreenBase              equ $4000                       ;
Attrs                   equ $5800                       ;
lAttrs                  equ $300                        ;

; Front end source starts

; Equates

OptiFlashR              equ 10                          ;
UDKfr                   equ 10                          ;

MinScans                equ 1                           ;
MinScansShift           equ 0                           ;

FlashRate               equ 10                          ;
HSTimeOut               equ 2000                        ;

SoundPort               equ $FE                         ;

cDel                    equ $08                         ;
cCret                   equ $0D                         ;
cCls                    equ $0C                         ;
Clr                     equ $1B                         ;
Home                    equ $0E                         ;

                ; Active text markers

cScore                  equ $B0                         ;
cnRings                 equ $B1                         ;
cAnEss                  equ $B2                         ;
cnThings                equ $B3                         ;
cBlurb                  equ $B4                         ;
cTabMid                 equ $B5                         ;
cEnableJokes            equ $B6                         ;
cEnablePiss             equ $B7                         ;

ckLeft                  equ $C0                         ;
ckRight                 equ $C1                         ;
ckUp                    equ $C2                         ;
ckDown                  equ $C3                         ;
ckFireball              equ $C4                         ;
ckLightning             equ $C5                         ;
ckArrow                 equ $C6                         ;
ckSword                 equ $C7                         ;
ckDrop                  equ $C8                         ;
ckClose                 equ $C9                         ;

cBlack                  equ $00                         ;
cBlue                   equ $01                         ;
cRed                    equ $02                         ;
cMagenta                equ $03                         ;
cGreen                  equ $04                         ;
cCyan                   equ $05                         ;
cYellow                 equ $06                         ;
cWhite                  equ $07                         ;

delSp                   equ 3                           ; Monster speed up rate
mDynamMaxSpeed          equ 15                          ; Fastest monster (min delay)

cLintelRHS              equ $91                         ;
cLintelLHS              equ $92                         ;
cLintelBOT              equ $94                         ;
cLintelTOP              equ $98                         ;

cSleepingMonster        equ $D6

cDoorHori               equ $DC                         ;
cDoorVert               equ $DD                         ;

DoorTimer               equ 30                          ; Number of moves before this times out

XW                      equ 28                          ;
YW                      equ 21                          ;

pAttrib                 equ #5800                       ;
ScorePos                equ #1200                       ;

; These man delays are now frame-locked

ManSpeed                equ 0                           ; Man move rate (moving)
ManDelSlow              equ 1                           ; Man move rate

FireLife                equ 56                          ; Fireball life
FBSR                    equ 40                          ; Fireball search range
FireSpeedInit           equ 28                          ; Speed
FireSpeedFast           equ 10                          ; Speed
FireTurnRate            equ 2                           ; Update rate

LightLife               equ 100                         ; Lightning life
LightLifeRunning        equ XW                          ; Shorter lightning life
LtSR                    equ 50                          ; Lightning search range
LightSpeed              equ 13                          ; Speed
LightSpeedRunning       equ 8                           ; Faster

nTreasure               equ 40                          ;
nMagic                  equ 40                          ;

ArrowLife               equ 55                          ;
ArrowLifeMan            equ 32                          ;
ArrowSpeed              equ 15                          ;

FireDamageToMon         equ 40                          ; Hit points
LightDamageToMon        equ 40                          ; Hit points
SwordDamageToMon        equ 20                          ; Hit points (was 10)

MaxTreasure             equ nTreasure                   ;

nProj                   equ 32                          ;
nMonst                  equ 32                          ;

        struct                                          ; Displacements for projectiles
dp_Life                 ds 1                            ; Must be at offset 0!
dp_Delay                ds 1                            ;
dp_iDelay               ds 1                            ;
dp_pMaze_L              ds 1                            ;
dp_pMaze_H              ds 1                            ;
dp_Off_L                ds 1                            ;
dp_Off_H                ds 1                            ;
dp_pCode_L              ds 1                            ;
dp_pCode_H              ds 1                            ;
dp_MissileChar          ds 1                            ;
dp_BackingChar          ds 1                            ;
dp_Step1_L              ds 1                            ;
dp_Step1_H              ds 1                            ;
dp_ErrR                 ds 1                            ;
dp_ErrS                 ds 1                            ;
dp_ErrM                 ds 1                            ;
dp_pOwner_L             ds 1                            ;
dp_pOwner_H             ds 1                            ;
dp_pTarget_L            ds 1                            ;
dp_pTarget_H            ds 1                            ;
dp_Origin_L             ds 1                            ;
dp_Origin_H             ds 1                            ;
dp_ManF                 ds 1                            ;
dp_UpdateRate           ds 1                            ;
dp_TargetiPos_L         ds 1                            ;
dp_TargetiPos_H         ds 1                            ;
dp_pTarget2_L           ds 1                            ;
dp_pTarget2_H           ds 1                            ;
dp_RSave                ds 1                            ;
dp_pMazeSave_L          ds 1                            ;
dp_pMazeSave_H          ds 1                            ;
dp_pNext                ds 2                            ;
lProj                   equ *                           ;
        send

                        ; These are only used during initial setup and overlay
                        ; the code address store

dp_dX                   equ dp_pCode_L                  ;
dp_dY                   equ dp_pCode_H                  ;

        struct                                          ; Displacements for monsters
dm_pMaze_L              ds 1                            ;
dm_pMaze_H              ds 1                            ;
dm_Char                 ds 1                            ;
dm_MoveType             ds 1                            ;
dm_Strength             ds 1                            ;
dm_Flags                ds 1                            ;
dm_Magic                ds 1                            ;
dm_MaxMagic             ds 1                            ;
dm_Treasure             ds 1                            ;
dm_MaxStrength          ds 1                            ;
dm_Delay                ds 1                            ;
dm_cSpeed               ds 1                            ;
dm_nArrows              ds 1                            ;
dm_Wounds               ds 1                            ;
dm_Combat               ds 1                            ; [0] = can see man [7] = targetted
dm_Dirn                 ds 1                            ;
dm_Cache                ds 4                            ;

lMonsterFixed           equ *                           ; Below this they're defined

dm_iSpeed               ds 1                            ;
dm_PastPos_L            ds 1                            ; These are zero'd on creation
dm_PastPos_H            ds 1                            ;
dm_TimeOut              ds 1                            ;
;dm_AltMoveF             ds 1                            ;
dm_AimCnt               ds 1                            ; How much shit is heading our way...

;dm_pNext                ds 2                            ;

lMonst                  equ *                           ;
        send

        if dm_pMaze_L <> 0
          zeuserror "The code that decides if a projectile has hit it's owner needs this to be zero!"
        endif

        struct                                          ; Ring save table
drt_pMaze_L             ds 1                            ;
drt_pMaze_H             ds 1                            ;
drt_Floor               ds 1                            ;

lRingTable              equ *                           ;
        send

        struct                                          ; Maze monster definition
dml_pMaze_L             ds 1                            ;
dml_pMaze_H             ds 1                            ;
dml_Char                ds 1                            ;
dml_MoveType            ds 1                            ;
        send

        struct                                          ; Maze monster definition
dst_Off_L               ds 1                            ;
dst_Off_H               ds 1                            ;
dst_Char                ds 1                            ;
        send

; Maze type definitions

dmo_Prob0               equ 0                           ;
dmo_Prob1               equ 8                           ;
dmo_Prob2               equ 16                          ;

; Setup the character encryption

encoff                  equ 31                          ; Setup the encryption
                        dbxo encoff                     ;

