; Dead thing characters

deadMon_Steamed         equ #DB                         ;
deadMon_Sword           equ #DE                         ;
deadMon_Arrow           equ #DF                         ;
deadMon_Steaming        equ #E0                         ;

JokeDelay               equ 20                          ; How long we wait

DodgeTime               equ 6                           ; Time before projectiles hurt their firer
ManDodgeTime            equ 10                          ;

MaxMagic                equ 255                         ;
MaxWounds               equ 127                         ;

; A few QAD macros

mSCV_Out                macro()                         ;
                          call SCV                      ;
                          call nc OutIt                 ;
                          mend                          ;

mAddNoise               macro(cnt)
                          ld a,(NoiseCnt)
                          add a,cnt
                          ld (NoiseCnt),a
                          mend

mOutSound               macro(reg)
                          out ($FE),reg
                          mend

mNoiseON                macro()
                          ld a,(CType)
                          mOutSound(a)
                          mend

mNoiseOFF                macro()
                          ld a,%000 00 000
                          mOutSound(a)
                          mend

; This code builds a random maze

                        include "maze.inc"              ;

; Start the game

StartRunningGame        ld a,%0000 0111                 ; Full-on aggression
                        ld (GameBType),a                ;

                        ld a,1                          ;
                        jr SG_SetType                   ;

StartGame               ld a,(BType)                    ; The user's choice
                        ld (GameBType),a                ;

                        xor a                           ;

                        ; Fall into...

SG_SetType              ld (GameType),a                 ;

                        ld (Stack),sp                   ;

        if def bReturnInstantResult
                ld hl,256
                ld (nDTs),hl
                ld a,#8
                ld (nRings),a

                ld hl,10000
                ld (GameScore),hl

                ld a,#1

                ret
        endif

; Restart here in the event of a fuck-up

FuckUp                  equ *

                if def bFixedMaze
                        ld hl,$1111
                        ld (Seed),hl
                        ld (Seed+2),hl
                        ld a,0
                        ld r,a
                endif

                        ld sp,(Stack)                   ;

                        ; Add the silly message

                        call ShowTitleMsg               ; Add the title message

                        call RandRange

                        xor a                           ; Init the progress showing
                        ld (ShowProgX),a                ;

                        call InitSanctuary              ;

                        call InitGame                   ;

                        call Gen8                       ;

                        ; Start us on the ground floor

                        ld a,0                          ;
                        ld (cFloor),a                   ;

                        call Recreate                   ;

                        call PlaceMon                   ;

                        call OpenBasement               ; If required

                        call JustifyT                   ;

                        call InitGameKeys               ;

                        ; We're starting on a new floor

                        call PM                         ;

                        call InitProjList               ;

                        call NewScreen                  ;

                        ld a,0                          ; Clear the sword
                        ld (SwdPhase),a                 ;
                        ld hl,0                         ;
                        ld (SwdPos),hl                  ;

                        ; Set the speed

                        ld a,(GameBType)                ; Slow or fast?
                        ld b,#5                         ;

                        and $01                         ;
                        jr z SetGameSpeed               ;

                        ld b,#7                         ;
SetGameSpeed            ld a,b                          ;

                        ld (GameSpeed),a                ;
                        ld (GameLpCnt),a                ;

        zeustimerstart 1
GameLoop                call MoveMan                    ;

                        call MoveMonsters               ;

                        call MoveProjectiles

;                        call GameScanKeys               ;

                        xor a                           ;
                        out ($FE),a                     ;

                        call JustifyScreen              ;

                        call DisplayStatus              ;

                        call Noises                     ;

                        call EditScreen                 ; Try editing

                zeustimerstart 2
                        call Rand1                      ;
                        ld a,(Seed)                     ;
                        ld r,a                          ;
                zeustimerstop 2

                        ; Speed

                        call CheckSpeed                 ;

                        call CheckJOKE                  ;
                        jp z DunIt                      ;

                        call CheckQuit                  ;
                        jp nz GameLoop                  ;

                        ; The player has been killed

LeaveGame               call FadeScreen                 ;

                        ld de,0                         ; Treasure = 0
                        call CalcScore_NoTreasure       ;
                        ld (GameScore),hl               ; Save

                        ld sp,(Stack)                   ; Restore

                        ld a,0                          ; Flag that we were killed
                        ret                             ; Exit

; Check the speed

CheckSpeed              ld a,(GameLpCnt)                ;
                        dec a                           ;
                        ld (GameLpCnt),a                ;
                        ret nz                          ;

                        ld a,(GameSpeed)                ;
                        ld (GameLpCnt),a                ;

CheckSpeedPause         ld a,(IrqFlag)                  ;
                        or a                            ;
                        jr z CheckSpeedPause            ;

                        xor a                           ;
                        ld (IrqFlag),a                  ;

                        ret                             ;

; Clear the keys

InitGameKeys            ld hl,KeyStart                  ; Base
                        ld b,KeyEnd-KeyStart            ;

IGK                     ld (hl),0                       ;
                        inc hl                          ;
                        djnz IGK                        ;
                        ret                             ;
; Enable the jokes

PS_EnableJokes          ld a,$FF                        ; Set the enable flag
                        ld (bJokeEnable),a              ;
                        ret                             ; Done

; Enable the piss

PS_EnablePiss           ld hl,PissDefn                  ; Overwrite the chars
                        ld de,LightningDefn             ;
                        ld bc,16                        ;
                        ldir                            ;

                        ld a,#46                        ; Yellow
                        ld (LightningAttr1),a           ;
                        ld (LightningAttr2),a           ;
                        ret                             ; Done

; We've escaped and finished the game

DunIt                   call FadeScreen                 ;

                        call CalcScore_WithTreasure     ; We include the treasure
                        ld (GameScore),hl               ; Save

                        ; Exit this code

FOut                    ld sp,(Stack)                   ; Restore

                        ld a,1                          ; Flag that we won
                        ret                             ; Exit

; Setup the game's variables

InitGame                xor a                           ;
                        out (#FE),a                     ;
                        ld (Wounds),a                   ;
                        ld (TreasureCount),a            ;
                        ld (UnderMan),a                 ;
                        ld (JFLAG),a                    ;

                        ld a,#FF                        ;
                        ld (pFrameX),a                  ;
                        ld (pFrameY),a                  ;

                        ld a,120                        ;
                        ld (CurrentMagic),a             ;

                        ld a,255                        ;
                        ld (ArrowCount),a               ;

                        ld a,3                          ;
                        ld (ArrDir),a                   ;
                        ld (ManAngle),a                 ;
                        ld (MManDelay),a                ; Conveniently fast first move
                        ld a,-8                         ;
                        ld (JustXDisp),a                ;

                        ld hl,BigMaze+14077             ;
                        ld (pMan),hl                    ;
                        ld (pManLookingSquare),hl       ;
                        call ConvBM_To_XY_HL            ;
                        ld (pFrameX),hl                 ;

                        ld hl,0                         ;
                        ld (ManOPosXY),hl               ;

                        ret                             ;

; Fade out

FadeScreen              ld ix,$3000                     ; Speed
                        jr FadeScreenLp                 ;

FadeScreenFast          ld ix,$0100                     ; Speed

                        ; Fade it

FadeScreenLp            ld e,$00                        ;
                        ld hl,Attrs                     ;
                        ld bc,$0300                     ;

Fade1                   ld a,(hl)                       ;
                        and $07                         ;
                        jr z,Fade2                      ;

                        set 0,e                         ;
                        dec (hl)                        ;
Fade2                   cpi                             ;
                        jp pe,Fade1                     ;

                        push ix                         ;
                        pop bc                          ;
FadeDel1                cpi                             ;
                        dec hl                          ;
                        jp pe,FadeDel1                  ;

                        bit 0,e                         ;
                        jr nz,FadeScreenLp              ;

                        ret                             ; Done

; Edit the screen

EditScreen              ld a,(bJokeEnable)              ;
                        ld b,a                          ;
                        ld a,(Key2P)                    ;
                        and b                           ;
                        ret z                           ;

                        xor a                           ;
                        ld (Key2P),a                    ;

                        ; Edit it

                        ld hl,(pMan)                    ;
                        ld (pEdit),hl                   ;

                        ld a,(hl)                       ;
                        ld (EditUnder),a                ;

                        ld a,$90                        ;
                        ld (EditChar),a                 ;

                        call ShowEditCursor             ;

                        ; Edit loop

EditLp                  call EditDelay                  ; Scans keys

                        ; Move the cursor

                        call ClearEditCursor            ;

                        call GetCursorDir               ;
                        ld hl,(pEdit)                   ;
                        add hl,de                       ;
                        ld (pEdit),hl                   ;

                        call EditChangeChar             ;

                        call ShowEditCursor             ;

                        ; Change the character?

                        ld a,(KeyspP)                   ; Change it
                        or a                            ;
                        call nz EditReplace             ;

                        ; Delay

                        ld a,(Key2P)                    ;
                        or a                            ;
                        jr z EditLp                     ;

                        xor a                           ;
                        ld (Key2P),a                    ;

                        ; Clear the cursor

ClearEditCursor         ld hl,(pEdit)                   ; Restore the char
                        ld a,(EditUnder)                ;
                        ld (hl),a                       ;

                        mSCV_Out()                      ;
                        ret                             ;

; Replace the char

EditReplace             ld a,(EditChar)                 ;
                        ld (EditUnder),a                ;

                        xor a                           ;
                        ld (KeyspP),a                   ;

                        ret                             ;
; Move cursor?

GetCursorDir            call MMoveLR                    ; Move left or right?
                        jr c GCD_Set                    ; l or r, so can't move up/down

                        call MMoveUD                    ; Move up or down?

                        ld de,#0                        ;
                        ret nc                          ; No

GCD_Set                 jp CDirect                      ; DE := offset

; Change char?

EditChangeChar          ld a,(KeyFire)                  ; Up?
                        or a                            ;
                        jr z ECC_1                      ; No

                        xor a                           ;
                        ld (KeyFireP),a                 ;

                        ld b,1                          ;
                        jr ECC_Change                   ;

ECC_1                   ld a,(KeyLight)                 ; Down?
                        or a                            ;
                        ret z                           ; No

                        xor a                           ;
                        ld (KeyLightP),a                ;

                        ld b,-1                         ;

                        ; Fall into

ECC_Change              ld a,(EditChar)                 ;
                        add a,b                         ;
                        ld (EditChar),a                 ;

                        ret                             ; Done

; Show the cursor

ShowEditCursor          ld hl,(pEdit)                   ; Save the char
                        ld a,(hl)                       ;
                        ld (EditUnder),a                ;

                        ld a,(EditChar)                 ;
                        ld (hl),a                       ;

                        mSCV_Out()                      ;
                        ret                             ;

; Wait

EditDelay               ld bc,$300                      ;

ED_Lp                   push bc
                        call GameScanKeys
                        pop bc

                        cpi                             ;
                        jp v ED_Lp                      ;
                        ret                             ;

; Should we make a noise

Noises                  ld a,(NoiseCnt)                 ; Do we have any
                        or a                            ;
                        ret z                           ;

                        dec a                           ;
                        ld (NoiseCnt),a                 ;

                        ; Now, make a noise

                        ld a,(CType)                    ;
;                        ld b,a                          ;
;                        ld a,r                          ;
;                        and b                           ;
                        mOutSound(a)                    ;

                        ret                             ; Done

; Show the status screen

DisplayStatus           ld hl,Key1P                     ;
                        call ReadAKey                   ;
                        ret z                           ;

                        call FadeScreenFast             ;

                        call DrawScoreFixed             ;

DS_Lp                   equ * ;call GameScanKeys               ;

                        ld a,(TempStore)                ;
                        dec a                           ;
                        ld (TempStore),a                ;

                        and $07                         ;
                        call z SlowlyHeal               ;

                        call DrawScoreEtc               ;

                        call ArrowDir                   ;

                        ; Exit

                        ld hl,Key1P                     ;
                        call ReadAKey                   ;
                        jr z DS_Lp                      ;

                        xor a                           ;
                        ld (MManDelay),a                ;

                        call FadeScreenFast             ;

                        call NewScreen                  ;

                        call PMD                        ;

                        ret                             ;

; Add the titles while we draw the maze

ShowTitleMsg            ld de,sNames1                   ;
                        ld hl,#0F00                     ;
                        call SPrint                     ;

                        ; Add something?

                        ld a,(GameCount)                ;
                        inc a                           ;
                        ld (GameCount),a                ;

                        ld de,sNames2                   ;
                        cp JokeDelay                    ;
                        jr z STM_1                      ;

                        ld de,sNames3                   ;
                        cp JokeDelay+1                  ;
                        jr z STM_1                      ;

                        ld de,sNames4                   ;
                        cp JokeDelay+2                  ;
                        jp nz ShowTitlesRev             ; Show the titles

STM_1                   ld hl,#1100                     ;
                        call SPrint                     ;

                        jp ShowTitlesRev                ; Show the titles

sNames1                 dbx *,"Please wait a moment...",0
sNames2                 dbx *,"(while admiring those names)",0
sNames3                 dbx *,"(you'll rarely see their like)",0
sNames4                 dbx *,"(probably all dead by now)",0

; Use the man movement keys to determine the arrow direction

ArrowDir                call MMoveLR                    ; Move left or right?
                        jr c AD_Set                     ; l or r, so can't move up/down

                        call MMoveUD                    ; Move up or down?
                        ret nc                          ; No

AD_Set                  ld (ArrDir),a                   ; Set the direction
                        ret                             ;

; Test the man-move keys. CF = move

MMoveLR                 ld a,(DType)                    ; Use the alternate keys?
                        or a                            ;
                        jr nz MMoveLR_Alt               ;

                        ; Z/X

                        ld bc,65278                     ;
                        in a,(c)                        ;

                        bit 1,a                         ;
                        jr z MMLR1                      ;

                        bit 2,a                         ;
                        jr z MMLR2                      ;

MMLR0                   or a                            ;
                        ret                             ;

MMLR1                   bit 2,a                         ;
                        jr z MMLR0                      ;

                        ld a,3                          ;
                        scf                             ;
                        ret                             ;

MMLR2                   bit 1,a                         ;
                        jr z MMLR0                      ;

                        ld a,1                          ;
                        scf                             ;
                        ret                             ;

                ; A/D

MMoveLR_Alt             ld bc,$FDFE                     ;
                        in a,(c)                        ;

                        bit 0,a                         ;
                        jr z MMLR_A1                    ;

                        bit 2,a                         ;
                        jr z MMLR_A2                    ;

MMLR_A0                 or a                            ;
                        ret                             ;

MMLR_A1                 bit 2,a                         ;
                        jr z MMLR_A0                    ;

                        ld a,3                          ;
                        scf                             ;
                        ret                             ;

MMLR_A2                 bit 0,a                         ;
                        jr z MMLR_A0                    ;

                        ld a,1                          ;
                        scf                             ;
                        ret                             ;

MMoveUD                 ld a,(DType)                    ; Use the alternate keys?
                        or a                            ;
                        jr nz MMoveUD_Alt               ;

                        ld bc,32766                     ;
                        in a,(c)                        ;

                        bit 3,a                         ;
                        jr z MMUD1                      ;

                        bit 2,a                         ;
                        jr z MMUD2                      ;

                        or a                            ;
                        ret                             ;

MMUD1                   bit 2,a                         ;
                        jr z MMLR0                      ;

                        ld a,0                          ;
                        scf                             ;
                        ret                             ;

MMUD2                   bit 3,a                         ;
                        jr z MMLR0                      ;

                        ld a,2                          ;
                        scf                             ;
                        ret                             ;


MMoveUD_Alt             ld bc,$FBFE                     ;
                        in a,(c)                        ;

                        bit 1,a                         ;
                        jr z MMUD_A1                    ;

                        ld bc,$FDFE                     ;
                        in a,(c)                        ;
                        bit 1,a                         ;
                        jr z MMUD_A2                    ;

                        or a                            ;
                        ret                             ;

MMUD_A1                 ld bc,$FDFE                     ;
                        in a,(c)                        ;
                        bit 1,a                         ;
                        jr z MMLR_A0                    ;

                        ld a,0                          ;
                        scf                             ;
                        ret                             ;

MMUD_A2                 ld bc,$FBFE                     ;
                        in a,(c)                        ;
                        bit 1,a                         ;
                        jr z MMLR_A0                    ;

                        ld a,2                          ;
                        scf                             ;
                        ret                             ;

                ; See if we want to close a door

MCloseDoor              ld a,(bManMoving)               ; Are we moving?
                        or a                            ;
                        jr nz MCheckCloseBehind         ; Yes, check behind

                        ; We're not moving. Close in front?

                        ld hl,KeyCloseP                 ; Close in front?
                        call ReadAKey                   ;
                        ret z                           ;

                        ; We want to close any door ahead of us

                        call IsManNearDoor              ; Look for a door
                        ret nz                          ; None found

                        ; Clear the open request flag

                        xor a                           ; 0
                        ld (bDoorOpenKeepReq),a         ;

                        ; Is it an open door?

MCloseIfOpen            ld a,c                          ; The door character
                        cp " "                          ; Open?
                        ret nz                          ; No, so ignore

                        jr CloseDoor_HL                 ; Close it

                ; See if we want to close one behind

MCheckCloseBehind       ld a,(KeyClose)                 ; Pressed?
                        or a                            ;
                        ret z                           ; Nope

                        ; Is there a door here?

                        call IsDoorBehindMan            ; One there?
                        ret nz                          ; No

                        ; Yes, clear the close key

                        xor a                           ; Clear the flag
                        ld (KeyCloseP),a                ;

                        ; Close it

                        jr MCloseIfOpen                 ; As above

; So close the door we just found (HL points at TOP/LEFT char, DE = 1 or 128)

CloseDoor_HL            ld a,cDoorHori                  ; Presume horizontal (DE=1)
                        dec e                           ; Is E=1?
                        jr z CD_Hori                    ; Yes, skip

                        ld a,cDoorVert                  ; It's vertical
CD_Hori                 inc e                           ; Restore

                        ; Close the door

FillDoorway             ld b,4                          ; Length

FD_Lp                   ld (hl),a                       ; Store this character
                        push hl                         ; Show the character if it's visible
                        mSCV_Out()                      ;
                        pop hl                          ;

                        add hl,de                       ; Move that way
                        djnz FD_Lp                      ; Loop

                        ret                             ;

                ; Now, do we have a pending open/keep request?

MOpenDoor               ld a,(bDoorOpenKeepReq)         ;
                        or a                            ;
                        ret z                           ; No, exit

                        dec a                           ; Time it out
                        ld (bDoorOpenKeepReq),a         ;

                        ; Now, first we see if there is anything ahead of us that we might want to keep

                        call AnythingToKeep             ; Anything in out way?
                        ret nz                          ; Yes, we kept something instead.

                        ; Are we near a door

                        call IsManNearDoor              ; Look for a door
                        ret nz                          ; None found

                        ; Clear the open request flag

                        xor a                           ; 0
                        ld (bDoorOpenKeepReq),a         ;

                        ; Is it an open door?

                        ld a,c                          ; The door character
                        cp " "                          ; Open?
                        ret z                           ; Yes, ignore

                        ; Open the doorway

OpenDoor_HL             ld a," "                        ; Clear it
                        jp FillDoorway                  ; As above

; Set the request that we change the next door

SetRequestDoorKeep      ld a,DoorTimer                  ; Set the timer
                        ld (bDoorOpenKeepReq),a         ;

                        ret                             ; Done

; See if the man is standing with a doorway behind him

IsDoorBehindMan         ld hl,(pMan)                    ; We want the square BEHIND the man
                        ld a,(ManAngle)                 ;
                        xor 2                           ;

                        call CDirect                    ;
                        cp 2                            ;
                        jr nz,IDBM1                     ;

                        add hl,de                       ; (Feet)

IDBM1                   add hl,de                       ;

                        jr IMND_NotFeet                 ; Use the code below but with this position

; See if the man is standing near a doorway

IsManNearDoor           ld hl,(pManLookingSquare)       ; Get the square the man is facing
                        ld a,(ManAngle)                 ;

                        ; Now, get the direction we look in for the door URDL -> 0/2 -> 1, 1/3 -> 2

IMND_NotFeet            and 1                           ; Are we looking up or down?
                        jr z IMND_HorizDoor             ; Yes, check a horizontal door

                        ; We're looking for a possible vertical doorway

                        ld de,-128                      ;

                        ; Now see if we can find the lintel

IMND_VertDoor           ld b,6                          ; We will look at up to 6 places for a TOP lintel

IMND_LU_Lp              ld a,(hl)                       ; Get it
                        cp cLintelTOP                   ; Is it?
                        jr z IMND_VD_GotLintel          ; Yes, skip

                        add hl,de                       ; Skip
                        djnz IMND_LU_Lp                 ; Loop

                        ; Not a doorway

                        ret                             ; NZ

                ; Found the vertical lintel, but is the door open/closed?

IMND_VD_GotLintel       ld de,128                       ; Move to doorway
                        add hl,de                       ;
                        ld a,(hl)                       ; Get it
                        cp " "                          ; Might be open
                        jr z IMND_VD_CheckOpen          ; Check
                        cp cDoorVert                    ; Is it closed?
                        ret nz                          ; No, skip

                        ; Since we have a door character it must be a valid closed door. Ret Z

                        ld c,a                          ; Return the door character

                        ret                             ; Found

                ; We're looking at a possible open door, for this to be true there must be 3 more spaces

IMND_VD_CheckOpen       ld b,3                          ; We'll look for this many

                        push hl                         ; Save

IMND_VD_CO_Lp           add hl,de                       ; Move
                        ld a,(hl)                       ; Get it
                        cp " "                          ; Still space?
                        jr nz IMND_CO_Fail              ; No, open

                        djnz IMND_VD_CO_Lp              ; Loop

                        ; Now, we must also have a bottom lintel

                        add hl,de                       ; Move
                        ld a,(hl)                       ; Get it
                        cp cLintelBOT                   ; Bottom lintel?
                        jr nz IMND_CO_Fail              ; No, open

                        ; Yes, this door is open

                        pop hl                          ; Restore

                        ld c," "                        ; Return the door character

                        xor a                           ; Z
                        ret                             ; Done

                ; Now see if we can find the lintel

IMND_HorizDoor          ld b,6                          ; We will look at up to 6 places for a LHS lintel

IMND_LL_Lp              ld a,(hl)                       ; Get it
                        cp cLintelLHS                   ; Is it?
                        jr z IMND_HD_GotLintel          ; Yes, skip

                        dec hl                          ; Skip
                        djnz IMND_LL_Lp                 ; Loop

                        ; Not a doorway

                        ret                             ; NZ

                ; Found the horizontal lintel, but is the door open/closed?

IMND_HD_GotLintel       inc hl                          ; Move to doorway
                        ld a,(hl)                       ; Get it
                        cp " "                          ; Might be open
                        jr z IMND_HD_CheckOpen          ; Check
                        cp cDoorHori                    ; Is it closed?
                        ret nz                          ; No, skip

                        ; Since we have a door character it must be a valid closed door. Ret Z

                        ld c,a                          ; Return the door character
                        ld de,1                         ; Return the direction

                        ret                             ; Found

                ; We're looking at a possible open door, for this to be true there must be 3 more spaces

IMND_HD_CheckOpen       ld b,3                          ; We'll look for this many

                        push hl                         ; Save

IMND_HD_CO_Lp           inc hl                          ; Move
                        ld a,(hl)                       ; Get it
                        cp " "                          ; Still space?
                        jr nz IMND_CO_Fail              ; No, open

                        djnz IMND_HD_CO_Lp              ; Loop

                        ; Now, we must also have a RHSlintel

                        inc hl                          ; Move
                        ld a,(hl)                       ; Get it
                        cp cLintelRHS                   ; RHS lintel?
                        jr nz IMND_CO_Fail              ; No, open

                        ; Yes, this door is open

                        pop hl                          ; Restore

                        ld c," "                        ; Return the door character
                        ld de,1                         ; Return the direction

                        xor a                           ; Z
                        ret                             ; Done

                ; Not a valid door

IMND_CO_Fail            pop hl                          ; Restore

                        ; Fall into...

Ret_NZ                  xor a                           ; Signal not found
                        inc a                           ;
                        ret                             ;

; Now, we check to see if there is anything to keep in the man's way...

AnythingToKeep          ld hl,(pManLookingSquare)       ; Get the square the man is facing

                        ; Now, see if this is something we can keep...

                        call ATK_Check                  ; Anything we should keep?
                        ret nz                          ; Yes, and we did so exit

                        ; We might want to look down if facing sideways

                        ld a,(ManAngle)                 ;
                        rra                             ;
                        jr nc ATK_Didnt                 ;

                        ld de,128                       ;
                        add hl,de                       ;

                        ; Look to see if this is something we should automatically keep

ATK_Check               ld c,(hl)                       ;
                        ld a,c                          ;
                        and #F0                         ;
                        cp #B0                          ;
                        jr z,ATKTreasure                ;

                        cp #C0                          ;
                        jr z,ATKMagic                   ;

                        ld a,c                          ;
;                        and #FC                         ;
;                        cp #D8                          ;
;                        jr z,ATKArrow                   ;

                        and #F8                         ;
                        cp #88                          ;
                        jp z ATKRing                    ;

ATK_Didnt               xor a                           ; Didn't keep anything
                        ret                             ;

                ; Return NZ

ATK_Kept                xor a                           ; Clear the flag
                        ld (bDoorOpenKeepReq),a         ;

                        inc a                           ;
                        ret                             ;

ATKTreasure             ld a,(TreasureCount)            ;
                        cp MaxTreasure                  ;
                        jr z ATK_Didnt                  ;

                        inc a                           ;
                        ld (TreasureCount),a            ;

                        ld e,a                          ;
                        ld d,0                          ;
                        ld ix,SwagBag-1                 ;
                        add ix,de                       ;
                        ld (ix),c                       ;

                        ld a,#20                        ;
                        ld (hl),a                       ;

                        mSCV_Out()                      ;

                        jp ATK_Kept                     ; Clear it

                ; Can we pick any magic up?

ATKMagic                ld a,(CurrentMagic)             ; Are we replete?
                        cp MaxMagic                     ;
                        jr nz ATKM_Inc                  ; No, inc it

                        ; We're full of magic. Do we have wounds?

                        ld a,(Wounds)                   ; Are we wounded?
                        or a                            ;
                        ret z                           ; We're not, leave this alone

                        call TryToHeal                  ; Try healing. This has to work and reduce the magic

                        ; Increment our magic

ATKM_Inc                ld a,(CurrentMagic)             ; Add one
                        inc a                           ;
                        ld (CurrentMagic),a             ;

                        ; Decrement the magic

                        ld a,(hl)                       ;
                        cp #C0                          ;
                        jr z ATKM_Clear                 ;

                        dec a                           ;
                        ld (hl),a                       ;

ATKM_Replace            ld (hl),a                       ;

                        mSCV_Out()                      ;

                        jp ATK_Kept                     ; Clear it

ATKM_Clear              ld a," "                        ;
                        jp ATKM_Replace                 ;

; We've picked up a ring

ATKRing                 ld a,MaxMagic                   ; Top up the magic
                        ld (CurrentMagic),a             ;

                        ld a,0                          ; Heal all wounds
                        ld (Wounds),a                   ;

                        ld a,c                          ; Get the ring number
                        and 7                           ;
                        ld e,a                          ;
                        ld d,0                          ;

                        ; Find the right ring

                        ld ix,RingTab                   ;

                        loop lRingTable                 ; * length
                          add ix,de                     ;
                          lend                          ;

                        ld (ix+drt_Floor),#FF           ; Flag that we've picked it up

                        ld a," "                        ; Clear it
                        ld (hl),a                       ;

                        mSCV_Out()                      ;

                        ld a,c                          ;
                        cp #88                          ; Is this the key?
                        jr nz ATKRingB                  ; No, skip

                        ; Flag that we've picked up the key

                        ld a,8                          ;
                        ld (cFloor),a                   ;

                        ; Inc the ring count

ATKRingB                ld a,(nRings)                   ;
                        inc a                           ;
                        ld (nRings),a                   ;

                        jp ATK_Kept                     ; Clear it

; Now. have we got the right number of rings?


OpenBasement            ld a,(nRings)                   ; Got them all?
                        cp 7                            ;
                        ret nz                          ; Nope

                        ld a,(cFloor)                   ; On floor zero?
                        or a                            ;
                        ret nz                          ;

                        ; Yes, so open the bottom floor's door...

                        ld hl,TopLeftSanc+13311         ; Open the inner one for a change
                        ld de,-128
                        ld (hl),cLintelBOT
                        add hl,de
                        ld (hl),#90
                        add hl,de
                        ld (hl),#90
                        add hl,de
                        ld (hl),#90
                        add hl,de
                        ld (hl),#90
                        add hl,de
                        ld (hl),cLintelTOP

                        ret

OB_OpenDoor             ld a,(hl)                       ;
                        ld (ix),a                       ;

                        add hl,de                       ;
                        add ix,de                       ;

                        djnz OB_OpenDoor                ;

                        ret                             ; Done

        ; These are preserved for use by the monsters

        ; Move along a door looking for the bottom/rhs

MMDoorO2                add hl,de                       ;
                        ld a,(hl)                       ;
                        and #FE                         ;
                        cp #DC                          ;
                        jr z,MMDoorO2                   ;

                        ld a," "                        ;

MMDoorC4                push hl                         ; Negate DE
                        ld hl,0                         ;
                        or a                            ;
                        sbc hl,de                       ;
                        ex de,hl                        ;
                        pop hl                          ;

                        ld b,4                          ; Length

MMDoorC5                add hl,de                       ; Move that way
                        ld (hl),a                       ; Store this character

                        push hl                         ; Show the character if it's visible
                        mSCV_Out()                      ;
                        pop hl                          ;

                        djnz MMDoorC5                   ; Loop

                        ret                             ;

; Are we trying to drop something? If we're moving we drop behind, else we drop in front.

MMDrop                  ld a,(TreasureCount)            ;
                        or a                            ;
                        ret z                           ;

                        ld a,(bManMoving)               ; Are we moving?
                        or a                            ;
                        jr z MMDropAhead                ; No, skip

                        ; We're moving, try dropping behind

                        ld a,(KeyDrop)                  ;
                        or a                            ;
                        ret z                           ;

                        ; Clear the persistent flag

                        xor a                           ; We're handling it here
                        ld (KeyDropP),a                 ;

                        ; Right, find the square

                        ld hl,(pMan)                    ; We want the square BEHIND the man
                        ld a,(ManAngle)                 ;
                        xor 2                           ;
                        jr MMDropAngle                  ;

                        ; We're not moving, so try dropping in front

MMDropAhead             ld hl,KeyDropP                  ;
                        call ReadAKey                   ;
                        ret z                           ;

                        ld hl,(pMan)                    ;
                        ld a,(ManAngle)                 ;

MMDropAngle             call CDirect                    ;
                        cp 2                            ;
                        jr nz,MMDrop1                   ;

                        add hl,de                       ;

MMDrop1                 add hl,de                       ;
                        ld a,(hl)                       ;
                        cp " "                          ;
                        jr z,MMDrop2                    ;

                        ld a,(ManAngle)                 ;
                        rra                             ;
                        ret nc                          ;

                        ld de,128                       ;
                        add hl,de                       ;
                        ld a,(hl)                       ;
                        cp " "                          ;
                        ret nz                          ;

MMDrop2                 ld a,(TreasureCount)            ;
                        ld c,a                          ;
                        ld b,0                          ;
                        ld ix,SwagBag-1                 ;
                        add ix,bc                       ;

                        ld a,(ix)                       ;
                        ld (hl),a                       ;

                        mSCV_Out()                      ;

                        dec c                           ;
                        ld a,c                          ;

                        ld (TreasureCount),a            ;
                        ret                             ;

; Drive the sword

MSword                  ld a,(SwdPhase)                 ; Are we swinging it?
                        or a                            ;
                        jr nz,MSDoing                   ; Yes, calc next position

                        ; Can we?

                        ld hl,(pMan)                    ; Check for force-field
                        ld a,(hl)                       ;
                        cp #90                          ;
                        jr z MSword_Nope                ; Yes, so don't allow the sword

                        ; No, is the "S" key pressed?

                        ld hl,KeySwordP                 ; "S" pressed?
                        call ReadAKey                   ;
                        jr z MSword_Auto                ; No, skip

                        xor a                           ; Clear it
                        ld (KeySwordP),a                ;

                        ; Setup the swing

MSA_Start               ld a,9+1                        ; 9 phases
                        ld (SwdPhase),a                 ;

                        jp MSDoing                      ; Drive it

                ; We can't swing the sword so clear any request that's pending

MSword_Nope             xor a                           ; Clear it
                        ld (KeySwordP),a                ;
                        ret                             ; Done

        ; Is there a monster in the sword range?

MSword_Auto             ld hl,(pMan)                    ; Our head's position
                        ld a,(ManAngle)                 ; Which way are we facing?

                        cp 3                            ;
                        jr z MSA_Left                   ;

                        cp 1                            ;
                        jr z MSA_Right                  ;

                        cp 0                            ;
                        jr z MSA_Up                     ;

                        ; Assume down

                        inc h                           ; + 128 * 2
                        dec hl                          ; Left

MSA_LR3                 call MSA_IsMonster              ; Is this a monster?
                        jr z MSA_Start                  ; Yes

                        inc hl                          ; Next char

                        call MSA_IsMonster              ; Is this a monster?
                        jr z MSA_Start                  ; Yes

                        inc hl                          ; Next char

                        call MSA_IsMonster              ; Is this a monster?
                        jr z MSA_Start                  ; Yes

                        ret                             ; Done

        ; Is this a monster?

MSA_IsMonster           ld a,(hl)                       ; Get the char
                        and #F8                         ; Clip out irrelevent
                        cp #D0                          ; Monster=ZF
                        ret                             ;

        ; Try up

MSA_Up                  ld de,-129                      ; Up and left
                        add hl,de                       ;
                        jp MSA_LR3                      ; As above

        ; Try right

MSA_Right               inc hl                          ; Look right

MSA_UD2                 call MSA_IsMonster              ; Is this a monster?
                        jr z MSA_Start                  ; Yes

                        ld de,128                       ; Down
                        add hl,de                       ;

                        call MSA_IsMonster              ; Is this a monster?
                        jr z MSA_Start                  ; Yes

                        ret                             ; Done

        ; Try left

MSA_Left                dec hl                          ; Look left
                        jp MSA_UD2                      ; As above

        ; Swing the sword. This changes according to the man's direction

MSDoing                 ld hl,(SwdPos)                  ; Undraw the sword

                        ld a,l                          ; Is it valid?
                        or a                            ;
                        jr z MSNewSword                 ; No, skip (with A=0)

                        ld a,(hl)                       ;
                        mSCV_Out()                      ;

                        ; Time to give up on the sword?

MSNewSword              ld a,(SwdPhase)                 ; Get the phase
                        or a                            ;
                        ret z                           ; 0=don't

                        dec a                           ;
                        ld (SwdPhase),a                 ;
                        or a                            ;
                        ret z                           ;

                        ; Calc the new sword position

                        ld a,(ManAngle)                 ; Which way are we facing?
                        call CDirect                    ;

                        ld hl,(pMan)                    ; Add the offset
                        add hl,de                       ;

                        cp 2                            ; If it's down we add it again
                        jr nz,MSword1                   ; to skip the feet...

                        add hl,de                       ; It is...

MSword1                 ld (SwdPos),hl                  ;

                        ; Now, calc the offset and sword character

                        ld iy,SwdUpTab                  ;
                        ld a,(ManAngle)                 ;
                        rlca                            ; * 32
                        rlca                            ;
                        rlca                            ;
                        rlca                            ;
                        rlca                            ;
                        ld d,0                          ;
                        ld e,a                          ;
                        add iy,de                       ;
                        ld a,(SwdPhase)                 ;
                        ld b,a                          ;
                        ld a,9                          ;
                        sub b                           ;
                        ld b,a                          ;
                        add a,a                         ;
                        add a,b                         ;
                        ld e,a                          ;
                        add iy,de                       ;

                        ld e,(iy+dst_Off_L)             ;
                        ld d,(iy+dst_Off_H)             ;
                        ld hl,(SwdPos)                  ;
                        add hl,de                       ;
                        ld (SwdPos),hl                  ;

                        ld a,(hl)                       ;

                        cp #FD                          ; Stairs
                        ret z                           ; Yes, ignore

                        and #FE                         ;
                        cp #DC                          ;
                        ret z                           ;

                        and #F8                         ;
                        cp #D0                          ;
                        jr z,MSHitMon                   ;

                        and #F0                         ;
                        cp #90                          ;
                        ret z                           ;

                        ld a,(iy+dst_Char)              ;
                        mSCV_Out()                      ;

MSSkip                  ret                             ;

MSStop                  xor a                           ;
                        ld (SwdPhase),a                 ;
                        ret                             ;

MSHitMon                ld a,SwordDamageToMon           ;
                        ld b,#DE                        ;
                        call HitMonster                 ;

                        ret                             ;

; Slow healing process

SlowlyHeal              ld a,(Wounds)                   ; Do we have wounds?
                        or a                            ;
                        ret z                           ; Nope

                        ld b,a                          ; Save

                        ; Yes.

                        ld a,(CurrentMagic)             ; Do we have enough magic?
                        cp 16                           ;
                        ret c                           ; Nope

                        ; Dec zem both

                        dec a                           ;
                        ld (CurrentMagic),a             ;

                        ld a,b                          ;
                        dec a                           ;
                        ld (Wounds),a                   ;

                        ret                             ; Done

; See if the man can move here and return CF if not.
; If we've hit something try picking it up

TestManMove             push hl                         ; Store putative new position

                        ; Can we turn this into a gate?

                        ld a,(bJokeEnable)              ;
                        ld e,a                          ;

                        ld a,(KeyPortalP)               ; Portal pressed
                        and e                           ;
                        call nz ManMakePortal           ; If we can, do

                        ld a,(hl)                       ; Is the head blocked?
                        cp cLintelLHS                   ; By a LHS lintel?
                        call z SetJinkRightIfUp         ; Yes
                        cp cLintelRHS                   ; By a RHS lintel?
                        call z SetJinkLeftIfUp          ; Yes
                        cp cLintelLHS                   ; By a LHS lintel?
                        call z SetJinkDownIfLeft        ; Yes
                        cp cLintelRHS                   ; By a RHS lintel?
                        call z SetJinkDownIfRight       ; Yes
                        cp cLintelTOP                   ; By a TOP lintel?
                        call z SetJinkDownIfLeft        ; Yes
                        cp cLintelTOP                   ; By a TOP lintel?
                        call z SetJinkDownIfRight       ; Yes

                        call ManValid                   ;
                        jp nz TMM_Fail                  ; Yes, failed

                        ld de,128                       ; Look down
                        add hl,de                       ;

                        ld a,(hl)                       ; Are the feet blocked?
                        cp cLintelLHS                   ; By a LHS lintel?
                        call z SetJinkRightIfDown       ; Yes
                        cp cLintelRHS                   ; By a RHS lintel?
                        call z SetJinkLeftIfDown        ; Yes
                        cp cLintelLHS                   ; By a LHS lintel?
                        call z SetJinkUpIfLeft          ; Yes
                        cp cLintelRHS                   ; By a RHS lintel?
                        call z SetJinkUpIfRight         ; Yes
                        cp cLintelBOT                   ; By a LHS lintel?
                        call z SetJinkUpIfLeft          ; Yes
                        cp cLintelBOT                   ; By a RHS lintel?
                        call z SetJinkUpIfRight         ; Yes

                        call ManValid                   ;
                        jp nz TMM_Fail                  ; Yes, failed

                        pop hl                          ; Restore

                        or a                            ; We could move
                        ret                             ;

                ; Failed

TMM_Fail                pop hl                          ; Restore
                        scf                             ; Failed
                        ret                             ;

; Set the jink flags

SetJinkUpIfRight        ld a,(ManAngle)                 ; Right?
                        cp 1                            ;
JinkUp                  jr nz JinkX                     ; No

                        ld a,4                          ;
                        ld (JinkDirnUD),a               ;

                        jr JinkX                        ; As below

; Set the jink flags

SetJinkUpIfLeft         ld a,(ManAngle)                 ; Left?
                        cp 3                            ;
                        jr JinkUp                       ;

; Set the jink flags

SetJinkDownIfRight      ld a,(ManAngle)                 ; Right?
                        cp 1                            ;
JinkDown                jr nz JinkX                     ; No

                        ld a,2                          ;
                        ld (JinkDirnUD),a                 ;

                        jr JinkX                        ; As below

; Set the jink flags

SetJinkDownIfLeft       ld a,(ManAngle)                 ; Left?
                        cp 3                            ;
                        jr JinkDown                     ;


; Set the jink flags

SetJinkLeftIfUp         ld a,(ManAngle)                 ; Up?
                        cp 0                            ;
JinkLeft                jr nz JinkX                     ; No

                        ld a,3                          ;
                        ld (JinkDirn),a                 ;

                        jr JinkX                        ; As below

; Set the jink flags

SetJinkLeftIfDown       ld a,(ManAngle)                 ; Down?
                        cp 2                            ;
                        jr JinkLeft                     ;

; Set the jink flags

SetJinkRightIfUp        ld a,(ManAngle)                 ; Up?
                        cp 0                            ;
JinkRight               jr nz JinkX                     ; No

                        ld a,1                          ;
                        ld (JinkDirn),a                 ;

JinkX                   ld a,(hl)                       ;
                        ret                             ;

; Set the jink flags

SetJinkRightIfDown      ld a,(ManAngle)                 ; Down?
                        cp 2                            ;
                        jr JinkRight                    ;

; Is this a character the man can move onto? z = Valid

ManValid                cp " "                          ; Space is OK
                        ret z                           ;

                        cp deadMon_Steaming             ; Steaming?
                        jr c MV_1                       ; No, skip
                        cp deadMon_Steaming+4           ; Steaming?
                        jr c ManHitThing                ; Yes

MV_1                    cp deadMon_Steamed              ; Dead thing?
                        jr z ManHitThing                ;
                        cp deadMon_Sword                ; Dead thing?
                        jr z ManHitThing                ;
                        cp deadMon_Arrow                ; Dead thing?
                        jr z ManHitThing                ;

                        cp #90                          ; Force-field?
                        jp z OpenPlan                   ; Yes, see how we should treat it...

                        and #FE                         ; Landing
                        cp #FC                          ;
                        ret z                           ;

                        and #F8                         ; The different Landings
                        cp #80                          ;
                        ret                             ;

                ; We've hit a dead thing. Can we move it?

ManHitThing             call FindThing_HL               ; Find the thing we've hit and shove it

                        ; Now, can we move it?

                        push hl                         ; Save the pMan

                        ld a,(ManAngle)                 ; Which way are we facing?
                        call CDirect                    ;

                        add hl,de                       ;

                        ld a,(hl)                       ; Is this clear?
                        cp " "                          ;
                        jr nz MHT_Done                  ; No, don't move it

                        ; Yes, we can move to this point.

                        pop hl                          ; Restore the address
                        push hl                         ;

                        ld (hl)," "                     ;

                        call SCV                        ; Remove it from the screen
                        call nc OutIt_NR_Blank          ;

                        pop hl                          ; Restore the address
                        push hl                         ;
                        add hl,de                       ;

                        ld (iy+dm_pMaze_L),l            ;
                        ld (iy+dm_pMaze_H),h            ;

                        ld a,(iy+dm_Char)               ; Draw it in the new pos
                        ld (hl),a                       ;

                        call SCV                        ; Remove it from the screen
                        call nc OutIt_NR                ;

                        ; Return NZ

MHT_Done                pop hl                          ; Restore
                        xor a                           ; NZ
                        inc a                           ;

                        ret                             ;

; Find the thing at HL

FindThing_HL            ld iy,MonsterList               ;
                        ld de,lMonst                    ;

                        ld b,nMonst-1                   ;

FT_Lp                   ld a,(iy+dm_pMaze_L)            ;
                        cp l                            ;
                        jr nz FT_Nope                   ;

                        ld a,(iy+dm_pMaze_H)            ;
                        cp h                            ;
                        ret z                           ;

FT_Nope                 add iy,de                       ;
                        djnz FT_Lp                      ;

                        ret                             ;

; Add an angle to HL

AddAngle_A_HL           ld de,128                       ;
                        or a                            ;
                        sbc hl,de                       ;

                        cp 0                            ; 0 -> UP
                        ret z                           ;

                        add hl,de                       ; Restore
                        inc hl                          ; Assume RIGHT

                        cp 1                            ; 1 -> RIGHT
                        ret z                           ;

                        dec hl                          ; Restore
                        add hl,de                       ; Assume DOWN

                        cp 2                            ; 2 -> DOWN
                        ret z                           ;

                        or a                            ; Restore
                        sbc hl,de                       ;
                        dec hl                          ; Must be LEFT

                        ret                             ; Done

ManSetOpenReq           push af                         ;

                        ld a,1                          ; Try to open something
                        ld (bDoorOpenKeepReq),a         ;

                        pop af                          ;
                        ret                             ;

; Show him dead

MDead                   inc a                           ; Inc the timer
                        jp z LeaveGame                  ;

                        ld (GameBType),a                ;

                        ; Show the dead man characters while we time-out

                        ld a,$F3                        ;

                        ld hl,(ManOPosXY)               ; Position
                        call OutIt                      ; Write the man to the screen
                        inc l                           ;
                        inc a                           ;
                        jp OutIt                        ;

; Move the man

MoveMan                 ld a,(MManDelay)                ; Time to move?
                        or a                            ;
                        ret p                           ;

                        ; Now, if this was our first move we have a longer delay

                        ld a,(bManMoving)               ; Were we moving?
                        or a                            ;

                        ld a,ManSpeed                   ; Setup delay
                        jr nz MM_GotSpeed               ;

                        ld a,ManDelSlow                 ; Setup slower delay

MM_GotSpeed             ld (MManDelay),a                ;

                        ld a,(GameBType)                ; Are we dead?
                        or a                            ;
                        jp m MDead                      ; Yes, show him dead

                        call SlowlyHeal                 ; Heal some wounds

                        call MOpenDoor                  ; Open or keep anything?

                        call MCloseDoor                 ; Close a door?

                        call MMDrop                     ; Drop anything?

                        ; Don't allow attacks while in the doorway of the stairs

                        ld hl,(pMan)                    ; Check for force-field
                        ld a,(hl)                       ;
                        cp #90                          ;
                        jr z MMan5                      ; Skip if in doorway

                        call MFireArrow                 ; Fire an arrow?

                        call FireBall                   ; Fire a fireball?

                        call Lightning                  ; Fire lightning?

                        ; Move the man

MMan5                   xor a                           ; Clear the weapon key flags
                        ld (KeyArrowP),a                ;
                        ld (KeyFireP),a                 ;
                        ld (KeyLightP),a                ;
                        ld (bManMoving),a               ;

                        ; See if we can move up/down. Do so if we can.

                        ld a,(ManAngle)                 ; Save the posn.
                        ld (OldManAngle),a              ;

                        ld hl,(pMan)                    ;
                        ld (OldpMan),hl                 ;

                        ;

                        ld hl,(pMan)                    ; Get the current position
                        ld (nMan),hl                    ; Presume OK

                        ; If he's shown, remove him

                        ld a,(UnderMan)                 ; Anything under the man?
                        or a                            ;
                        jr nz MoveMANCleared            ; Yes, skip

                        ; Clear the man from the maze

                        ld (hl)," "                     ; Clear under the man
                        ld de,128                       ;
                        add hl,de                       ;
                        ld (hl)," "                     ;
                        sbc hl,de                       ; Move back

                        ; We're clear

MoveMANCleared          call MMoveUD                    ; Trying to move U/D?
                        jr nc MMoveNotUD_PossJink       ; No, skip

MMoveNotUD_Jink         and $3                          ; Lose the jink bit
                        ld (ManAngle),a                 ; Save the angle

                        ; Is this a valid position?

                        call AddAngle_A_HL              ; Add it

                        call TestManMove                ; Could we move here?
                        call c ManSetOpenReq            ; No, try to open/pick up
                        jr c MMoveNotUD                 ; No, skip

                        ; Yes, we could move to here

                        ld (nMan),hl                    ; Save the position
                        jr MMoveNotUD                   ;

MMoveNotUD_PossJink     ld a,(JinkDirnUD)               ; Got one?
                        or a                            ;
                        jr nz MMoveNotUD_Jink           ; Yes, jink

                        ; Check L/R

MMoveNotUD              xor a                           ; Clear the jink flags
                        ld (JinkDirnUD),a               ;

                        ld hl,(nMan)                    ; Restore if required

                        call MMoveLR                    ; Trying to move L/R?
                        jr nc MMoveNotLR_PossJink       ; No, jink?

                        ld (ManAngle),a                 ; Save the angle

                        ; Is this a valid position?

MMoveNotLR_Jink         call AddAngle_A_HL              ; Add it

                        call TestManMove                ; Could we move here?
                        call c ManSetOpenReq            ; No, try to open/pick up
                        jr c MMoveControlsDone          ; No, skip

                        ; Yes, we could move to here

                        ld (nMan),hl                    ; Save the position
                        jr MMoveControlsDone            ;

MMoveNotLR_PossJink     ld a,(JinkDirn)                 ; Got one?
                        or a                            ;
                        jr nz MMoveNotLR_Jink           ; Yes, jink

MMoveControlsDone       xor a                           ; Clear the jink flags
                        ld (JinkDirn),a                 ;

                        ; Undraw only if position or angle changed

                        ld a,(OldManAngle)              ; Has the angle changed?
                        ld b,a                          ;
                        ld a,(ManAngle)                 ;
                        cp b                            ;
                        jr nz MManAngleChanged          ;

                        ; Position?

                        ld hl,(nMan)                    ;
                        ld de,(OldpMan)                 ;
                        or a                            ;
                        sbc hl,de                       ;
                        jr nz MManChanged               ; Yes

                        jp MManNotMoved                 ;

MManAngleChanged        ld hl,(pMan)                    ; Position hasn't
                        ld (nMan),hl                    ;
                        jr MManNotMoved                 ;

                ; Undraw

MManChanged             ld a,1                          ; We're moving
                        ld (bManMoving),a               ;

                        ld hl,(OldpMan)                 ; Pointer to maze
                        call SCV                        ; Convert to screen coordinates
                        ld (ManOPosXY),hl               ; Store screen coordinates

                        ld ix,(pMan)                    ;
                        ld de,128                       ;

                        ld a,(ix)                       ; Show the chars at the curr position
                        call OutIt                      ; This removes him from the screen
                        inc h                           ;
                        add ix,de                       ;
                        ld a,(ix)                       ;
                        call OutIt                      ;

                        ; Move to here

MManNotMoved            ld hl,(nMan)                    ; Store putative new position

                        ld a,0                          ; We're not on a new floor
                        ld (NFloorFl),a                 ;

                        ld de,128                       ; Look down
                        add hl,de                       ;

                        ; We can move to here, but check if we're on a landing
                        ; This is the foot position

                        ld a,(hl)                       ; Could we be on a landing?
                        cp #80                          ;
                        call nc MManRE1                 ; Perhaps, check...

                        xor " "                         ; Set this flag if there's something
                        ld (UnderMan),a                 ; other than a space under the man

MManNF_Done             ld hl,(nMan)                    ; Move to here...
                        ld (pMan),hl                    ;

                        ; Calc the screen co-ordinates

                        call SCV                        ; Convert head to screen coordinates
                        jp c MManNewFrame               ; Skip if we've moved off-screen

                        ld a,h                          ; Y
                        cp YW+2                         ; At bottom
                        jp z MManNewFrame               ;

                        ld (ManOPosXY),hl               ; Save them

                        ; We're visible, show it here

                        call PM                         ; Show the man

                        ; See if we're on a landing

                        ld a,(NFloorFl)                 ; On a landing?
                        or a                            ;
                        call nz NFloor                  ; Yes, see if the floor has changed

MManMoved               jp MSword                       ; Drive the sword

; See if we can make a hole in a wall

ManMakePortal           ld a,l                          ; Outside wall?
                        and $7F                         ;
                        ret z                           ; Nope LHS
                        cp $7F                          ;
                        ret z                           ; Nope RHS

                        ld a,(hl)                       ;
                        cp #9C                          ;
                        ret nz                          ;

                        ld de,128                       ; Look down
                        add hl,de                       ;

                        ld a,(hl)                       ;
                        cp #9C                          ;
                        jr z CanMakePortal              ;

                        or a                            ;
                        sbc hl,de                       ;
                        ret                             ;

                ; We can do it here, so do it...

CanMakePortal           ld (hl),$90                     ; Do so
                        or a                            ;
                        sbc hl,de                       ;
                        ld (hl),$90                     ;

                        xor a                           ; Clear the flag
                        ld (KeyPortalP),a               ;

                        ret                             ; Done

; On a landing?

MManRE1                 cp #88                          ; Landing char?
                        ret nc                          ; No, exit

                        ; We're on a landing. Calc the floor...

                        and #7                          ; Calc the floor, 1..8
                        inc a                           ;
                        ld (NFloorFl),a                 ;

                        ld a,(hl)                       ; Restore the char
                        ret                             ; Done

; Update the map_nextpos and draw the man in the maze and on the screen

PM                      ld a,(GameBType)                ; Are we dead
                        or a                            ;
                        ret m                           ; Yes, exit

                        ld hl,(pMan)                    ; Get the square the man is facing
                        ld a,(ManAngle)                 ;
                        call CDirect                    ;

                        add hl,de                       ;
                        cp 2                            ;
                        jr nz,PM_NotFeet                ;

                        add hl,de                       ;

PM_NotFeet              ld (pManLookingSquare),hl       ; Save a pointer to it

                        add a,a                         ; Calc the right char for this angle
                        add a,#A8                       ;
                        ld b,a                          ;

                        ld hl,(pMan)                    ; Get the man's position

                        ld a,(hl)                       ; Check the char under the head
                        cp #80                          ;
                        ld a,b                          ;
                        jr nc PM1                       ;

                        ; Can overwrite this character

                        ld (hl),a                       ; Store the head in the maze
                        ld de,128                       ; Move down
                        add hl,de                       ;
                        inc a                           ;
                        ld (hl),a                       ; Store feet
                        dec a                           ;

                        ; Show the man on the screen

PM1                     ld hl,(ManOPosXY)               ; Position
                        call OutIt                      ; Write the man to the screen
                        inc h                           ;
                        inc a                           ;
                        jp OutIt                        ;

                ; Remove from the screen

UndrawMan               ld hl,(ManOPosXY)               ; Position

                        call OutIt_Blank                ; Write the man to the screen
                        inc h                           ;
                        jp OutIt_Blank                  ;

; Draw the man on the display only

PMD                     ld a,(ManAngle)                 ;
                        add a,a                         ;
                        add a,#A8                       ;
                        jr PM1                          ;

; We need to shift the viewport

MManNewFrame            ld hl,(pMan)                    ; Get the screen posn
                        ld a,l                          ; Get X/Y
                        and #7F                         ;
                        add hl,hl                       ; H:=Y+Offset BigMaze starts at C000 so offset = 80
                        ld e,a                          ;

                        ld a,h                          ;
                        and $7F                         ; Lose the offset
                        ld d,a                          ;

                        ; D = ScrY, E = ScrX

                        ld hl,(pFrameX)                 ;
                        ld a,e                          ;
                        sub l                           ; a = offset to man on screen.
                        jp m MMNF_ShiftLeft             ;

                        cp XW+4                         ;
                        jr nc MMNF_ShiftRight           ;

                        ; Now, check Y

                        ld a,d                          ;
                        sub h                           ; a = offset to man on screen.
                        jp m MMNF_ShiftUp               ;

                        cp YW+2                         ;
                        jr nc MMNF_ShiftDown            ;

                        jp MManNF_Done                  ; Done

                ; Move window Up

MMNF_ShiftUp            ld hl,(pFrameX)
                        ld a,h
                        sub YW
                        ld h,a
                        jr MMNF_Done

                ; Move down

MMNF_ShiftDown          ld hl,(pFrameX)
                        ld a,h
                        add a,YW
                        ld h,a
                        jr MMNF_Done

                ; Move left

MMNF_ShiftLeft          ld hl,(pFrameX)
                        ld a,l
                        sub XW
                        ld l,a
                        jr MMNF_Done

                ; Move right

MMNF_ShiftRight         ld hl,(pFrameX)
                        ld a,l
                        add a,XW
                        ld l,a

MMNF_Done               ld (pFrameX),hl                 ;
                        call NewScreen                  ;

                        jp MManNF_Done                  ;


            ld a,(ManAngle)                 ;
                        ld hl,(pFrameX)                 ;
                        cp 0                            ;
                        jr nz Scroll1                   ;
                        ld a,h                          ;
                        sub YW                          ;
                        ld h,a                          ;
                        jr Scroll4                      ;

Scroll1                 cp 1                            ;
                        jr nz Scroll2                   ;
                        ld a,l                          ;
                        add a,XW                        ;
                        ld l,a                          ;
                        jr Scroll4                      ;

Scroll2                 cp 2                            ;
                        jr nz Scroll3                   ;
                        ld a,h                          ;
                        add a,YW                        ;
                        ld h,a                          ;
                        jr Scroll4                      ;

Scroll3                 ld a,l                          ;
                        sub XW                          ;
                        ld l,a                          ;

Scroll4                 ld (pFrameX),hl                 ;
                        call NewScreen                  ;
                        ld hl,(pMan)                    ;
                        call SCV                        ;
                        jp c FuckedUp                   ;
                        ld (ManOPosXY),hl               ;
                        jp PM                           ;

FuckedUp                ld a,2                          ; Red border
                        out ($FE),a                     ;
                        ret                             ; ???

                ; Can't move, redraw him and exit

MMoveBlocked            and $F0                         ; Is this a wall?
                        cp $90                          ;
                        jr z MMDontPick                 ; Yes, skip

                        ld a,2                          ; Set the keep flag (briefly)
                        ld (bDoorOpenKeepReq),a         ;

MMDontPick              call PM                         ;

                        jp MManMoved                    ;

; Justify our position on screen?

JustifyScreen           ld hl,KeyspP                    ;
                        call ReadAKey                   ;
                        ret z                           ;

                        ; Yes, justify it...

JustifyT                ld a,(ManAngle)                 ; Which way are we facing?
                        ld h,-8                         ; Assume right-facing justify

                        cp 1                            ; Right?
                        jr z JustGotXDisp               ; Yep, skip

                        ld h,-16                        ; Assume left-facing justify

                        cp 3                            ; Left?
                        jr z JustGotXDisp               ;

                        ld a,(JustXDisp)                ; Get the last offset
                        ld h,a                          ;

JustGotXDisp            ld a,h                          ; Store it
                        ld (JustXDisp),a                ;

                        ; Now justify us...

                        ld hl,(pMan)                    ;
                        call ConvBM_To_XY_HL            ;

                        ld d,h                          ;
                        ld h,l                          ;
                        dec h                           ;
                        call Bound7                     ;

                        ; Sub either 8 or 16

                        ld l,a                          ;
                        ld a,(JustXDisp)                ;
                        add a,l                         ;
                        ld l,a                          ;

                        ld h,d                          ;
                        call Bound7                     ;
                        sub 8                           ;
                        ld h,a                          ;
                        ex de,hl                        ;
                        ld hl,(pFrameX)                 ;

                        ld a,(JFLAG)                    ;
                        or a                            ;
                        jr nz,JUST                      ;

                        sbc hl,de                       ;
                        ret z                           ;

JUST                    xor a                           ;
                        ld (JFLAG),a                    ;

                        ld hl,(ManOPosXY)               ;

                        ld a," "                        ;
                        call OutIt                      ;
                        inc h                           ;
                        call OutIt                      ;

                        ld (pFrameX),de                 ;
                        ld hl,(pMan)                    ;
                        call SCV                        ;

                        ld (ManOPosXY),hl               ;

                        call NewScreen                  ;

                        call PM                         ;

                        ret                             ;

BackwardCon             res 7,l                         ;
                        rl l                            ;
                        srl h                           ;
                        rr l                            ;

                        push de                         ;
                        ld de,BigMaze                   ;
                        add hl,de                       ;
                        pop de                          ;

                        ret                             ;

NewScreen               ld iy,(pFrameX)                 ;
                        ld hl,#0000                     ;
                        ld b,YW+3                       ;

NewS1                   push bc                         ;
                        ld b,XW+4                       ;

NewS2                   push bc                         ;
                        push hl                         ;
                        call NewSGet                    ;
                        pop hl                          ;

                        push hl                         ; Save
                        call OutIt_NR                   ;
                        pop hl                          ;
                        inc iyl                         ;

                        inc l                           ;
                        pop bc                          ;
                        djnz NewS2                      ;

                        ld a,(pFrameX)                  ;
                        ld iyl,a                        ;

                        inc iyh                         ;

                        ld l,0                          ;
                        inc h                           ;

                        pop bc                          ;
                        djnz NewS1                      ;

                        ret                             ;

NewSGet                 push iy                         ;
                        pop bc                          ;

                        ld a,b                          ;
                        cp #71                          ;
                        jp nc NewSGet2                  ;

                        ld a,c                          ;
                        cp #80                          ;
                        jp nc NewSGet2                  ;

                        push iy                         ;
                        pop hl                          ;

                        call BackwardCon                ;

                        ld a,iyl                        ;
                        ; cp #70                        ;
                        ld a,(hl)                       ;
                        ret                             ;

NewSGet2                ld a,#FF                        ;
                        ret                             ;

; Convert to screen co-ordinates. NC means visible...

SCV                     push de                         ;
                        push af                         ;

                        ; Get this as an X/Y in DE

                        ld a,l                          ; Get X
                        and #7F                         ;
                        add hl,hl                       ; H:=Y+Offset BigMaze starts at C000 so offset = 80
                        ld e,a                          ;

                        ld a,h                          ;
                        and $7F                         ; Lose the offset
                        ld d,a                          ;

                        ; See if we're visible

                        ld hl,(pFrameX)                 ;
                        ld a,e                          ;
                        sub l                           ;
                        ld l,a                          ;

                        cp XW+4                         ;
                        jr nc SCVF                      ;

                        ld a,d                          ;
                        sub h                           ;
                        ld h,a                          ;

                        cp YW+3                         ;
                        jr nc SCVF1                     ;

                        pop af                          ;
                        pop de                          ;
                        or a                            ;
                        ret                             ;

SCVF                    ld a,d                          ;
                        sub h                           ;
                        ld h,a                          ;

SCVF1                   pop af                          ;
                        pop de                          ;
                        scf                             ;
                        ret                             ;

; Convert a big-maze pointer to L=X, H=Y

ConvBM_To_XY_HL         ld a,l                          ; Get X
                        and #7F                         ;
                        add hl,hl                       ; H:=Y+Offset BigMaze starts at C000 so offset = 80
                        ld l,a                          ;

                        ld a,h                          ;
                        and $7F                         ;
                        ld h,a                          ;

                        ret                             ;

OutIt                   cp " "                          ; Speed up this case
                        jr z OutIt_Blank                ;

                        push hl                         ;
                        push de                         ;
                        push af                         ;
                        push bc                         ;
                        push hl                         ;
                        push hl                         ;

                        ld h,Characters/256             ;
                        ld l,a                          ;
                        ld c,(hl)                       ;
                        pop hl                          ;
                        ld de,SpecTab                   ;
                        push hl                         ;
                        ld l,h                          ;
                        ld h,0                          ;
                        add hl,hl                       ;
                        add hl,de                       ;
                        ld e,(hl)                       ;
                        inc hl                          ;
                        ld d,(hl)                       ;
                        pop hl                          ;
                        ld h,0                          ;
                        add hl,de                       ;
                        push hl                         ;
                        ld l,a                          ;
                        ld h,0                          ;
                        add hl,hl                       ;
                        add hl,hl                       ;
                        add hl,hl                       ;
                        ld de,Char_8x8_21-$108          ;
                        add hl,de                       ;
                        pop de                          ;

                        loop 7
                          ld a,(hl)                     ;
                          ld (de),a                     ;
                          inc hl                        ;
                          inc d                         ;
                          lend

                        ld a,(hl)                       ;
                        ld (de),a                       ;

                        pop hl                          ;
                        ld a,l                          ;
                        add a,a                         ;
                        add a,a                         ;
                        add a,a                         ;
                        srl h                           ;
                        rra                             ;
                        srl h                           ;
                        rra                             ;
                        srl h                           ;
                        rra                             ;
                        ld l,a                          ;
                        ld de,pAttrib                   ;
                        add hl,de                       ;
                        ld (hl),c                       ;

OutItEx                 pop bc                          ;
                        pop af                          ;
                        pop de                          ;
                        pop hl                          ;
                        ret                             ;

                ; Just calc the attribute address and clear it
                ; h = y (0..23), l = x (0..31)

OutIt_Blank             push hl                         ; Save

                        ld a,0                          ; Clear it

                        srl h                           ; Get the 3 LSB's
                        rra                             ;
                        srl h                           ;
                        rra                             ;
                        srl h                           ;
                        rra                             ;

                        or l                            ; Merge X
                        ld l,a                          ;

                        ; HL is not the attribute offset

                        ld a,high Attrs                 ;
                        add a,h                         ;
                        ld h,a                          ;

                        ld (hl),0                       ; Clear the attribute

                        ld a," "                        ; Restore
                        pop hl                          ;
                        ret                             ; Done

; Slightly faster version

OutIt_NR                ld d,Characters/256             ;
                        ld e,a                          ;

                        ld a,(de)                       ; Get the attribute
                        or a                            ; Is this zero?
                        jr z OutIt_NR_Blank             ; It's zero, just clear it

                        ; Carry on and draw it

                        ld c,a                          ; The attribute
                        ld a,e                          ; Restore the character

                        push hl                         ;

                        ld de,SpecTab                   ;

                        push hl                         ;

                        ld l,h                          ;
                        ld h,0                          ;

                        add hl,hl                       ;
                        add hl,de                       ;

                        ld e,(hl)                       ;
                        inc hl                          ;
                        ld d,(hl)                       ;

                        pop hl                          ;

                        ld h,0                          ;
                        add hl,de                       ;

                        push hl                         ;

                        ld l,a                          ;
                        ld h,0                          ;

                        add hl,hl                       ;
                        add hl,hl                       ;
                        add hl,hl                       ;

                        ld de,Char_8x8_21-$108          ;
                        add hl,de                       ;

                        pop de                          ;

                        ; Copy a character from (hl) to (de)

                        loop 7
                          ld a,(hl)                     ;
                          ld (de),a                     ;
                          inc hl                        ;
                          inc d                         ;
                          lend

                        ld a,(hl)                       ;
                        ld (de),a                       ;

                        pop hl                          ;

                        ld a,l                          ;

                        add a,a                         ;
                        add a,a                         ;
                        add a,a                         ;

                        srl h                           ;
                        rra                             ;

                        srl h                           ;
                        rra                             ;
                        srl h                           ;
                        rra                             ;

                        ld l,a                          ;

                        ld de,pAttrib                   ;
                        add hl,de                       ;

                        ld (hl),c                       ;
                        ret                             ; Done

                ; Just calc the attribute address and clear it
                ; h = y (0..23), l = x (0..31)

OutIt_NR_Blank          xor a                           ; Clear it

                        srl h                           ; Get the 3 LSB's
                        rra                             ;
                        srl h                           ;
                        rra                             ;
                        srl h                           ;
                        rra                             ;

                        or l                            ; Merge X
                        ld l,a                          ;

                        ; HL is not the attribute offset

                        ld a,high Attrs                 ;
                        add a,h                         ;
                        ld h,a                          ;

                        ld (hl),0                       ; Clear the attribute
                        ret                             ; Done

InitTreasure            ld b,nTreasure                  ;

InitTLoop               push bc                         ;

                        call FindPosition               ;

                        call RandOnly_A                 ;
                        and #F                          ;
                        or #B0                          ;
                        ld (hl),a                       ;

                        pop bc                          ;
                        djnz InitTLoop                  ;

                        ret                             ;

InitMagic               ld b,nMagic                     ;

InitMLoop               push bc                         ;

                        call FindPosition               ;

                        call RandOnly_A                 ;
                        and #7                          ;
                        or #C8                          ;
                        ld (hl),a                       ;

                        pop bc                          ;
                        djnz InitMLoop                  ;

                        ret                             ;

; Find an empty square in the maze

FindPosition            call Rand                       ;

                        ld hl,(Seed)                    ;
                        ld a,l                          ;
                        and #7F                         ;
                        cp #70                          ;
                        jr nc FindPosition              ;

                        ld a,h                          ;
                        and #3F                         ;
                        ld h,a                          ;
                        cp #38                          ;
                        jr nc FindPosition              ;

                        push de                         ;
                        ld de,BigMaze                   ;
                        add hl,de                       ;
                        pop de                          ;

                        ld a,(hl)                       ; Empty?
                        cp " "                          ;
                        jr nz,FindPosition              ; No, find another one...

                        ret                             ;

InitMonsters            ld b,nMonst                     ;
                        ld ix,MonsterList               ;

IMons0                  push bc                         ;
                        push ix
                        call IMons1                     ;
                        pop ix

                        ld a,(ix+dm_cSpeed)             ; Set the dynamic speed
                        ld (ix+dm_iSpeed),a             ;

                        ld bc,lMonst                    ;
                        add ix,bc                       ;

                        pop bc                          ;
                        djnz IMons0                     ;

                        ; Make more of the monsters nasty?

                        ld a,(GameBType)                ; Faster monsters?
                        bit 1,a                         ;

                        ld a,14                         ; 14 of them on each floor
                        jr nz Nasty                     ; Jmp if faster

                        ; Exit if we're in the basement

                        ld a,(cFloor)                   ;
                        or a                            ;
                        ret z                           ;

                        ; Make some nastier, more on the higher floors

Nasty                   ld ix,MonsterList-lMonst        ;
                        ld de,lMonst                    ;

IMons4                  add ix,de                       ;
                        ld (ix+dm_Magic),#FF            ;
                        ld (ix+dm_cSpeed),30            ;
                        ld (ix+dm_iSpeed),30            ;

                        dec a                           ;
                        jr nz,IMons4                    ;

                        ld (ix+dm_Wounds),#FF           ;
                        ret                             ;

                ; Init a monster.

IMons1                  ld iy,MonsterTypes              ;
                        ld b,lMonsterFixed              ;

IMons2                  push bc                         ;

                        ld a,(iy+lMonsterFixed)         ; Get the variation
                        call RandRange                  ; Rand 0..Var-1
                        add a,(iy)                      ; +Base
                        ld (ix),a                       ; Store

                        inc ix                          ;
                        inc iy                          ;

                        pop bc                          ;
                        djnz IMons2                     ;

                        ; Find somewhere for it
                        ; IX now has an offset of lMonsterFixed

                        call FindPosition               ;

                        ld (ix+dm_pMaze_L-lMonsterFixed),l
                        ld (ix+dm_pMaze_H-lMonsterFixed),h

                        ; This didn't mark the position in any way, so potentially a ring could be put under the monster...

                        ld a,(bBuilding)                ; Are we building for the first time?
                        or a                            ;
                        jr z IMon_DontPlace             ; No, don't place it

                        ; We are, so mark it

                        ld a,(ix+dm_Char-lMonsterFixed) ;
                        ld (hl),a                       ;

                        ; Clear to the end of the monster

IMon_DontPlace          ld b,lMonst-lMonsterFixed       ;

IMons3                  ld (ix),0                       ;
                        inc ix                          ;
                        djnz IMons3                     ;

                        ret                             ;

; Place the monsters in the maze

PlaceMon                ld b,nMonst                     ;
                        ld ix,MonsterList               ;
                        ld de,lMonst                    ;

PlaceMonL               ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        ld a,(ix+dm_Char)               ;
                        ld (hl),a                       ;
                        add ix,de                       ;

                        djnz PlaceMonL                  ;

                        ret                             ;

; Get a random number less than A

RandRange               or a                            ;
                        ret z                           ;

                        push hl                         ;
                        push de                         ;
                        push bc                         ;

                        ld c,a                          ;
                        call RandOnly_A                 ;
                        ld l,a                          ;
                        xor a                           ;
                        ld b,8                          ;
RandR1                  rl l                            ;
                        rla                             ;
                        cp c                            ;
                        jr c RandR2                     ;

                        sub c                           ;
RandR2                  djnz RandR1                     ;

                        pop bc                          ;
                        pop de                          ;
                        pop hl                          ;
                        ret                             ;

; Move the monsters

MoveMonsters            ld b,nMonst                     ;
                        ld ix,MonsterList               ;

MM_Lp                   dec (ix+dm_Delay)               ;
                        call z DoMoveMonster            ;

                        ld de,lMonst                    ;
                        add ix,de                       ;

                        djnz MM_Lp                      ;
                        ret                             ;

; Move a monster

DoMoveMonster           ld a,(ix+dm_cSpeed)             ; Reset the speed
                        ld (ix+dm_Delay),a              ;

                        bit 7,(ix+dm_Flags)             ; Is it dead?
                        jp nz MoveDeadMonster           ; Yes, animate it

                        bit 0,(ix+dm_Combat)            ; Are we being targetted?
                        jr z MMons2A                    ; No, skip

                        ; We're under attack, we need to wake up

                        ld a,(ix+dm_Char)               ; Are we sleeping?
                        cp cSleepingMonster             ;
                        jr nz MMons2Z                   ; No, so carry on

                        ; Yes, so change our character to something else

                        ld a,r                          ; Random character
                        and #7                          ;
                        or #D0                          ;
                        cp cSleepingMonster             ; But not this one
                        jr nz MMons2B                   ;

                        inc a                           ;

MMons2B                 ld (ix+dm_Char),a               ; Set this character

                        jp MMons2Z                      ;

                ; Not under attack so should we doze off?

MMons2A                 ld a,(ix+dm_Char)               ;
                        cp cSleepingMonster             ;
                        jr z,MMons2Z                    ;

                        ; This isn't a sleeping monster, should it fall asleep?

                        ld a,(Seed+1)                   ;
                        ld c,a                          ;
                        ld a,r                          ;
                        or c                            ;
                        and #3F                         ;
                        jr nz MMons2Z                   ; No.

                        ; Can it be seen?

                        push hl                         ;
                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;

                        call SCV                        ;
                        jr nc MMons2X                   ;

                        ; It can't be seen, so goto sleep

                        ld (ix+dm_Char),cSleepingMonster;

                        ; We're not on screen

MMons2X                 pop hl                          ;

                        ; General monster move

MMons2Z                 push bc                         ;

                        ; Remove the thing from the bigmaze

                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;

                        ld a," "                        ; Clear it
                        ld (hl),a                       ;

                        ; If we are asleep we don't undraw them or move to prevent tell-tale flicker...

                        ld a,(ix+dm_Char)               ;
                        cp cSleepingMonster             ;
                        jp z,MMons5                     ;

                        ; No, we're a moving thing, so undraw it

                        call SCV                        ;
                        call nc OutIt_NR_Blank          ;

                        ; Setup the "return" address

                        ld hl,MMons5                    ;
                        push hl                         ;

                        ; What sort of thing is it?

                        ld a,(ix+dm_MoveType)           ; 1
                        bit 6,a                         ; Is this an alternate move?
                        jp nz MoveThingRandom           ; Yes, skip

                        cp 1                            ;
                        jp c MoveThingWallFollowLHS     ; 0
                        jp z MoveThingWallFollowRHS     ; 1

                        cp 3                            ;
                        jp c MoveThingRandom            ; 2
                        jp z MoveThingRandCoward        ; 3

                        ; 4/5

                        cp 4                            ;
                        jp z MoveThingCowardWF_LHS      ; 4
                        jp MoveThingCowardWF_RHS        ; 5

                ; This is a wall-following coward...

MoveThingCowardWF_LHS   bit 0,(ix+dm_Combat)            ; Is this visible to the man?
                        jr nz MTWF_LHS_Seen             ; Yes, skip

                        res 1,(ix+dm_Combat)            ; Clear the was visible flag
                        jp MoveThingWallFollowLHS       ; Same as wall-follower

                ; We can be seen

MTWF_LHS_Seen           bit 1,(ix+dm_Combat)            ; Was this visible to the man?
                        jp nz MoveThingWallFollowLHS    ; Yes, no change

                        ; We've just become visible

                        set 1,(ix+dm_Combat)            ; Set the was visible flag

                        ; Change walls

                        ld (ix+dm_MoveType),5           ; WF rhs
                        jp MoveThingWallFollowRHS       ; Yes, do it

                ; This is a wall-following coward...

MoveThingCowardWF_RHS   bit 0,(ix+dm_Combat)            ; Is this visible to the man?
                        jr nz MTWF_RHS_Seen             ; Yes, skip

                        res 1,(ix+dm_Combat)            ; Clear the was visible flag
                        jp MoveThingWallFollowRHS       ; Same as wall-follower

                ; We can be seen

MTWF_RHS_Seen           bit 1,(ix+dm_Combat)            ; Was this visible to the man?
                        jp nz MoveThingWallFollowRHS    ; Yes, no change

                        ; We've just become visible

                        set 1,(ix+dm_Combat)            ; Set the was visible flag

                        ; Change walls

                        ld (ix+dm_MoveType),4           ; WF lhs
                        jp MoveThingWallFollowLHS       ; Yes, do it

                ; Random coward

MoveThingRandCoward     bit 0,(ix+dm_Combat)            ; Is this visible to the man?
                        jr nz MTRC_Seen                 ; Yes, skip

                        res 1,(ix+dm_Combat)            ; Clear the was visible flag
                        jp MoveThingRandom              ; Same as random

                ; We can be seen

MTRC_Seen               bit 1,(ix+dm_Combat)            ; Was this visible to the man?
                        jp nz MoveThingRandom           ; Yes, no change, same as random

                        ; We've just become visible

                        set 1,(ix+dm_Combat)            ; Set the was visible flag

                        ; We want to move away from the man ideally, but for the moment we'll just reverse

                        ld a,(ix+dm_Dirn)               ; Rotate the angle by 2
                        add a,2                         ;
                        and $7                          ;
                        ld (ix+dm_Dirn),a               ;

                        jp MoveThingRandom              ; Random

                ; We've moved it, see if it wants to fight

MMons5                  call CheckCombat                ; See if it wants to fight

                        ; Now, re-draw it

                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;

                        ld a,(ix+dm_Char)               ;
                        ld (hl),a                       ; Write it to BM

                        mSCV_Out()                      ;

                        pop bc                          ;
                        ret                             ;

; Dynamic monsters

NHack1a                 ld a,(GameBType)                ; Are we dynamic?
                        bit 2,a                         ;
                        ret z                           ; No, exit

                        ; We're slowing down

                        ld a,(ix+dm_cSpeed)             ; We are slowing back down
                        ld c,(ix+dm_iSpeed)             ; Back to this
                        add a,delSp                     ;
                        cp c                            ;
                        ret nc                          ;
                        ld (ix+dm_cSpeed),a             ;
                        ret                             ;

; See if we want to attack

MonCelebrate            call MonCelebrate2              ; Fire lightning at him
                        ld a,r                          ;
                        and $03                         ;
                        add a,low sCeleb                ;
                        ld l,a                          ;
                        ld h,high sCeleb
                        ld a,(hl)
                        ld (iy+dp_MissileChar),a        ; Different character

                        ld hl,MoveCelebrate             ;
                        ld (iy+dp_pCode_L),l            ;
                        ld (iy+dp_pCode_H),h            ;

                        ret                             ; Done

sCeleb                  db "ha!",$F5

                if high * <> high sCeleb
                  zeuserror "Alignment error - you need to move sCeleb, it can't cross a page boundary"
                endif

CheckCombat             call FindProjSpace              ; Any projectile space?
                        ret z                           ;

                        ld e,(ix+dm_pMaze_L)            ;
                        ld d,(ix+dm_pMaze_H)            ;
                        ld hl,(pMan)                    ;
                        ld c,50                         ;
                        call RangeLook                  ;

                        ld (iy+dp_Life),0               ;
                        res 0,(ix+dm_Combat)            ;
                        jr c NHack1a                    ; Can't see the man

                        ; We can see the man

                        ld a,(GameBType)                ; Are we dynamic?

                        bit 7,a                         ; Man dead?
                        jr nz MonCelebrate              ;

                        bit 2,a                         ;
                        jr z NHack1                     ; No, skip

                        ; Speed up

                        ld a,(ix+dm_cSpeed)             ; Speed up to max speed
                        sub delSp                       ;
                        cp mDynamMaxSpeed               ;
                        jr c NHack1                     ;
                        ld (ix+dm_cSpeed),a             ;

                        ; Flag that the man isn't a virgin any longer

NHack1                  ld a,1                          ; Not a virgin any more
                        ld (Virgin),a                   ;

                        set 0,(ix+dm_Combat)            ; Set that it can see the man

                        ; Is this a pure vertical or horizontal?

                        ld a,(iy+dp_ErrS)               ;
                        or a                            ;
                        jp nz CComNA                    ; Not an arrow

                        ; Fire an arrow? More likely as we get closer to the thing...

                        ld a,40                         ;
                        call RandRange                  ;

                        ld d,(iy+dp_ErrM)               ; This is the range, I think
                        cp d                            ; dp_ErrM (Range?)
                        jr c CComNA                     ;

                        ld a,(ix+dm_nArrows)            ;
                        or a                            ;
                        jr z CComNA                     ;

                        ; We are firing an arrow

                        mAddNoise(3)                    ;

                        ; We're firing at the man, so he doesn't have a combat flag
                        ; Make sure we don't clear it

                        ld (iy+dp_pTarget2_H),0         ; If zero, no clearing

                        dec (ix+dm_nArrows)             ;

                        ld (iy+dp_Delay),ArrowSpeed     ;
                        ld (iy+dp_iDelay),ArrowSpeed    ;

                        ld a,(ix+dm_pMaze_L)            ;
                        ld (iy+dp_pMaze_L),a            ;

                        ld a,(ix+dm_pMaze_H)            ;
                        ld (iy+dp_pMaze_H),a            ;

                        ld l,(iy+dp_Step1_L)            ;
                        ld (iy+dp_Off_L),l              ;
                        ld h,(iy+dp_Step1_H)            ;
                        ld (iy+dp_Off_H),h              ;

                        ld a,l                          ;
                        and #1                          ;
                        xor #A1                         ;
                        ld (iy+dp_MissileChar),a        ;

                        ld (iy+dp_Life),ArrowLife       ;
                        call AllocateProjSpace          ; Make it active

                        ld hl,MoveArrow                 ;
                        ld (iy+dp_pCode_L),l            ;
                        ld (iy+dp_pCode_H),h            ;

                        ld (iy+dp_BackingChar),0        ;

                        push ix                         ;

                        push iy                         ;
                        pop ix                          ;

                        call MoveArrow                  ;
                        pop ix                          ;

                        ret                             ; Done

                ; Now, use magic instead?

CComNA                  ld a,r                          ; 25% chance
                        and %0100100                    ;
                        ret nz                          ;

                        ; Might fire

                        ld a,(ix+dm_Magic)              ; Do we have enough magic?
                        cp 6                            ;
                        ret c                           ; Not enough

                        ; Make it more probable that the thing will fire if it has more magic

                        ld c,a                          ;
                        ld a,12                         ;
                        call RandRange                  ;

                        cp c                            ;
                        ret nc                          ; Rand > magic, ignore

                        ld a,(Seed+1)                   ; 7:8ths chance of a fireball
                        and %01101000                   ;
                        jr nz,CComFire                  ; Fireball

                        ; Fire lightning

MonCelebrate2           mAddNoise(2)                    ;

                        ld hl,(pMan)                    ;
                        ld e,(ix+dm_pMaze_L)            ;
                        ld d,(ix+dm_pMaze_H)            ;
                        call InitLine                   ;

                        ld (iy+dp_MissileChar),#A0      ;
                        ld (iy+dp_Delay),LightSpeed     ;
                        ld (iy+dp_iDelay),LightSpeed    ;

                        ld hl,MoveLight                 ;
                        ld (iy+dp_pCode_L),l            ;
                        ld (iy+dp_pCode_H),h            ;

                        ld (iy+dp_Life),LightLife       ;
                        call AllocateProjSpace          ; Make it active

                        ld (iy+dp_BackingChar),0        ;

                        ; We want a pointer to the owner's pointer to the maze.
                        ; so we can compare addresses to see if the projectile has hit its owner

                        ld a,ixl                        ; This is the address of the monster's pMaze
                        ld (iy+dp_pOwner_L),a           ;
                        ld a,ixh                        ;
                        ld (iy+dp_pOwner_H),a           ;

                        ld hl,pMan                      ;
                        ld (iy+dp_pTarget_L),l          ;
                        ld (iy+dp_pTarget_H),h          ;

                        ld a,(ix+dm_Magic)              ;
                        sub 6                           ;
                        ld (ix+dm_Magic),a              ;

                        ret                             ;

CComFire                ld a,(ix+dm_Magic)              ;
                        cp 10                           ;
                        ret c                           ;

                        mAddNoise(3)                    ;

                        ld hl,(pMan)                    ;
                        ld e,(ix+dm_pMaze_L)            ;
                        ld d,(ix+dm_pMaze_H)            ;
                        call InitLine                   ;

                        ld (iy+dp_Delay),FireSpeedInit  ;
                        ld (iy+dp_iDelay),FireSpeedInit ;

                        ld hl,MoveFire                  ;
                        ld (iy+dp_pCode_L),l            ;
                        ld (iy+dp_pCode_H),h            ;

                        ld (iy+dp_Life),FireLife        ;
                        call AllocateProjSpace          ; Make it active

                        ld (iy+dp_BackingChar),0        ;
                        ld (iy+dp_MissileChar),#A4      ;

                        ; We want a pointer to the owner's pointer to the maze.
                        ; so we can compare addresses to see if the projectile has hit its owner

                        ld a,ixl                        ; This is the address of the monster's pMaze
                        ld (iy+dp_pOwner_L),a           ;
                        ld a,ixh                        ;
                        ld (iy+dp_pOwner_H),a           ;

                        ld hl,pMan                      ;
                        ld (iy+dp_pTarget_L),l          ;
                        ld (iy+dp_pTarget_H),h          ;

                        ld (iy+dp_ManF),0               ;
                        ld (iy+dp_UpdateRate),FireTurnRate;

                        ld hl,(pMan)                    ;
                        ld (iy+dp_TargetiPos_L),l       ;
                        ld (iy+dp_TargetiPos_H),h       ;

                        ld a,(ix+dm_Magic)              ;
                        sub 10                          ;
                        ld (ix+dm_Magic),a              ;

                        ret                             ;

                ; Steaming pile. Now, slow the animation down

MoveDeadMonster         ld a,(ix+dm_Char)               ; Is this a steaming thing?
                        cp #E0                          ;
                        jr nc ShowSteaming              ; No, it's not.

                        ; We're a static shape

                        ld c,255                        ; Save time
                        ld (ix+dm_cSpeed),c             ;

                        ; Show this static thing

ShowDeadThing           ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        ld (hl),a                       ;

                        call SCV                        ;
                        jp nc OutIt                     ;
                        ret                             ;

                ; It's steaming, slow down

ShowSteaming            ld c,(ix+dm_cSpeed)             ; Decrease the speed
                        inc c                           ;
                        jr z StopSteaming               ; Finished

                        ld (ix+dm_cSpeed),c             ; Slower

                        ; We're still growing deader...

                        inc a                           ;
                        and #E3                         ;
                        ld (ix+dm_Char),a               ;

                        ; Show it

                        jp ShowDeadThing                ; Show it

                ; We're completely dead

StopSteaming            ld a,$DB                        ; Burned out thing
                        ld (ix+dm_Char),a               ;
                        jp ShowDeadThing                ;

; Convert 8 directions (A) into bigmaze displacements (DE)

CDirect1                ld de,-129                      ;
                        cp 4                            ;
                        ret z                           ;

                        ld de,-127                      ;
                        cp 5                            ;
                        ret z                           ;

                        ld de,129                       ;
                        cp 6                            ;
                        ret z                           ;

                        ld de,127                       ;
                        cp 7                            ;
                        ret z                           ;

                        ; Convert 4 directions into bigmaze displacements

CDirect                 ld de,-128                      ;
                        cp 0                            ;
                        ret z                           ;

                        ld de,1                         ;
                        cp 1                            ;
                        ret z                           ;

                        ld de,128                       ;
                        cp 2                            ;
                        ret z                           ;

                        ld de,-1                        ;
                        cp 3                            ;
                        ret z                           ;

                        ld de,0                         ;
                        ret                             ;

; Simple random thing movement

MoveThingRandom         ld a,(ix+dm_Dirn)               ;
                        call CDirect1                   ;

                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        add hl,de                       ;

                        ld a,(hl)                       ; Is this a door?
                        and #FE                         ;
                        cp #DC                          ;
                        call z MonODoor                 ; Yes, see if we want to open it

                        ld a,(hl)                       ;
                        cp " "                          ;
                        jp nz MTR_NewDir_Hit            ; Hit something so change direction

                        ; It's clear so we move there

                        ld (ix+dm_pMaze_L),l            ;
                        ld (ix+dm_pMaze_H),h            ;

                        ld a,r                          ;
                        and #72                         ; Was $70
                        jp z MTR_NewDir                 ;

                        ret                             ;

                ; Type 1 monster new direction

MTR_NewDir_Hit          call MonKeep                    ; Want to keep this?
                        ret nc                          ; We did, exit

                        ; We didn't keep it, so change direction to a new random direction

MTR_NewDir              ld a,r                          ;
                        and #7                          ;
                        ld (ix+dm_Dirn),a               ;

                        ; Now, have we hit anything interesting?

                        ld a,(hl)                       ; Is this a sleeping monster or a ring?
                        cp cSleepingMonster             ; A sleeping monster?
                        call z Mon_HitSleeper           ; Yes, join it

                        and #F8                         ;
                        cp #88                          ;
                        call z Mon_HitRing              ; Yes, supercharge it

                        ld a,(hl)                       ; Hit a wall?
                        and #F0                         ;
                        cp #90                          ;
                        ret nz                          ; No, exit

                        ; Yes, and was this an alternative move for something else?

                        bit 6,(ix+dm_MoveType)          ;
                        ret z                           ; No, done

                        ; Yes, so we become a whatever it was again

                        res 6,(ix+dm_MoveType)          ;

                        ; Remember this position so we detect loops

MoveT2Mark              ld a,(ix+dm_pMaze_L)            ;
                        ld (ix+dm_PastPos_L),a          ;

                        ld a,(ix+dm_pMaze_H)            ;
                        ld (ix+dm_PastPos_H),a          ;

                        ld (ix+dm_TimeOut),0            ;
                        ret                             ;

; Wall follower one way

MoveThingWallFollowLHS  ld a,1                          ;
                        jp MTWF_1                       ;

MoveThingWallFollowRHS  ld a,-1                         ;

MTWF_1                  ld (WallFollowDirn),a           ;

                        ld a,(ix+dm_TimeOut)            ; Update the marker if we've not hit it for a while
                        or a                            ;
                        call z MoveT2Mark               ;

                        inc (ix+dm_TimeOut)             ; ++

                        ; Look the way we're moving

                        ld a,(ix+dm_Dirn)               ; This should only be LRUD
                        and $03                         ; Make sure
                        call CDirect                    ;

                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        add hl,de                       ;

                        ; What's there?

                        ld a,(hl)                       ; Is this a ring or sleeping thing?
                        cp " "                          ;
                        jr z MTWF_ClearInFront          ;

                        ; Hit something

                        cp cSleepingMonster             ; A sleeping monster?
                        call z Mon_HitSleeper           ; Yes, join it

                        and #F8                         ;
                        cp #88                          ;
                        call z Mon_HitRing              ; Yes, supercharge it

                        ; Not a ring, is it a door?

                        ld a,(hl)                       ; Is this a door?
                        and #FE                         ;
                        cp #DC                          ;
                        call z MonODoor                 ; Yes, see if we want to open it

                        ; We've hit something, try to keep it

                        call MonKeep                    ;
                        ret nc                          ;

                        ; Change direction?

                        ld a,(WallFollowDirn)           ; Dirn
                        ld e,(ix+dm_Dirn)               ; MoveType: 1-> -1 | 3-> +1
                        add a,e                         ;
                        and #3                          ; LRUD
                        ld (ix+dm_Dirn),a               ;

                        ; Detect loops

WallFC                  ld e,(ix+dm_PastPos_L)          ; Have we been here before?
                        ld d,(ix+dm_PastPos_H)          ;
                        or a                            ;
                        sbc hl,de                       ;
                        ret nz                          ; No, exit

                        ; We've been here before so start moving randomly

                        ld (ix+dm_TimeOut),1            ; Reset the time-out

                        set 6,(ix+dm_MoveType)          ; Assert the ALT-MOVE flag
;                        ld (ix+dm_MoveType),2           ; Become random
;                        ld (ix+dm_AltMoveF),1           ; But only for a while

                        ld a,r                          ; Move in a random diagonal direction
                        and #3                          ;
                        or #4                           ;
                        ld (ix+dm_Dirn),a               ;

                        ret                             ;

                ; It's clear in front, so check that we have a wall on out LHS

MTWF_ClearInFront       ld a,(WallFollowDirn)           ; Dirn
                        neg                             ;
                        ld e,(ix+dm_Dirn)               ; MoveType: 1-> -1 | 3-> +1
                        add a,e                         ; Change angle
                        and #3                          ; LRUD

                        call CDirect                    ;

                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        add hl,de                       ;

                        ld a,(hl)                       ; Is this a door?
                        and #FE                         ;
                        cp #DC                          ;
                        call z MonODoor                 ; Yes, see if we want to open it

                        ; Is the left of us clear?

                        ld a,(hl)                       ;
                        cp " "                          ;
                        jr nz MT_WallDoMoveDirn         ; No, we're OK

                        ; Yes, so move left

                        ld (ix+dm_pMaze_L),l            ;
                        ld (ix+dm_pMaze_H),h            ;

                        ; And change our direction

                        ld a,(WallFollowDirn)           ; Dirn
                        neg                             ;
                        ld e,(ix+dm_Dirn)               ; MoveType: 1-> -1 | 3-> +1
                        add a,e                         ; Change angle
                        and #3                          ; LRUD
                        ld (ix+dm_Dirn),a               ;

                        jp WallFC                       ;

                ; Still on the wall so just move

MT_WallDoMoveDirn       ld a,(ix+dm_Dirn)               ;
                        and #3                          ;
                        call CDirect                    ;

                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        add hl,de
                        ld (ix+dm_pMaze_L),l            ;
                        ld (ix+dm_pMaze_H),h            ;

                        jp WallFC                       ;

                ; We've hit a ring. SUPERCHARGE!

Mon_HitRing             ld (ix+dm_cSpeed),25            ; Faster
                        ld (ix+dm_Magic),#FF            ; Fully armed
                        ld (ix+dm_Wounds),#FF           ; And hard to kill

                        ; Is this visible?

                        push hl                         ; See if it's on-screen
                        call SCV                        ;
                        pop hl                          ;

                        ret nc                          ; Yes, exit

                        ; We can't see this one at the moment, so go to sleep

                        ld (ix+dm_Char),cSleepingMonster; Go to sleep if we're not visible

                        ret                             ; Done

                ; We've hit another sleeper (don't alter a or hl)

Mon_HitSleeper          push hl                         ; See if it's on-screen
                        ld c,a                          ; Save a
                        push bc                         ;

                        call SCV                        ;

                        pop bc                          ; Restore
                        ld a,c                          ;
                        pop hl                          ;

                        ret nc                          ; Yes, exit

                        ld (ix+dm_Char),cSleepingMonster; Also goto sleep (presume we're invisible)

                        ld (ix+dm_cSpeed),45            ; Faster?
                        ld (ix+dm_Magic),#80            ; Fully armed
                        ld (ix+dm_Wounds),#80           ; And hard to kill

                        ret                             ; Done

        if false
                ; Wall follower RHS

MoveThing3              ld a,(ix+dm_TimeOut)            ;
                        or a                            ;
                        call z MoveT2Mark               ;

                        inc (ix+dm_TimeOut)             ;

                        ld a,(ix+dm_Dirn)               ;
                        and #3                          ;
                        call CDirect                    ;

                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        add hl,de                       ;

                        ld a,(hl)                       ; Is this a ring?
                        cp cSleepingMonster             ; A sleeping monster?
                        call z Mon_HitSleeper           ; Yes, join it

                        and #F8                         ;
                        cp #88                          ;
                        call z Mon_HitRing              ; Yes, supercharge it

                        ld a,(hl)                       ; Is this a door?
                        and #FE                         ;
                        cp #DC                          ;
                        call z MonODoor                 ; Yes, see if we want to open it

                        ld a,(hl)                       ;
                        cp " "                          ;
                        jr z MT3_ClearInFront           ;

                        call MonKeep                    ;
                        ret nc                          ;

                        ld a,(ix+dm_Dirn)               ;
                        inc a                           ;
                        and #3                          ;
                        ld (ix+dm_Dirn),a               ;

                        jp WallFC                       ;

                ; It's clear in front, so check that we have a wall on our RHS

MT3_ClearInFront        ld a,(ix+dm_Dirn)               ; Get the movement direction
                        dec a                           ; Look LRUD at an angle to how we're moving
                        and #3                          ;
                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        call CDirect                    ;
                        add hl,de                       ;

                        ; We're now looking to our left

                        ld a,(hl)                       ; Is this a door?
                        and #FE                         ;
                        cp #DC                          ;
                        call z MonODoor                 ; Yes, see if we want to open it

                        ; Is there space on our left?

                        ld a,(hl)                       ;
                        cp " "                          ;
                        jp nz MT_WallDoMoveDirn         ;

                        ; Space on our left

                        ld (ix+dm_pMaze_L),l            ;
                        ld (ix+dm_pMaze_H),h            ;

                        ld a,(ix+dm_Dirn)               ;
                        dec a                           ;
                        and #3                          ;
                        ld (ix+dm_Dirn),a               ;

                        jp WallFC                       ;
        endif

; See if we want to keep this - preserve HL

MonKeep                 ld c,a                          ;
                        and #F0                         ;
                        cp #C0                          ;
                        jr z MonMagic                   ;

                        cp #B0                          ;
                        jr z MonTreas                   ;

                        scf                             ;
                        ret                             ;

MonMagic                ld a,c                          ;
                        and #F                          ;
                        ld c,a                          ;

                        ld a,(ix+dm_Magic)              ;
                        add a,c                         ;
                        add a,c                         ;
                        ret c                           ;

                        cp (ix+dm_MaxMagic)             ;
                        ccf                             ;
                        ret c                           ;

                        ld (ix+dm_Magic),a              ;

KillIt                  ld a," "                        ;
                        ld (hl),a                       ;

                        push hl                         ; Save

                        call SCV                        ;
                        call nc OutIt_NR_Blank          ;

                        pop hl                          ;

                        or a                            ;
                        ret                             ;

MonTreas                ld a,(ix+dm_Treasure)           ;
                        cp 4                            ;
                        ccf                             ;
                        ret c                           ;

                        ; We have room, so store it

                        ld e,a                          ;
                        ld d,0                          ;

                        inc a                           ; ++
                        ld (ix+dm_Treasure),a           ;

                        push ix                         ;
                        add ix,de                       ;
                        ld (ix+dm_Cache),c              ;
                        pop ix                          ;

                        jp KillIt                       ;

; Move the projectiles - fast

MoveProjectiles         ld hl,(pNextProj)               ;

                        ld a,h                          ; End
                        or a                            ;
                        ret z                           ;

                        ld de,pNextProj-dp_pNext        ; Point at the head pointer as if it was a projectile
                        ld (pPrevProj),de               ;

                        push hl                         ;

MP_Next                 pop ix                          ;

                        ld a,ixh                        ;
                        or a                            ;
                        ret z                           ;

                        ld hl,(ix+dp_pNext)             ;
                        push hl                         ;

                        ld a,(ix+dp_Life)               ; Dead?
                        or a                            ;
                        jr z MP_Remove                  ; Yes, remove it

                        ; It's alive

                        dec (ix+dp_Delay)               ; Proj speed
                        jp nz MP_Alive                  ; Not time

                        ; So, move it

                        call MoveProj_IX                ; Move it

                        ; Now, if the life is zero, remove it from the list

                        ld a,(ix+dp_Life)               ; Dead?
                        or a                            ;
                        jr z MP_Remove                  ; Yes, remove it

                        ; Not dead.

MP_Alive                ld (pPrevProj),ix               ; Remember it
                        jp MP_Next                      ; Next

                ; We want to remove this one

MP_Remove               ld iy,(pPrevProj)               ; Get the previous one's pointer

                        pop hl                          ; Get the next one
                        ld (iy+dp_pNext),hl             ; Remove this from the list
                        push hl                         ; Restore the stack

                        ; This one is dead, remove it

                        call FreeProjSpace_IX           ; Release it

                        jp MP_Next                      ;

                ; Move it

MoveProj_IX             ld a,(ix+dp_iDelay)             ; Set the speed
                        ld (ix+dp_Delay),a              ;

                        ld l,(ix+dp_pMaze_L)            ;
                        ld h,(ix+dp_pMaze_H)            ;

                        ld a,(ix+dp_Life)               ; Life --
                        dec a                           ;
                        ld (ix+dp_Life),a               ;
                        jr nz MProj3                    ;

                        ; We have timed-out. We need to release the combat flag on anything we're aimed at

                        call Proj_Clear_CombatFlag      ; Clear it

                        ld a,(ix+dp_BackingChar)        ; Is it drawn?
                        or a                            ;
                        ret z                           ; No, we're done

                        ; Clear it

                        ld a,#20                        ;
                        ld (hl),a                       ;

                        call SCV                        ;
                        jp nc OutIt_NR_Blank            ;

                        ret                             ;

                ; Move a projectile

MProj3                  ld de,MProj4                    ;
                        push de                         ;

                        ld a,(ix+dp_BackingChar)        ;
                        or a                            ;
                        jr z MProj3A                    ;

                        ld a,#20                        ;
                        ld (hl),a                       ;

                        call SCV                        ;
                        call nc OutIt_NR_Blank          ;

MProj3A                 ld l,(ix+dp_pCode_L)            ;
                        ld h,(ix+dp_pCode_H)            ;
                        jp (hl)                         ;

                ; After we've moved it

MProj4                  ld a,(ix+dp_Life)               ;
                        or a                            ;
                        ret z                           ;

                        ld l,(ix+dp_pMaze_L)            ;
                        ld h,(ix+dp_pMaze_H)            ;

                        ld a,(hl)                       ;
                        cp #20                          ;
                        jr nz MProj4A                   ;

                        ld a,(ix+dp_MissileChar)        ;
                        ld (hl),a                       ;

                        ld (ix+dp_BackingChar),1        ;

                        ; We want to show this projectile, and make some noise while we're at it

                        call SCV                        ;
                        jp nc OutIt_NR                  ;

                        ret                             ; Done

MProj4A                 ld (ix+dp_BackingChar),0        ;
                        ret                             ;

; Build the list of projectiles

InitProjList            ld b,nProj-1                    ;
                        ld iy,ProjList                  ;
                        ld hl,ProjList                  ;

                        ld (pFreeProj),hl               ; Start the list

                        ld de,lProj                     ; Length

IPL_Lp                  add hl,de                       ; Next
                        ld (iy+dp_pNext),hl             ; Link

                        push hl                         ;
                        pop iy                          ;

                        djnz IPL_Lp                     ; Do all but the last

                        ; This is the last one

                        ld hl,0                         ; Terminate the list
                        ld (iy+dp_pNext),hl             ; Link
                        ld (pNextProj),hl               ;

                        ret                             ; Done

; Find a projectile space (IY)

FindProjSpace           ld iy,(pFreeProj)               ;
                        ld a,iyh                        ;
                        or a                            ;
                        ret                             ;

; Add this proj to the active list

AllocateProjSpace       ld hl,(iy+dp_pNext)             ; Remove from free space
                        ld (pFreeProj),hl               ;

                        ld hl,(pNextProj)               ; Add to active list
                        ld (iy+dp_pNext),hl             ;
                        ld (pNextProj),iy               ;

                        ret                             ;

; Free this projectile

FreeProjSpace_IX        ld hl,(pFreeProj)               ; Add it to free space
                        ld (ix+dp_pNext),hl             ;
                        ld (pFreeProj),ix               ;

                        ; Remove it from the active list

                        ret                             ;

MFireArrow              ld hl,KeyArrowP                 ;
                        call ReadAKey                   ;
                        ret z                           ;

                        call FindProjSpace              ;
                        ret z                           ; Can't

                        push iy                         ;
                        pop ix                          ;

                        ld a,(ArrowCount)               ;
                        or a                            ;
                        ret z                           ;

                        dec a                           ;
                        ld (ArrowCount),a               ;

                        call AllocateProjSpace          ;

                        ld hl,(pMan)                    ;
                        ld a,(ArrDir)                   ;

                        call CDirect                    ;
                        cp 2                            ;
                        jr nz MFAr1                     ;

                        add hl,de                       ;
                        jp MFA0                         ;

MFAr1                   or a                            ;
                        jp z,MFA0                       ;

                        push af                         ;
                        push hl                         ;
                        pop iy                          ;
                        xor a                           ;
                        ex af,af'                       ;
                        xor a                           ;
                        ld (MFAr3B_SMC+2),a             ;
                        ld a,#80                        ;
                        ld (MFArOff1_SMC+2),a           ;

                        ld bc,128                       ;
                        add iy,bc                       ;

                        ld b,(ix+dp_Life)               ;
MFAr3                   add iy,de                       ;

MFArOff1_SMC            ld a,(iy-128)                   ;
                        and #FE                         ;
                        cp #DC                          ;
                        jr z,MFAr5                      ;

                        and #F8                         ;
                        cp #D0                          ;
                        jr z,MFAr5                      ;

                        and #F0                         ;
                        cp #90                          ;
                        jr nz,MFAr3B_SMC                ;

                        ex af,af'                       ;
                        jr nz,MFAr5                     ;

                        or #FF                          ;
                        ex af,af'                       ;
                        ld a,#0                         ;
                        ld (MFArOff1_SMC+2),a           ;

MFAr3B_SMC              ld a,(iy)                       ;
                        and #FE                         ;
                        cp #DC                          ;
                        jr z,MFAr5                      ;

                        and #F8                         ;
                        cp #D0                          ;
                        jr z,MFAr7                      ;

                        and #F0                         ;
                        cp #90                          ;
                        jr nz,MFAr3A                    ;

                        ex af,af'                       ;
                        jr nz,MFAr5                     ;

                        or #FF                          ;
                        ex af,af'                       ;

                        ld a,#80                        ;
                        ld (MFAr3B_SMC+2),a             ;

MFAr3A                  djnz MFAr3                      ;

                        jr MFAr5                        ;

        ; We need to tell the emulator about this revolting code!

        mem_smc MFArOff1_SMC+2,1
        mem_smc MFAr3B_SMC+2,1

MFAr7                   ld bc,128                       ;
                        add hl,bc                       ;

MFAr5                   pop af                          ;

MFA0                    ld (ix+dp_Off_L),e              ;
                        ld (ix+dp_Off_H),d              ;
                        ld (ix+dp_pMaze_L),l            ;
                        ld (ix+dp_pMaze_H),h            ;
                        ld (ix+dp_BackingChar),0        ;
                        ld (ix+dp_Life),ArrowLifeMan    ;

                        ; Set the character

                        bit 0,a                         ;

                        ld a,#A0                        ;
                        jr nz MFA1                      ;

                        inc a                           ;

MFA1                    ld (ix+dp_MissileChar),a

                        ld hl,MoveArrow                 ;
                        ld (ix+dp_pCode_L),l            ;
                        ld (ix+dp_pCode_H),h            ;

                        ld hl,#0505                     ;
                        ld (ix+dp_Delay),l              ;
                        ld (ix+dp_iDelay),h             ;

                        ld (ix+dp_pTarget2_H),0         ; Make sure we don't decrease the aim count

                        jp MoveProj_IX                  ;

MArr1                   ld (ix+dp_Life),0               ;
                        ret                             ;

MoveArrow               equ *

                        mNoiseON()                      ;

                        ld l,(ix+dp_pMaze_L)            ;
                        ld h,(ix+dp_pMaze_H)            ;
                        ld e,(ix+dp_Off_L)              ;
                        ld d,(ix+dp_Off_H)              ;
                        add hl,de                       ;
                        ld (ix+dp_pMaze_L),l            ;
                        ld (ix+dp_pMaze_H),h            ;

                        mNoiseOFF()                     ;

                        ld a,(hl)                       ;
                        cp #20                          ;
                        ret z                           ;

                        and #FE                         ;
                        cp #DC                          ;
                        jr z MArr1                      ;

                        and #F0                         ;
                        cp #90                          ;
                        jr z MArr1                      ;

                        ld a,(hl)                       ;
                        and #F8                         ;
                        cp #D0                          ;
                        jp z ArrowHitMon                ;

                        cp #A8                          ;
                        ret nz                          ;

                        ld a,(ix+dp_Life)               ;
                        ld (ix+dp_Life),0               ; Kill the arrow
                        add a,25                        ;

                        sra a                           ;

                        ; Fall into...

HitMan                  ld b,a                          ; Save damage

        if def bNoDamage
                        ret
        endif

                        ld a,(Wounds)                   ; Add it to the wounds
                        add a,b                         ;
                        ld (Wounds),a                   ;

                        ; High enough wounds to kill the man?

                        cp MaxWounds                    ; Dead yet?
                        ret c                           ; No, exit

                        ; By rights we're dead, but we will try healing...

HM_TryToHeal            call TryToHeal                  ; Try healing before we die
                        jr c HM_NoMagic                 ;

                        ; We healed, but was it enough?

                        ld a,(Wounds)                   ; Add it to the wounds
                        cp MaxWounds                    ; Still dead?
                        jp nc HM_TryToHeal              ; Yes, try healing again

                        ; We're alive now

                        ret                             ; Done

                ; We don't have enough magic to heal more

HM_NoMagic              ld a,(Wounds)                   ; Add it to the wounds
                        cp MaxWounds                    ; Still dead?
                        ret c                           ; Nope, done

                        ; Are we dead already?

                        ld a,(GameBType)                ; Dead
                        or a                            ;
                        ret m                           ; Yes, done

                        ; Kill the man

                        call UndrawMan                  ; Clear him from the maze

                        ; Now, if he's near a wall we need to move X

                        ld hl,(pMan)                    ; Get his position
                        ld de,128                       ;

                        ld (hl)," "                     ;
                        add hl,de                       ;
                        ld (hl)," "                     ;
                        ld de,-127                      ; Move back to head + 1 space to the right
                        add hl,de                       ;

                        ld a,(hl)                       ;
                        and $FE                         ; Door?
                        cp $DC                          ;
                        jr z HM_DeadMove                ; Yes, move

                        and $F0                         ;
                        cp $90
                        jr nz HM_PosOK                  ;

                        ; Move him left

HM_DeadMove             dec l                           ;
                        dec l                           ;
                        ld (pMan),hl                    ;

                        ld a,(ManOPosXY)                ;
                        dec a                           ;
                        ld (ManOPosXY),a                ;

HM_PosOK                ld hl,(pMan)                    ;
                        ld a,#A8                        ; Any man char
                        ld (hl),a                       ; Put it where his head is
                        inc l                           ;
                        ld (hl),a                       ; Put it where his feet are

                        ld a,%1 0000000                 ; Dead flag+time-out count
                        ld (GameBType),a                ; Yes

                        ; Remove the sodding sword

                        xor a                           ; Clear it
                        ld (SwdPhase),a                 ;

                        jp MSDoing                      ; Remove the sword, if necc.

; Man hit by a fireball

HitManFire              ld (ix+dp_Life),0               ; Kill the fireball

                        ld a,15                         ;
                        jr HitMan                       ;

; Man hit by lightning

HitManLight             ld a,10                         ;
                        jr HitMan                       ;

; Arrow [ix] hit monster

ArrowHitMon             ld a,70                         ;
                        ld b,#DF                        ;
                        ld (ix+dp_Life),0               ;

                        ; We've hit a monster at [hl] A = Damage, B = dead thing character.

HitMonster              ld c,a                          ;
                        ld a,b                          ;
                        ld (TempStore),a                ;

                        ld iy,MonsterList               ;
                        ld de,lMonst                    ;

                        ld b,nMonst                     ;

HMon1                   ld a,(iy+dm_pMaze_L)            ;
                        cp l                            ;
                        jr nz HMonNope                  ;

                        ld a,(iy+dm_pMaze_H)            ;
                        cp h                            ;
                        jr z HitThisMon                 ;

HMonNope                add iy,de                       ;
                        djnz HMon1                      ;

                        ; We haven't found this monster...

                        ld a,1                          ; Blue border
                        out ($FE),a                     ;

                        ret                             ; Ignore the problem???

                ; We've hit this one hl = pMaze

HitThisMon              ld a,(iy+dm_Wounds)             ;
                        sub c                           ;
                        ld (iy+dm_Wounds),a             ;

                        ret nc                          ; Not dead

                        ; Can't kill anything after we're dead

                        ld a,(GameBType)                ; Ignore if the player is dead
                        or a                            ;
                        ret m                           ;

                        ; We've killed this one

                        ld (iy+dm_Flags),#FF            ;

                        ld a,(TempStore)                ;
                        ld (hl),a                       ;
                        ld (iy+dm_Char),a               ;

                        mSCV_Out()                      ;

                        ld a,(iy+dm_iSpeed)             ;
                        ld (iy+dm_cSpeed),a             ;

                        ; We have another dead thing

                        ld hl,(nDTs)                    ; Count++
                        inc hl                          ;
                        ld (nDTs),hl                    ;

                        ret                             ;

; Setup to draw a line from DE to HL. Breshenhams... (Martin did this, I think)

InitLine                call ConvBM_To_XY_HL            ;

                        ; This is for when HL is already XY

InitLine_HLisXY         ld (iy+dp_pMaze_L),e            ;
                        ld (iy+dp_pMaze_H),d            ;
                        ld (iy+dp_dX),1                 ;
                        ld (iy+dp_dY),1                 ;

                        ex de,hl                        ;
                        call ConvBM_To_XY_HL            ;
                        ex de,hl                        ;

                        ld a,l                          ;
                        sub e                           ;
                        ld l,a                          ;
                        jp z ILine1A                    ;
                        jp p ILine1                     ;

                        neg                             ;
                        ld (iy+dp_dX),#FF               ;

ILine1                  ld e,a                          ;
                        ld a,h                          ;
                        sub d                           ;
                        ld h,a                          ;
                        jp z ILine2A                    ;
                        jp p ILine2                     ;

                        neg                             ;
                        ld (iy+dp_dY),#FF               ;

ILine2                  ld d,a                          ;
                        sub e                           ;
                        jr nc ILine3                    ;

                        ; dX > dY

                        ld (iy+dp_Life),e               ;
                        ld (iy+dp_ErrM),e               ;
                        sra e                           ;
                        ld (iy+dp_ErrR),e               ;
                        ld (iy+dp_ErrS),d               ;

                        call ILine4                     ;

                        ld (iy+dp_Off_L),l              ;
                        ld (iy+dp_Off_H),h              ;
                        ld (iy+dp_dY),0                 ;

                        call ILine4                     ;

                        ld (iy+dp_Step1_L),l            ;
                        ld (iy+dp_Step1_H),h            ;
                        ret                             ;

                ; dY > dX

ILine3                  ld (iy+dp_Life),d               ;
                        ld (iy+dp_ErrM),d               ;
                        sra d                           ;
                        ld (iy+dp_ErrR),d               ;
                        ld (iy+dp_ErrS),e               ;

                        call ILine4                     ;

                        ld (iy+dp_Off_L),l              ;
                        ld (iy+dp_Off_H),h              ;
                        ld (iy+dp_dX),0                 ;

                        call ILine4                     ;

                        ld (iy+dp_Step1_L),l            ;
                        ld (iy+dp_Step1_H),h            ;
                        ret                             ;

ILine1A                 ld (iy+dp_dX),0                 ;
                        jr ILine1                       ;

ILine2A                 ld (iy+dp_dY),0                 ;
                        jr ILine2                       ;

                ; dX/dY -> offset in HL

ILine4                  ld a,(iy+dp_dX)                 ;
                        cp #FF                          ;
                        jr z ILine4A                    ;

                        ld a,(iy+dp_dY)                 ;
                        cp #FF                          ;
                        jr z ILine4B                    ;

                        ; dX = 0/1 dY = 0/1

                        ld l,(iy+dp_dX)                 ; l = 0/1 (crem)
                        inc l                           ; l := 1 or 2
                        ld h,a                          ; h= 0/1
                        srl h                           ; >>
                        rr l                            ; >>
                        ret                             ;

                ; dX = -1

ILine4A                 ld a,(iy+dp_dY)                 ;
                        cp #FF                          ;
                        jr z ILine4AA                   ;

                        or a                            ;
                        jr z ILine4AB                   ;

                        ; dX = -1, dY = +1

                        ld hl,127                       ;
                        ret                             ;

ILine4AA                ld hl,-129                      ;
                        ret                             ;

ILine4AB                ld hl,-1                        ;
                        ret                             ;

ILine4B                 ld a,(iy+dp_dX)                 ;
                        ld hl,-128                      ;
                        or l                            ;
                        ld l,a                          ;
                        ret                             ;

; Mustn't alter BC

NextPoint               ld a,(iy+dp_Life)               ; 0?
                        or a                            ;
                        ccf                             ;
                        ret z                           ; Yes (CF)

                        dec a                           ;
                        ld (iy+dp_Life),a               ;

                        ; Calc next point

                        ld l,(iy+dp_pMaze_L)            ;
                        ld h,(iy+dp_pMaze_H)            ;

                        ld a,(iy+dp_ErrR)               ;
                        sub (iy+dp_ErrS)                ;
                        ld (iy+dp_ErrR),a               ;
                        jp p NextPoint1                 ;

                        ld e,(iy+dp_Off_L)              ;
                        ld d,(iy+dp_Off_H)              ;
                        add hl,de                       ;
                        ld (iy+dp_pMaze_L),l            ;
                        ld (iy+dp_pMaze_H),h            ;

                        ld a,(iy+dp_ErrR)               ;
                        add a,(iy+dp_ErrM)              ;
                        ld (iy+dp_ErrR),a               ;

                        or a                            ;
                        ret                             ;

NextPoint1              ld e,(iy+dp_Step1_L)            ;
                        ld d,(iy+dp_Step1_H)            ;
                        add hl,de                       ;
                        ld (iy+dp_pMaze_L),l            ;
                        ld (iy+dp_pMaze_H),h            ;

                        or a                            ;
                        ret                             ;

; Look for the nearest monster HL = position, A =  angle?? C = search range

MonsterSearch           ld ix,MonsterList               ; Make the first one the putative monster
       if false
                        ld hl,MonSRange                 ; Furthest one's distance = FF
                        ld (hl),#FF                     ;
       else
                        ld a,#FF                          ;
                        ld (MonSAimCnt),a               ;

       endif
                        ld b,nMonst                     ;

MonSearchLoop           bit 7,(ix+dm_Flags)             ; Alive?
                        jr nz,MonSNext                  ; No, skip

;                        bit 7,(ix+dm_Combat)            ; Already targetted?
;                        jr nz MonSNext                  ; Yes, ignore it

                        ld l,(ix+dm_pMaze_L)            ; Target
                        ld h,(ix+dm_pMaze_H)            ;

                        ld de,(pMan)                    ; Src

                        push bc                         ; Save
                        call RangeLook                  ; And look
                        pop bc                          ; Restore

                        jr c,MonSNext                   ; Not visible, skip

                if true
                        ; This monster is visible, d = range

                        ld a,(MonSAimCnt)               ; Has it been aimed at less?
                        ld e,(ix+dm_AimCnt)             ;
                        cp e                            ;
                        jr c NotThisOne

                        ; This one is nearer (or the same)

                        ld a,e                          ;
                        ld (MonSAimCnt),a               ;

                        ld (pNearMonster),ix            ;


                        ld d,(iy+dp_ErrM)               ; Get the distance
                        ld (MonSRange),a                ;

NotThisOne              equ *

               else

                        ; Is it nearer?

                        ld d,(iy+dp_ErrM)               ; Get the distance

                        ld a,(MonSRange)                ;
                        cp d                            ;
                        jr c,MonSNext                   ; No, skip

                        ; Yes, save this as the putative nearest one

                        ld a,d                          ;
                        ld c,a                          ; Don't bother looking further
                        ld (MonSRange),a                ;

                        ld (pNearMonster),ix            ;
                endif
                        ; Look at the next monster

MonSNext                ld de,lMonst                    ;
                        add ix,de                       ;

                        djnz MonSearchLoop              ;

                        ; Return the range to this monster

                        ld a,(MonSAimCnt)               ;
                        add a,1                         ;

                        ret                             ;

; NC means we can see the man, maybe through a door

RangeDoor               push de                         ;

                        ; QAD check for the range first

                        call ConvBM_To_XY_HL            ;
                        ex de,hl                        ;
                        call ConvBM_To_XY_HL            ;
                        ld a,e                          ;
                        sub l                           ;
                        jp p,RD1                        ;

                        neg                             ; See if dX
RD1                     cp c                            ;
                        jp p,RLFail_S                   ; dX > C

                        ld a,d                          ;
                        sub h                           ;
                        jp p,RD2                        ;

                        neg                             ;
RD2                     cp c                            ;
                        jp p,RLFail_S                   ; dY > C

                        ex de,hl                        ;
                        pop de                          ;

                        ; Now, it's in range, so draw the line

                        xor a                           ;
                        ld (DoorFlag),a                 ;

                        ; Now, it's in range, so draw the line

                        call InitLine_HLisXY            ;

                        ; Move to the first point on the line

                        call NextPoint                  ;
                        ccf                             ;
                        ret nc                          ; Done, exit

                        ; First point on the line. Is it a door?

                        ld a,(hl)                       ;
                        and #FE                         ;
                        cp #DC                          ;
                        jr z,RDFDoor                    ; Door

                        and #F0                         ;
                        cp #90                          ;
                        jr z,RLFail                     ; Wall

                        ; We've done the first point, do the rest

                        jp RL_Lp                        ; As below

                  ; Door

RDFDoor                 ld (DoorFlag),a                 ;

                        jp RL_Lp                        ; Next

; DE = src, HL = target, c = max range
; Used to return d=dp_ErrM (range), but doesn't now...

RangeLook               push de                         ;

                        call ConvBM_To_XY_HL            ;
                        ex de,hl                        ;
                        call ConvBM_To_XY_HL            ;
                        ld a,e                          ;
                        sub l                           ;
                        jp p,RL1                        ;

                        neg                             ; See if dX
RL1                     cp c                            ;
                        jp p,RLFail_S                   ; dX > C

                        ld a,d                          ;
                        sub h                           ;
                        jp p,RL2                        ;

                        neg                             ;
RL2                     cp c                            ;
                        jp p,RLFail_S                   ; dY > C

                        ex de,hl                        ;
                        pop de                          ;

                        ; Now, it's in range, so draw the line

                        call InitLine_HLisXY            ;

                        ; Look along the line

RL_Lp                   call NextPoint                  ;
                        ccf                             ;
                        ret nc                          ; Done, exit

                        ; Any point on the line

                        ld a,(hl)                       ; Get the char

                        and #FE                         ;
                        cp #DC                          ;
                        scf                             ;
                        ret z                           ; Hit a door

                        and $F0                         ; Wall?
                        cp #90                          ;
                        jp nz RL_Lp                     ; No, loop

                        ; Failed

RLFail                  scf                             ;
                        ret                             ;

RLFail_S                pop de                          ;

                        scf                             ;
                        ret                             ;

; See if we want to fire a fireball

FireBall                ld hl,KeyFireP                  ;
                        call ReadAKey                   ;
                        ret z                           ;

                        call FindProjSpace              ;
                        ret z                           ;

                        ld a,(CurrentMagic)             ; Enough magic?
                        sub 2                           ;
                        ret c                           ;

                        mAddNoise(1)                    ;

                        ld c,FBSR                       ;

                        call MonsterSearch              ;
                        ld (iy+dp_Life),0               ; Kill it
                        ret c                           ; Nothing to fire at

                        ; We have a target

                        ld ix,(pNearMonster)            ; HL = target
                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;

                        ld de,(pMan)                    ; DE = Source

                        ld a,(CurrentMagic)             ; Dec the magic
                        sub 2                           ;
                        ld (CurrentMagic),a             ;

                        set 7,(ix+dm_Combat)            ;
                        inc (ix+dm_AimCnt)              ;
                        call InitLine                   ;

                        ld hl,MoveFire                  ;
                        ld (iy+dp_pCode_L),l            ;
                        ld (iy+dp_pCode_H),h            ;

                        ld (iy+dp_MissileChar),#A4

                        ld (iy+dp_Delay),FireSpeedInit
                        ld (iy+dp_iDelay),FireSpeedInit

                        ld (iy+dp_BackingChar),0        ;
                        ld (iy+dp_Life),FireLife        ;
                        call AllocateProjSpace          ;

                        ; The address of the man's pMaze

                        ld hl,pMan                      ;
                        ld (iy+dp_pOwner_L),l           ;
                        ld (iy+dp_pOwner_H),h           ;

                        ld a,ixl                        ;
                        ld (iy+dp_pTarget_L),a          ;
                        ld (iy+dp_pTarget2_L),a         ;
                        ld a,ixh                        ;
                        ld (iy+dp_pTarget_H),a          ;
                        ld (iy+dp_pTarget2_H),a         ;

                        ld (iy+dp_ManF),1               ;

                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        ld (iy+dp_TargetiPos_L),l       ;
                        ld (iy+dp_TargetiPos_H),h       ;

                        ld (iy+dp_UpdateRate),FireTurnRate;
                        ret                             ;

; Man hit by fireball

MFire1                  ld (ix+dp_Life),0               ; Kill the fireball

                        ; We must clear the combat flag on the target of this projectile

Proj_Clear_CombatFlag   ld d,(ix+dp_pTarget2_H)         ; Get the Target2 pointer
                        dec d                           ; 0?
                        inc d                           ;
                        ret z                           ; Yes, ignore it

                        ; We presume the pointer is valid

                        ld e,(ix+dp_pTarget2_L)         ;

                        ld (ix+dp_pTarget2_H),0         ; Don't do this twice

                        ; Assuming this is a thing we clear its combat flag

                        push hl                         ; Save

                        ld hl,dm_Combat                 ; Move to it
                        add hl,de                       ;

                        res 7,(hl)                      ; Clear it

                        ld de,dm_AimCnt-dm_Combat       ; Move to it
                        add hl,de                       ;

                        dec (hl)                        ; Reduce it

                        pop hl                          ;
                        ret                             ;

MoveFire                ld a,(ix+dp_Life)               ;
                        inc a                           ;
                        ld (ix+dp_Life),a               ;

;                        ld a,(ix+dp_MissileChar)        ;
;                        inc a                           ;
;                        ld a,r                          ;
                        and #3                          ;
                        or #A4                          ;
                        ld (ix+dp_MissileChar),a        ;

                        push ix                         ;
                        pop iy                          ;
                        dec (iy+dp_UpdateRate)          ;
                        jr nz MoveFireTM1               ;

                        ; Time to update

                        ld a,(iy+dp_iDelay)             ;
                        dec a                           ;
                        cp FireSpeedFast+1              ;
                        jr c MF_NSU                     ;

                        ld (iy+dp_iDelay),a             ;

MF_NSU                  mNoiseON()                      ;

                        ld (iy+dp_UpdateRate),FireTurnRate ;
                        ld l,(iy+dp_pTarget_L)          ;
                        ld h,(iy+dp_pTarget_H)          ;
                        ld e,(hl)                       ;
                        inc hl                          ;
                        ld d,(hl)                       ;
                        ld l,(iy+dp_TargetiPos_L)
                        ld h,(iy+dp_TargetiPos_H)

                        mNoiseOFF()                     ;

                        or a                            ;
                        sbc hl,de                       ;
                        jp nz MoveFireTM                ; It has moved

                        ; Move along the current line

MoveFireTM1             call NextPoint                  ;
                        jr c MFire1                     ;

                        ld a,(hl)                       ;
                        cp #20                          ;
                        ret z                           ;

                        and #FE                         ;
                        cp #DC                          ;
                        jr z MFire1                     ;

                        and #F0                         ;
                        cp #90                          ;
                        jr z MFire1                     ;

                        ld a,(hl)                       ;
                        and #F8                         ;
                        cp #D0                          ;
                        jr z HFireMon                   ;

                        cp #A8                          ; Is this the man?
                        ret nz                          ; No, exit

                        ; We have hit the man

                        ld a,(iy+dp_ManF)               ; Was this fired by a monster?
                        or a                            ;
                        jp z HitManFire                 ; Yes, hit him

                        ; No, it was fired by the man

                        ld a,FireLife                   ; In the first few moves?
                        sub (iy+dp_Life)                ;
                        cp ManDodgeTime                 ;
                        ret c                           ; Yes, ignore

                        ; We should have dodged. Hit him...

                        jp HitManFire                   ;

                ; We want to try to aim again

MoveFireTM              ld a,(iy+dp_Life)               ;
                        push af                         ;

                        ld (iy+dp_TargetiPos_L),e
                        ld (iy+dp_TargetiPos_H),d
                        ld l,(iy+dp_pMaze_L)            ;
                        ld h,(iy+dp_pMaze_H)            ;
                        ex de,hl                        ;

                        call InitLine                   ;

                        ld hl,MoveFire                  ;
                        ld (iy+dp_pCode_L),l            ;
                        ld (iy+dp_pCode_H),h            ;

                        pop af                          ;
                        ld (iy+dp_Life),a               ;

                        jp MoveFireTM1                  ;

                ; We've hit a monster. But is it the one that fired this in the first place?

HFireMon                ld a,(iy+dp_ManF)               ; Was this fired by the man?
                        or a                            ;
                        jp nz HitMonFire                ; Yes, so cause damage.

                        ; See if it has shot itself

                        ld l,(iy+dp_pOwner_L)           ; Get the owner's address
                        ld h,(iy+dp_pOwner_H)           ;

                        ; HL points at the thing that fired it's pMaze

                        ld e,(hl)                       ;
                        inc hl                          ;
                        ld d,(hl)                       ;

                        ; DE is now the address of the thing that fired it
                        ; Is this the same as the address of the projectile?

                        ld l,(iy+dp_pMaze_L)            ;
                        ld h,(iy+dp_pMaze_H)            ;
                        ex de,hl                        ;
                        or a                            ;
                        sbc hl,de                       ;
                        ex de,hl                        ;
                        jp nz HitMonFire                ; No, so cause damage.

                        ; Is it in the first few moves?

                        ld a,FireLife                   ;
                        sub (iy+dp_Life)                ;
                        cp DodgeTime                    ;
                        ret c                           ; Yes, so don't cause damage

                        ; No, so damage it

HitMonFire              ld a,FireDamageToMon            ;
                        ld b,#E0                        ;
                        call MFire1                     ;

                        jp HitMonster                   ;

; Should we try lightning?

Lightning               ld a,(ManLightDel)              ; Delay between firing?
                        or a                            ;
                        ret nz                          ;

                        ld a,(GameType)                 ; Fire if this is NZ
                        ld b,a                          ;

                        ld a,(KeyLight)                 ; Or if this is NZ
                        or b                            ;
                        ret z                           ;

                        call FindProjSpace              ;
                        ret z                           ;

                        ld c,XW+7                       ; Shorter viewing distance
                        ld a,(GameType)                 ; No cost if this is NZ
                        or a                            ;
                        jr nz ManLight1                 ;

                        ld a,(CurrentMagic)             ;
                        sub 1                           ;
                        ret c                           ;

                        ld c,LtSR                       ;

ManLight1               call MonsterSearch              ;
                        ld (iy+dp_Life),0               ;
                        ret c                           ;

                        ld ix,(pNearMonster)            ;
                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        ld de,(pMan)                    ;

                        inc (ix+dm_AimCnt)              ; We're firing at it

                        mAddNoise(1)                    ;

                        ld a,(GameType)                 ; No cost if this is NZ
                        or a                            ;
                        jr nz ManLight2                 ;

                        ld a,(CurrentMagic)             ;
                        dec a                           ;
                        ld (CurrentMagic),a             ;

ManLight2               call InitLine                   ;

                        ld hl,MoveLight                 ;
                        ld (iy+dp_pCode_L),l            ;
                        ld (iy+dp_pCode_H),h            ;

                        ld (iy+dp_MissileChar),#A2
                        ld (iy+dp_BackingChar),0

                        ld hl,(LightLife << 8) + LightSpeed          ; Running game lifetime

                        ld a,(GameType)                 ; No cost if this is NZ
                        or a                            ;
                        jr z ManLight3                  ;

                        ld hl,(LightLifeRunning << 8) + LightSpeedRunning          ; Running game lifetime

ManLight3               ld (iy+dp_Life),h               ;
                        ld (iy+dp_Delay),l              ;
                        ld (iy+dp_iDelay),l             ;

                        call AllocateProjSpace          ;

                        ld hl,pMan                      ;
                        ld (iy+dp_pOwner_L),l           ;
                        ld (iy+dp_pOwner_H),h           ;

                        ld a,ixl                        ;
                        ld (iy+dp_pTarget_L),a          ;
                        ld (iy+dp_pTarget2_L),a         ;
                        ld a,ixh                        ;
                        ld (iy+dp_pTarget_H),a          ;
                        ld (iy+dp_pTarget2_H),a         ;

                        ld (iy+dp_ManF),1               ;

                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        ld (iy+dp_TargetiPos_L),l       ;
                        ld (iy+dp_TargetiPos_H),h       ;

                        ld a,(GameType)                 ; Faster repeat rate in the running game
                        add a,a                         ; 0/2
                        ld b,a                          ;
                        ld a,4                          ; 4 or 2 if running game
                        sub b                           ;
                        ld (ManLightDel),a              ;

                        ret                             ;

MoveLight               inc (ix+dp_Life)                ;

                        ld a,r                          ; Random sparkle
                        and $01                         ;
                        or $A2                          ;

                        ld (ix+dp_MissileChar),a

MoveCelebrate           push ix                         ;
                        pop iy                          ;

                        ld a,(iy+dp_ErrR)               ;
                        ld (iy+dp_RSave),a              ;
                        ld a,(iy+dp_pMaze_L)            ;
                        ld (iy+dp_pMazeSave_L),a        ;
                        ld a,(iy+dp_pMaze_H)            ;
                        ld (iy+dp_pMazeSave_H),a        ;

                        ; Move to next point

                        ld a,4                          ; We're allowed to bounce 4 times (prevents lock-up)
                        ld (LightBounceCnt),a           ;

MLRf0                   ld a,(LightBounceCnt)           ; Dec this
                        dec a                           ;
                        jr z ML_Kill                    ; Kill it
                        ld (LightBounceCnt),a           ;

                        call NextPoint                  ;
                        ret c                           ;

                        ld a,(hl)                       ;
                        cp #20                          ;
                        ret z                           ;

                        and #FE                         ;
                        cp #DC                          ;
                        jp z MLightRefl                 ;

                        and #F0                         ;
                        cp #90                          ;
                        jp z MLightRefl                 ;

                        ld a,(hl)                       ;
                        and #F8                         ;
                        cp #D0                          ;
                        jr z HLightMon                  ;

                        cp #A8                          ; Man character?
                        ret nz                          ;

                        ; We have hit the man

                        ld a,(iy+dp_ManF)               ; Was this fired by a monster?
                        or a                            ;
                        jp z HitManLight                ; Yes, hit him

                        ; No, it was fired by the man

                        ld a,(GameType)                 ; We ignore this if in the running game
                        or a                            ;
                        ret nz                          ;

                        ; In a normal game we hurt after the start

                        ld a,LightLife                  ; In the first few moves?
                        sub (iy+dp_Life)                ;
                        cp ManDodgeTime                 ;
                        ret c                           ; Yes, ignore

                        ; We should have dodged. Hit him...

                        jp HitManLight                  ;

ML_Kill                 ld (iy+dp_Life),0               ; Kill it
                        ret                             ;

                ; We've hit a monster. But is it the one that fired this in the first place?

HLightMon               ld a,(iy+dp_ManF)               ; Was this fired by the man?
                        or a                            ;
                        jp nz HitMonLight               ; Yes, so cause damage.

                        ; See if it has shot itself

                        ld l,(iy+dp_pOwner_L)           ; Get the owner's pMaze address
                        ld h,(iy+dp_pOwner_H)           ;

                        ; HL points at the thing that fired pMaze

                        ld e,(hl)                       ;
                        inc hl                          ;
                        ld d,(hl)                       ;

                        ; DE is now the address of the thing that fired it
                        ; Is this the same as the address of the projectile?

                        ld l,(iy+dp_pMaze_L)            ;
                        ld h,(iy+dp_pMaze_H)            ;
                        ex de,hl                        ;
                        or a                            ;
                        sbc hl,de                       ;
                        ex de,hl                        ;
                        jp nz HitMonLight               ; No, different monster, so cause damage.

                        ; Is it in the first three moves?

                        ld a,LightLife                  ;
                        sub (iy+dp_Life)                ;
                        cp DodgeTime                    ;
                        ret c                           ; Yes, so don't cause damage

                        ; No, so damage it

HitMonLight             ld a,LightDamageToMon           ;
                        ld b,#E0                        ;
                        jp HitMonster                   ;

MLightRefl              mNoiseON()                      ;

                        ld a,(iy+dp_RSave)              ;
                        ld (iy+dp_ErrR),a               ;

                        ld e,(iy+dp_pMazeSave_L)        ;
                        ld (iy+dp_pMaze_L),e            ;
                        ld d,(iy+dp_pMazeSave_H)        ;
                        ld (iy+dp_pMaze_H),d            ;

                        inc (iy+dp_Life)                ;

                        ld l,(iy+dp_Step1_L)            ;
                        ld h,(iy+dp_Step1_H)            ;
                        add hl,de                       ;

                        mNoiseOFF()                     ;

                        call TestWall                   ;
                        jp nz MLRf1                     ;

                        ld l,(iy+dp_Step1_L)            ;
                        ld h,(iy+dp_Step1_H)            ;
                        push de                         ;
                        ld de,0                         ;
                        ex de,hl                        ;
                        or a                            ;
                        sbc hl,de                       ;
                        ld (iy+dp_Step1_L),l            ;
                        ld (iy+dp_Step1_H),h            ;
                        pop de                          ;

MLRf1                   ld a,(iy+dp_ErrS)               ;
                        or a                            ;
                        jp z MLRf0                      ;

                        xor a                           ;
                        ex af,af'                       ;
                        ld l,(iy+dp_Off_L)              ;
                        ld h,(iy+dp_Off_H)              ;

                        push hl                         ;
                        call Separate                   ;
                        ex (sp),hl                      ;
                        call RTest2                     ;
                        pop bc                          ;
                        call RTest2                     ;

                        ld (iy+dp_Off_L),l              ;
                        ld (iy+dp_Off_H),h              ;
                        ex af,af'                       ;
                        or a                            ;
                        jp nz,MLRf0                     ;

                        ld e,(iy+dp_Off_L)              ;
                        ld d,(iy+dp_Off_H)              ;
                        ld hl,0                         ;
                        or a                            ;
                        sbc hl,de                       ;

                        ld (iy+dp_Off_L),l              ;
                        ld (iy+dp_Off_H),h              ;
                        ld e,(iy+dp_Step1_L)            ;
                        ld d,(iy+dp_Step1_H)            ;
                        ld hl,0                         ;
                        or a                            ;
                        sbc hl,de                       ;
                        ld (iy+dp_Step1_L),l            ;
                        ld (iy+dp_Step1_H),h            ;

                        jp MLRf0                        ;

TestWall                ld a,(hl)                       ;

                        and #FE                         ;
                        cp #DC                          ;
                        ret z                           ;

                        and #F0                         ;
                        cp #90                          ;
                        ret                             ;

RTest2                  push hl                         ;

                        ld h,b                          ;
                        ld l,c                          ;

                        add hl,de                       ;
                        call TestWall                   ;

                        pop hl                          ;
                        ret nz                          ;

                        or a                            ;
                        sbc hl,bc                       ;

                        or a                            ;
                        sbc hl,bc                       ;

                        ld a,1                          ;

                        ex af,af'                       ;
                        ret                             ;

Separate                bit 7,h                         ;

                        ld bc,-128                      ;
                        jr nz,Sep1                      ;

                        ld bc,128                       ;

Sep1                    bit 6,l                         ;
                        ld hl,-1                        ;

                        jr nz,Sep2                      ;

                        ld hl,1                         ;
Sep2                    ret                             ;

; See if QUIT is pressed (Z if so)

CheckQuit               ld bc,$FBFE                     ; Q&T
                        in a,(c)                        ;
                        and %000 1 1 1 1 1              ;
                        cp  %000 0 1 1 1 0              ;
                        ret nz                          ;

                        ld bc,$DFFE                     ; U&I
                        in a,(c)                        ;
                        and %000 1 1 1 1 1              ;
                        cp  %000 1 0 0 1 1              ;
                        ret                             ;

; See if JOKE is pressed (Z if so)

CheckJOKE               ld bc,$BBFE                     ; J&K
                        in a,(c)                        ;
                        and %000 1 1 1 1 1              ;
                        cp  %000 1 0 0 1 1              ;
                        ret nz                          ;

                        ld bc,$FBFE                     ; E
                        in a,(c)                        ;
                        and %000 1 1 1 1 1              ;
                        cp  %000 1 1 0 1 1              ;
                        ret nz                          ;

                        ld bc,$DFFE                     ; O
                        in a,(c)                        ;
                        and %000 1 1 1 1 1              ;
                        cp  %000 1 1 1 0 1              ;
                        ret                             ;

; Scan the keys every other time we're called

GameScanKeys            ld a,(KeyFlag)                  ;
                        inc a                           ;
                        ld (KeyFlag),a                  ;

                        and 1                           ;
                        ret nz                          ;

                        ; Is this the alternate arrangement?

                        ld a,(DType)                    ; Get the flag
                        or a                            ;
                        jp nz GSK_Alternate             ; Skip

                        ; Standard layout

GSK_Standard            ld bc,65022                     ; A
                        in a,(c)                        ;
                        bit 0,a                         ;
                        ld hl,KeyArrow                  ;
                        call DWKey                      ;

                        ld bc,49150                     ; L
                        in a,(c)                        ;
                        bit 1,a                         ;
                        ld hl,KeyLight                  ;
                        call DWKey                      ;

                        ld bc,65022                     ; F -> Fire
                        in a,(c)                        ;
                        bit 3,a                         ;
                        ld hl,KeyFire                   ;
                        call DWKey                      ;

                        ld bc,65022                     ; D
                        in a,(c)                        ;
                        bit 2,a                         ;
                        ld hl,KeyDrop                   ;
                        call DWKey                      ;

                        ld bc,65278                     ; C
                        in a,(c)                        ;
                        bit 3,a                         ;
                        ld hl,KeyClose                  ;
                        call DWKey                      ;

                        ld bc,65022                     ; S
                        in a,(c)                        ;
                        bit 1,a                         ;
                        ld hl,KeySword                  ;
                        call DWKey                      ;

                        ; These are common to both layouts

GSK_Common              ld bc,49150                     ; L
                        in a,(c)                        ;
                        bit 1,a                         ;
                        ld hl,KeyLight                  ;
                        call DWKey                      ;

                        ld bc,32766                     ; SP
                        in a,(c)                        ;
                        bit 0,a                         ;
                        ld hl,Keysp                     ;
                        call DWKey                      ;

                        ld bc,63486                     ; 1
                        in a,(c)                        ;
                        bit 0,a                         ;
                        ld hl,Key1                      ;

                        call DWKey                      ;

                        ld bc,$F7FE                     ; 2
                        in a,(c)                        ;
                        bit 1,a                         ;
                        ld hl,Key2                      ;

                        call DWKey                      ;

                        ld bc,$DFFE                     ; P
                        in a,(c)                        ;
                        bit 0,a                         ;
                        ld hl,KeyPortal                 ;

                        ; Fall into...

DWKey                   jr nz KillDWKey                 ; Skip if not pressed

                        ; It's pressed

                        ld a,(hl)                       ; Has it been reported?
                        or a                            ;
                        ret nz                          ; Yes, exit

                        ; No, set the pressed flag

                        inc a                           ; A = 1
                        ld (hl),a                       ; Set pressed now
                        inc hl                          ;
                        ld (hl),a                       ; Set has been pressed

                        ret                             ;

                ; Key not pressed, clear the pressed flag (but not the has pressed flag)

KillDWKey               xor a                           ;
                        ld (hl),a                       ;
                        ret                             ;

                ; Alternate layout

GSK_Alternate           ld bc,49150                     ; K -> Fire
                        in a,(c)                        ;
                        bit 2,a                         ;
                        ld hl,KeyFire                   ;
                        call DWKey                      ;

                        ld bc,49150                     ; J -> Arrow
                        in a,(c)                        ;
                        bit 3,a                         ;
                        ld hl,KeyArrow                  ;
                        call DWKey                      ;

                        ld bc,$7FFE                     ; N -> Drop
                        in a,(c)                        ;
                        bit 2,a                         ;
                        ld hl,KeyDrop                   ;
                        call DWKey                      ;

                        ld bc,$7FFE                     ; M -> Close
                        in a,(c)                        ;
                        bit 3,a                         ;
                        ld hl,KeyClose                  ;
                        call DWKey                      ;

                        ld bc,$DFFE                     ; I -> Sword
                        in a,(c)                        ;
                        bit 2,a                         ;
                        ld hl,KeySword                  ;
                        call DWKey                      ;

                        jp GSK_Common                   ; Same

; See if a key has been pressed - return nz if so

ReadAKey                ld a,(hl)                       ; Has it been pressed?
                        or a                            ;
                        ret z                           ; Return if not as Z

                        ld a,0                          ; Clear the flag
                        ld (hl),a                       ;
                        ret                             ; Return NZ

; Draw the side wall around bigmaze

SideWall                ld ix,BigMaze+#70               ;
                        ld (ix),#96                     ;

                        ld b,#70                        ;
                        ld de,#80                       ;

SWallLP                 add ix,de                       ;
                        ld (ix),#9C                     ;

                        ld a,(ix-1)                     ;
                        and #F0                         ;
                        cp #90                          ;
                        jr nz SWallLPE                  ;

                        set 1,(ix)                      ;
SWallLPE                djnz SWallLP                    ;

                        ld (ix),#9A                     ;

                        ; Now, add the door to the inner wall

                        ld a,(cFloor)                   ;
                        and #7                          ;
                        ret z                           ; Not on the bottom

                        inc a                           ;
                        ld b,a                          ;

                        ld hl,TopLeftSanc+14207         ;
                        ld de,-896                      ;

SancDoor                add hl,de                       ;
                        djnz SancDoor                   ;

                        ld (hl),#94                     ;
                        ld b,4                          ;
                        ld de,-128                      ;

SancD1                  add hl,de                       ;
                        ld (hl),#90                     ;

                        djnz SancD1                     ;

                        add hl,de                       ;
                        ld (hl),#98                     ;
                        ret                             ;

; a := h mod 7

Bound7                  push hl                         ;

                        ld c,7                          ; / 7
                        call Div                        ;

                        ld a,h                          ; * 7
                        add a,a                         ;
                        add a,a                         ;
                        add a,a                         ;
                        sub h                           ;
                        pop hl                          ;
                        ret                             ;

Div                     xor a                           ;
                        ld b,8                          ;

DivLoop                 sla h                           ;
                        rla                             ;
                        cp c                            ;
                        jr c DivLoopE                   ;

                        sub c                           ;
                        inc h                           ;

DivLoopE                djnz DivLoop                    ;

                        ret                             ;

; Show the build progressing

ShowProgress            ld a,(ShowProgX)                ; Move across
                        inc a                           ;
                        ld (ShowProgX),a                ;
                        and $1F                         ;
                        ld l,a                          ;

                        ld a,4                          ; Get a position
                        call RandRange                  ;

                        add a,19                        ; Avoid the titles
                        ld h,a                          ;

                        ; Add a thing

                        ld a,(cFloor)                   ;
                        add a,#D0                       ; Show a thing
                        call OutIt                      ;

                        ret

; Generate all 8 floors of the maze

Gen8                    ld a,1                          ; Flag that we are building the tower
                        ld (bBuilding),a                ;

                        xor a                           ; Setup to show the user
                        ld (BuildPhase),a               ;

                        ld hl,RingTab+drt_Floor         ; Point at the floor
                        ld (hl),0                       ; None on the first floor

                        ld b,7                          ; We have seven rings to place

Gen8R                   loop lRingTable                 ; Skip this entry
                          inc hl                        ;
                          lend                          ;

                        ld a,7                          ; Get a floor number 0..6
                        call RandRange                  ;
                        inc a                           ; -> 1..7
                        ld (hl),a                       ; Put this ring [hl] on this floor.

                        djnz Gen8R                      ; Loop

                        ; We now have the 7 rings on seven random floors

                        ld hl,0                         ; 0
                        ld a,l                          ;
                        ld (nDTs),hl                    ;
                        ld (cFloor),a                   ;
                        ld (nRings),a                   ;

                        ; Loop for each floor

Gen8A                   call gpMazeList                 ; Point at the definition

                        ; Store the seed to generate it

                if true
                        ex de,hl
                        ld hl,Seed
                        ld bc,4
                        ldir
                        ex de,hl
                else
                        ld de,(Seed)                    ;
                        ld (hl),e                       ;
                        inc hl                          ;
                        ld (hl),d                       ;
                        inc hl                          ;

                        ld de,(Seed+2)                  ;
                        ld (hl),e                       ;
                        inc hl                          ;
                        ld (hl),d                       ;
                        inc hl                          ;
                endif
                        call BuildTheMaze               ;
                        call ShowProgress               ;

                        call DrawBigmaze                ;
                        call ShowProgress               ;

                        call InitMonsters               ;

                        call InitTreasure               ;

                        call InitMagic                  ;

                        call SaveFloor                  ;
                        call ShowProgress               ;

                        ; Now, find somewhere for all the rings that are on this floor...

                        ld a,(cFloor)                   ; The current floor
                        and #7                          ;

                        ld iy,RingTab                   ; Search the ring table
                        ld b,8                          ;

Gen8RA                  cp (iy+drt_Floor)               ; On this floor?
                        call z DefRing                  ; Yes, find somewhere for it

                        loop lRingTable                 ; Skip to next
                          inc iy                        ;
                          lend                          ;

                        djnz Gen8RA                     ; Loop

                        ; Loop to next floor

                        inc a                           ;
                        ld (cFloor),a                   ;
                        cp 8                            ;
                        jr nz Gen8A                     ;

                        ; Finished building

                        xor a                           ; Flag that we are not building the tower
                        ld (bBuilding),a                ;

                        ret                             ;

                ; This ring is on this floor. Find somewhere for it

DefRing                 push af                         ;
                        push bc                         ;

DefRing1                call FindPosition               ; Find an empty square in the maze

                        push hl                         ; Save
                        call ConvBM_To_XY_HL            ; See what the X is...
                        ld a,l                          ; Is it far enough to the LHS?
                        pop hl                          ; Restore

                        cp 30                           ;
                        jr nc DefRing1                  ; Too far to the right - try another position

                        ; Mark that there is a ring here...

                        ld (iy+drt_pMaze_L),l           ; Save the putative position
                        ld (iy+drt_pMaze_H),h           ;
                        ld (hl),#8F                     ;

                        pop bc                          ;
                        pop af                          ;
                        ret                             ;

; Point at the maze list for this floor

gpMazeList              ld a,(cFloor)                   ; 512 bytes per floor
                        and #7                          ;
                        add a,a                         ;
                        ld d,a                          ;
                        ld e,0                          ;

                        ld hl,MazeList                  ;
                        add hl,de                       ;

                        ret                             ;

; Save the state of a floor
; There is an undetected failure case here - if there's too much treasure on a level it explodes
; ie you can kill the game by taking treasure from one floor to another (not the hall, that's safe)

SaveFloor               call gpMazeList                 ;

                        inc hl                          ; Skip the random seed
                        inc hl                          ;
                        inc hl                          ;
                        inc hl                          ;

                        ; Now, add the monsters

                        ld ix,MonsterList               ;
                        ld de,lMonst                    ;
                        ld b,nMonst                     ;

SFloor1                 ld a,(ix+dm_pMaze_L)            ; PtrL
                        ld (hl),a                       ;
                        inc hl                          ;
                        ld a,(ix+dm_pMaze_H)            ; PtrH
                        ld (hl),a                       ;
                        inc hl                          ;
                        ld a,(ix+dm_Char)               ; Char
                        ld (hl),a                       ;
                        inc hl                          ;
                        ld a,(ix+dm_Flags)              ; Bit 7 of Flags + MoveType
                        and #80                         ;
                        or (ix+dm_MoveType)             ;
                        ld (hl),a                       ;
                        inc hl                          ;

                        add ix,de                       ;

                        djnz SFloor1                    ;

                        ; Now, add anything from B0 .. CF (Treasure and Magic)

                        ld de,BigMaze                   ;
                        ld c,#70                        ;
SFloor2                 ld b,#70                        ;

SFloor3                 ld a,(de)                       ;
                        and #F0                         ;
                        cp #B0                          ;
                        jr c SFloor3A                   ;

                        cp #D0                          ;
                        jr nc SFloor3A                  ;

                        ld a,(de)                       ;
                        ld (hl),e                       ;
                        inc hl                          ;
                        ld (hl),d                       ;
                        inc hl                          ;
                        ld (hl),a                       ;
                        inc hl                          ;

SFloor3A                inc de                          ; Loop across X
                        djnz SFloor3                    ;

                        ; Skip the outside of the tower

                        push hl                         ;
                        ld hl,#10                       ;
                        add hl,de                       ;
                        ex de,hl                        ;
                        pop hl                          ;

                        dec c                           ; Loop down Y
                        jr nz SFloor2                   ;

                        ; Add a terminator

                        ld (hl),0                       ;
                        inc hl                          ;
                        ld (hl),0                       ;
                        inc hl                          ;
                        ld (hl),0                       ;
                        ret                             ;

; Recreate a floor

Recreate                call gpMazeList                 ;

                        ld de,Seed                      ;
                        ld bc,4                         ;
                        ldir                            ;

                        push hl                         ;

                        call BuildTheMaze               ;

                        call DrawBigmaze                ;

                        call InitMonsters               ;

                        pop iy                          ;

                        ld ix,MonsterList               ;
                        ld de,lMonst                    ;
                        ld b,nMonst                     ;

Rec1                    ld l,(iy+dml_pMaze_L)           ;
                        ld h,(iy+dml_pMaze_H)           ;
                        ld a,(hl)                       ;
                        cp #20                          ;
                        ld (ix+dm_pMaze_L),l            ;
                        ld (ix+dm_pMaze_H),h            ;

                        call nz OpenIfNess              ;

                        ld a,(iy+dml_Char)              ;
                        ld (ix+dm_Char),a               ;

                        ld a,(iy+dml_MoveType)          ; 7 bits of move type
                        and $7F                         ;
                        ld (ix+dm_MoveType),a           ;
                        ld a,(iy+dml_MoveType)          ;

                        inc iy                          ;
                        inc iy                          ;
                        inc iy                          ;
                        inc iy                          ;

                        and #80                         ; Set the dead flag
                        or (ix+dm_Flags)                ;
                        ld (ix+dm_Flags),a              ;

                        add ix,de                       ;

                        djnz Rec1                       ;

Rec2                    ld l,(iy)                       ;
                        inc iy                          ;
                        ld h,(iy)                       ;
                        inc iy                          ;
                        ld a,(iy)                       ;
                        inc iy                          ;

                        or a                            ;
                        jr z Rec3                       ;

                        ld a,(hl)                       ;
                        cp " "                          ;
                        call nz OpenIfNess              ;

                        ld a,(iy-1)                     ;
                        ld (hl),a                       ;

                        jr Rec2                         ;

Rec3                    equ *

                        call InitProjList               ; Clear the projectiles

                        ; Place any rings that are on this floor

                        ld ix,RingTab                   ; Point at them
                        ld b,8                          ; There are 8
                        ld c,#88                        ; First character
                        ld a,(cFloor)                   ; The current floor

Rec4                    cp (ix+drt_Floor)               ; Is this ring on this floor?
                        jr nz Rec5                      ; No, skip

                        ld l,(ix+drt_pMaze_L)           ; Get the address
                        ld h,(ix+drt_pMaze_H)           ; Get the address
                        ld (hl),c                       ; Plant this ring

Rec5                    inc c                           ; Change to next ring

                        loop lRingTable                 ; Skip forwards
                          inc ix                        ;
                          lend                          ;

                        djnz Rec4                       ; Next ring

                        ; Flag that we are not a virgin???

                        xor a                           ;
                        ld (Virgin),a                   ;

                        ret                             ;

                ; Are we looking at a door character?

OpenIfNess              cp #DC                          ; Horizontal door?
                        jr z OINHor                     ;

                        cp #DD                          ;
                        ret nz                          ; No, exit

                        ; Open a vertical door

OINVer                  push hl                         ;
                        push af                         ;
                        push de                         ;
                        push bc                         ;

                        ld de,128                       ;
                        call MMDoorO2                   ;
                        jr OINEx                        ;

                ; Open a horizontal door

OINHor                  push hl                         ;
                        push af                         ;
                        push de                         ;
                        push bc                         ;

                        ld de,1                         ;
                        call MMDoorO2                   ;

OINEx                   pop bc                          ;
                        pop de                          ;
                        pop af                          ;
                        pop hl                          ;
                        ret                             ;

InitSanctuary           ld hl,BigMaze                   ;
                        ld de,BigMaze+1                 ;
                        ld bc,BigMazeSize-1             ;
                        ld (hl),#20                     ;
                        ldir                            ;

                        ld hl,TopLeftSanc               ;
                        ld (hl),#95                     ;
                        ld b,13                         ;
InitSanc1               inc hl                          ;
                        ld (hl),#93                     ;
                        djnz InitSanc1                  ;

                        inc hl                          ;
                        ld (hl),#96                     ;
                        ld de,128                       ;
                        ld b,111                        ;
InitSanc2               add hl,de                       ;
                        ld (hl),#9C                     ;
                        djnz InitSanc2                  ;

                        add hl,de                       ;
                        ld (hl),#9A                     ;
                        ld b,13                         ;
InitSanc3               dec hl                          ;
                        ld (hl),#93                     ;
                        djnz InitSanc3                  ;

                        dec hl                          ;
                        ld (hl),#99                     ;
                        ld de,-128                      ;
                        ld b,13-7                         ;
InitSanc4               add hl,de                       ;
                        ld (hl),#9C                     ;
                        djnz InitSanc4                  ;

                        ; Draw the door openings (outer) going up...

                        ld b,7+1                         ;

InitSanc5               add hl,de                       ;
                        ld (hl),#9C                     ;
                        add hl,de                       ;
                        ld (hl),#94                     ;
                        add hl,de                       ;
;                        ld (hl),#90                     ; Doorway - overwritten
                        add hl,de                       ;
;                        ld (hl),#90                     ;
                        add hl,de                       ;
;                        ld (hl),#90                     ;
                        add hl,de                       ;
;                        ld (hl),#90                     ;
                        add hl,de                       ;
                        ld (hl),#98                     ;
                        djnz InitSanc5                  ;

                        ; Draw the stairs back down

                        push hl                         ;
                        ld b,49                         ;
InitSanc6               add hl,de                       ;
                        ld (hl),#9C                     ;
                        djnz InitSanc6                  ;
                        pop hl                          ;

                        ld (hl),#99                     ;
                        push hl                         ;

                        ld de,-3584                     ;
                        add hl,de                       ;

                        ld (hl),#9D                     ;
                        ld b,13                         ;
InitSanc7               inc hl                          ;
                        ld (hl),#93                     ;
                        djnz InitSanc7                  ;

                        inc hl                          ;
                        ld (hl),#9E                     ;

                        pop hl                          ;  Top-left of top flightl                         ;
                        push hl                         ;

                        ; Top line of stairs

                        ld b,6                          ;
InitSanc7a              inc hl                          ;
                        ld (hl),#93                     ;
                        djnz InitSanc7a                 ;

                        ; RHS of stairs

                        ld (hl),#96                     ; -\
                        ld de,128                       ;  !

                        ld b,55                         ;

InitSanc8               add hl,de                       ;
                        ld (hl),#9C                     ;
                        djnz InitSanc8                  ;

                        add hl,de                       ;
                        ld (hl),#98                     ;

                        pop hl                          ;  Restore TOP-LEFT of top flight

                        ld de,129-1                     ;
                        add hl,de                       ;

                        ; Draw the stairs

                        ld c,#87                        ; Floor-flag
InitSancD               ld a,#FC                        ;
                        call Rung6                      ;

                        ld b,3                          ;
                        ld a,c                          ;

InitSanc9               call Rung6                      ;
                        djnz InitSanc9                  ;

                        inc hl  ; Treads

                        ld b,3                          ;
                        ld a,#FD                        ;

InitSancB               call Rung                       ;
                        djnz InitSancB                  ;

                        dec hl  ;

                        dec c                           ;
                        ld a,c                          ;
                        cp #7F                          ;
                        jr nz InitSancD                 ;

                        inc hl

                        ld b,5                          ;
                        ld a,#FC                        ;
InitSancE               call Rung                       ;
                        djnz InitSancE                  ;

                        ; Text in sanctury

                        ld b,16                         ;
                        ld de,SMess                     ;
                        ld hl,TopLeftSanc+258           ;

SMessL                  ld c,11                         ;
                        push hl                         ;

SMessl                  ld a,(de)                       ;
                        ld (hl),a                       ;
                        inc de                          ;
                        inc hl                          ;
                        dec c                           ;
                        jr nz SMessl                    ;

                        pop hl                          ;
                        push bc                         ;

                        ld bc,128                       ;
                        add hl,bc                       ;

                        pop bc                          ;
                        djnz SMessL                     ;

                        ret                             ;

Rung6                   push bc                         ;

                        ld b,6                          ;
Rung6Lp                 ld (hl),a                       ;
                        inc hl                          ;
                        djnz Rung6Lp                    ;

                        ld bc,#80-6                     ;
                        add hl,bc                       ;

                        pop bc                          ;
                        ret                             ;

Rung                    push bc                         ;

                        ld b,5                          ;
Rung1                   ld (hl),a                       ;
                        inc hl                          ;
                        djnz Rung1                      ;

                        ld bc,#80-5                     ;
                        add hl,bc                       ;

                        pop bc                          ;
                        ret                             ;

; See if the floor has changed

NFloor                  ld a,(NFloorFl)                 ; New floor -> b
                        dec a                           ;
                        ld b,a                          ;

                        ld a,(cFloor)                   ; Ignore if cfloor=8
                        cp 8                            ;
                        ret z                           ;

                        and #7                          ; Has the floor changed?
                        cp b                            ;
                        ret z                           ; No.

                        ; Different floor.

                        push bc                         ; Save the current floor
                        call SaveFloor                  ;
                        pop bc                          ;

                        ld a,b                          ; Change to the new floor
                        ld (cFloor),a                   ;

                        call Recreate                   ; Recreate the new floor

                        call PlaceMon                   ; Place the monsters

                        call OpenBasement               ; If required

                        call NewScreen                  ; Update the screen

                        jp PM                           ; Draw the man

; See if a monster wants to open a door. HL is pointing at the door.

MonODoor                push hl                         ;
                        push de                         ;
                        push bc                         ;

                        call FindProjSpace              ;

                        pop bc                          ;
                        pop de                          ;
                        pop hl                          ;

                        ret z                           ; We don't have any projectile space

                        push hl                         ;
                        push de                         ;
                        push bc                         ;

                        ld c,50                         ;

                        push hl                         ;

                        ld e,(ix+dm_pMaze_L)            ; From the monster
                        ld d,(ix+dm_pMaze_H)            ;
                        ld hl,(pMan)                    ; To the man

                        call RangeDoor                  ;
                        pop hl                          ;

                        ld (iy+dp_Life),0               ;
                        jr c,MonODRnd                   ; Can't see the man, open randomly

                        ; Can see the man, but is it through a door?

                        ld a,(DoorFlag)                 ;
                        or a                            ;
                        jr z,MonODRnd                   ; Can see him but not through a door, open randomly anyway.

                        ; We can see him through the door, so open it

                        ld a,(hl)                       ;
                        call OpenIfNess                 ;

                        call MoveT2Mark                 ;

                        pop bc                          ;
                        pop de                          ;
                        pop hl                          ;

;                        or a                            ;
;                        sbc hl,de                       ;

                        ret                             ;

        ; Randomly open a door

MonODRnd                ld a,r                          ;
                        and 3                           ;
                        jr nz MonODoorEx                ;

                        ld a,(hl)                       ;
                        call OpenIfNess                 ;

                        call MoveT2Mark                 ;

MonODoorEx              pop bc                          ;
                        pop de                          ;
                        pop hl                          ;
                        ret                             ;

; See if we've escaped the dungeon

OpenPlan                ld a,(cFloor)                   ;
                        and #7                          ;
                        jr nz OpenPlanFEx               ;

                        ld a,(Virgin)                   ;
                        or a                            ;
                        ret z                           ;

                        ld a,(cFloor)                   ;
                        cp 8                            ;
                        ret nz                          ;

                        jp DunIt                        ;

OpenPlanFEx             xor a                           ;
                        ret                             ;

; Count up the treasure in the maze - result in DE

CTres                   ld hl,BigMaze                   ;
                        ld bc,BigMazeSize-1             ;
                        ld de,0                         ;

CTresL                  ld a,(hl)                       ;
                        and #F0                         ;
                        cp #B0                          ;
                        jr nz,CTresN                    ;

                        ld a,(hl)                       ;
                        and #F                          ;
                        add a,e                         ;
                        ld e,a                          ;
                        ld a,0                          ;
                        adc a,d                         ;
                        ld d,a                          ;

CTresN                  cpi                             ;
                        jp v CTresL                     ;

                        ret                             ;

; They've won, dammit - calculate the score. No round numbers in sight...

; Max score =           (40*8)*15       Treasure  4800
;                       8 * 1024        Rings     8192  ()
;                       (32*8)*2        Things    512   ()
;                       1024            Bonus     128   ()

CalcScore_WithTreasure  call CTres                      ; DE := treasure

CalcScore_NoTreasure    ld hl,(nDTs)                    ; Dead things * 2
                        add hl,hl                       ;

                        add hl,de                       ; + Treasure

                        ld a,(nRings)                   ; Rings * 1024
                        ld d,a                          ;
                        ld e,0                          ;

                        add hl,de                       ; + Rings
                        add hl,de                       ; + Rings
                        add hl,de                       ; + Rings
                        add hl,de                       ; + Rings

                        cp 8                            ; But return if we haven't collected them all
                        ret nz                          ;

                        ld de,1024                      ; + Finishing bonus
                        add hl,de                       ;
                        ret                             ;

; See if we can heal this wound, return C if we've not enough magic...

TryToHeal               ld a,(CurrentMagic)             ; Enough magic?
                        sub 30                          ;
                        ret c                           ; No, return

                        ld (CurrentMagic),a             ; See how much healing we can perform
                        ld a,r                          ;
                        and #F                          ;
                        add a,16                        ;
                        ld b,a                          ; b:=healing amount

                        ld a,(Wounds)                   ; Reduce the wounds
                        sub b                           ;
                        jr nc TryHeal1                  ; We're OK

                        ; We took away more than there was, so make the result zero

                        xor a                           ; Clear them all
TryHeal1                ld (Wounds),a                   ;

                        or a                            ; Ret NC
                        ret                             ;

; Shown the score page

ShowTitlesRev           ld hl,#704                      ;
                        ld de,sMessN1                   ;
                        call SPrint                     ;

                        ld hl,#604                      ;
                        jr ST_1                         ;

ShowTitles              ld hl,#604                      ;
                        ld de,sMessN1                   ;
                        call SPrint                     ;

                        ld hl,#704                      ;
ST_1                    ld de,sMessN2                   ;
                        call SPrint                     ;

                        ld hl,1                         ;
                        ld de,sMess6                    ;
                        call SPrint                     ;

                        ld hl,#100                      ;
                        ld de,sMess7                    ;
                        call SPrint                     ;

                        ld hl,#400                      ;
                        ld de,sMess8                    ;
                        call SPrint                     ;

                        ld hl,#801                      ;
                        ld de,sMessN3                   ;
                        jp SPrint                       ;

; Show the scores

DrawScoreFixed          call ShowTitles                 ; Show them

                        ld hl,ScorePos+#F               ;
                        ld de,sMess1                    ;
                        call SPrint                     ;

                        ld hl,ScorePos+#100             ;
                        ld de,sMess3                    ;
                        call SPrint                     ;

                        ld hl,ScorePos+#200             ;
                        ld de,sMess4                    ;
                        call SPrint                     ;

                        ld hl,ScorePos+#300             ;
                        ld de,sMess9                    ;
                        call SPrint                     ;

                        ld hl,ScorePos+#400             ;
                        ld de,sMess5                    ;
                        call SPrint                     ;

                        ld de,sMessA                    ;
                        ld hl,#F00                      ;
                        call SPrint                     ;

                        ; Show the rings

                        ld ix,RingTab+lRingTable*8      ; Point at one past the end of the table
                        ld hl,#F0E                      ;
                        ld bc,#088F                     ;

PRLp                    ld a,(ix+drt_Floor-lRingTable)  ; Floor on the previous entry
                        cp #FF                          ;
                        jr nz PRLp1                     ;

                        ld a,c                          ;
                        call OutIt                      ;

                        inc l                           ; Move right

PRLp1                   dec c                           ; Next ring character

                        loop lRingTable                 ; Skip backwards
                          dec ix                        ;
                          lend                          ;

                        djnz PRLp                       ;

                        ; Draw the bits that can change

DrawScoreEtc            call PrintMagic                 ;

                        call PrintWound                 ;

                        call PrintDTs                   ;

                        ld ix,(nDTs)                    ;
                        ld hl,ScorePos+#30A             ;
                        call PDec_IX                    ;

                        call PrintArrows                ;

                        ; Add arrow direction

                        ld hl,ScorePos+#500             ;
                        ld de,sMess5a                   ;
                        call SPrint                     ;

                        ld a,(ArrDir)                   ; Which way?
                        ld de,sUp                       ;
                        or a                            ;
                        jr z DSE_ArrDirn                ;

                        ld de,sRight                    ;
                        dec a                           ;
                        jr z DSE_ArrDirn                ;

                        ld de,sDown                     ;
                        dec a                           ;
                        jr z DSE_ArrDirn                ;

                        ld de,sLeft                     ;

DSE_ArrDirn             ld hl,ScorePos+#50C             ;
                        call SPrint                     ;

                        ;

                        ret                             ;

SPrint                  ld c,e                          ;

SPrintLp                ld a,(de)                       ;
                        xor c                           ;
                        ret z                           ;

                        call OutIt                      ;

                        ld a,c
                        add a,encoff
                        ld c,a

                        inc de                          ;
                        inc hl                          ;

                        jr SPrintLp                     ;

sMess1                  dbx *,"0%          100%",0       ;
sMess3                  dbx *,"Magic",0                  ;
sMess4                  dbx *,"Wounds",0                 ;
sMess5                  dbx *,"Arrows",0                 ;
sMess5a                 dbx *,"Arrows fire",0            ;
sUp                     dbx *,"up   ",0                  ;
sRight                  dbx *,"right",0                  ;
sDown                   dbx *,"down ",0                  ;
sLeft                   dbx *,"left ",0                  ;

sMess6                  dbx *,"-- Halls of the Things --",0
sMess7                  dbx *,"___________________________",0
sMess8                  dbx *,"(c) Design-Design Software",0
sMess9                  dbx *,"Ex-Things",0              ;
sMessA                  dbx *,"Rings found",0            ;

sMessN1                 dbx *,"Simon Brattel",0
sMessN2                 dbx *,"Neil Mottershead",0
sMessN3                 dbx *,"&  Martin Horsley",0

PrintMagic              ld hl,ScorePos+#10E             ;
                        ld a,(CurrentMagic)             ;

                        cp 255                          ; If it's full show a full bar
                        jr z PBarF                      ;

                        jr PrintBar                     ;

PrintWound              ld hl,ScorePos+#20E             ;
                        ld a,(Wounds)                   ;
                        jr PrintBar_128                 ;

PrintArrows             ld hl,ScorePos+#40E             ;
                        ld a,(ArrowCount)               ;
                        cp 255                          ; If it's full show a full bar
                        jr z PBarF                      ;
                        jr PrintBar                     ;

PrintDTs                ld hl,ScorePos+#30E             ;

                        ld de,(nDTs)                    ; nDead things (0 .. 256)

                        ld a,e                          ; Get the number if it's less than 256

                        dec d                           ; Was it 256?
                        jr z PBarF                      ; Yes, skip

                        ; Print a bar-graph, 0 .. 255 where 255 is one less than max.

PrintBar                srl a                           ; / 2  (0..7F)
                        jr PrintBar_128                 ;

                ; Show a full bar

PBarF                   ld a,128                        ; Full bar

PrintBar_128            call PBarRHS                    ;

                        push hl                         ;
                        ld de,17                        ; Point at the far end
                        add hl,de                       ;
                        call PBarLHS                    ;
                        pop hl
                        inc l                           ;

                        ; Now, fill it in

                        ld b,16                         ; This many

PB_Lp                   cp 8                            ; Less than a full one?
                        call nc PB_Full                 ;
                        call c PB_Partial               ;

                        djnz PB_Lp                      ;

                        ret                             ; Done

PB_Full                 sub 8                           ;
                        push af                         ;

                        ld a,#F0                        ;
                        call OutIt                      ;

                        inc l                           ;

                        pop af                          ;
                        ret                             ;

PB_Partial              and #7                          ;
                        or #E8                          ;
                        call OutIt                      ;
                        inc l                           ;

                        ld a,0                          ; Done
                        ret                             ;

PBarFull                push af                         ; FULL
                        ld a,#F0                        ;
                        call OutIt                      ;
                        pop af                          ;
                        ret                             ;

PBarRHS                 push af                         ; LHS
                        ld a,#F1                        ;
                        call OutIt                      ;
                        pop af                          ;
                        ret                             ;

PBarLHS                 push af                         ; RHS
                        ld a,#F2                        ;
                        call OutIt                      ;
                        pop af                          ;
                        ret                             ;

; Show a number

PDec_IX                 ld c,1
                        ld de,-100
                        call PDecNL1
                        ld de,-10
                        call PDecNL1
                        LD A,IXL
                        ADD A,"0"
                        jp OutItInc

PDecNL1                 XOR A
PDecNL2                 INC A
                        ADD IX,DE
                        JR C,PDecNL2
                        push hl
                        push ix
                        pop hl
                        SBC hl,DE
                        push hl
                        pop ix
                        pop hl
                        dec a
                        or "0"

                        CP C
                        JP Z,OutItInc

                        cp "0"
                        ret z

                        ld c,"0"
OutItInc                call OutIt
                        inc l
                        ret

; Data

SwdUpTab                defb #00,#00,#E5                ;
                        defb #FF,#FF,#E6                ;
                        defb #00,#00,#E5                ;
                        defb #01,#00,#E4                ;
                        defb #00,#00,#E5                ;
                        defb #FF,#FF,#E6                ;
                        defb #00,#00,#E5                ;
                        defb #01,#00,#E4                ;
                        defb #00,#00,#E5                ;
                        defb 0,0,0,0,0                  ;

SwdRtTab                defb #00,#00,#E4                ;
                        defb #80,#00,#E7                ;
                        defb #80,#00,#E6                ;
                        defb #80,#00,#E7                ;
                        defb #00,#00,#E4                ;
                        defb #80,#00,#E7                ;
                        defb #80,#00,#E6                ;
                        defb #80,#00,#E7                ;
                        defb #00,#00,#E4                ;
                        defb 0,0,0,0,0                  ;

SwdDnTab                defb #00,#00,#E5                ;
                        defb #FF,#FF,#E4                ;
                        defb #00,#00,#E5                ;
                        defb #01,#00,#E6                ;
                        defb #00,#00,#E5                ;
                        defb #FF,#FF,#E4                ;
                        defb #00,#00,#E5                ;
                        defb #01,#00,#E6                ;
                        defb #00,#00,#E5                ;
                        defb 0,0,0,0,0                  ;

SwdLfTab                defb #00,#00,#E6                ;
                        defb #80,#00,#E7                ;
                        defb #80,#00,#E4                ;
                        defb #80,#00,#E7                ;
                        defb #00,#00,#E6                ;
                        defb #80,#00,#E7                ;
                        defb #80,#00,#E4                ;
                        defb #80,#00,#E7                ;
                        defb #00,#00,#E6                ;

WallDefs                defb #9C,#9C,#9C,#9C,#9C,#9C,0,0
                        defb #98,#DD,#DD,#DD,#DD,#94,0,0
                        defb #98,#20,#20,#20,#20,#94,0,0
                        defb #20,#20,#20,#20,#20,#20,0,0
                        defb #93,#93,#93,#93,#93,#93,0,0
                        defb #92,#DC,#DC,#DC,#DC,#91,0,0
                        defb #92,#20,#20,#20,#20,#91,0,0
                        defb #20,#20,#20,#20,#20,#20,0,0

; First we have the base value

MonsterTypes            defb 0,0                        ; pMaze
                        defb #D0                        ; Char
                        defb 0                          ; MoveType
                        defb 100                        ; Strength
                        defb 0                          ; Flags
                        defb 16                         ; Magic
                        defb 32                         ; MaxMagic
                        defb 0                          ; Treasure
                        defb 0                          ; MaxTreasure
                        defb 60                         ; Delay
                        defb 60                         ; iDelay
                        defb 4                          ; nArrows
                        defb 30                         ; Wounds
                        defb 0                          ; Combat
                        defb 0                          ; Direction
                        defb 0,0,0,0                    ; Cache

; Then we have the range of variation allowed for each byte

                        defb 0,0                        ; pMaze
                        defb 8                          ; Char
                        defb 6                          ; MoveType  0 .. 5
                        defb 20                         ; Strength
                        defb 0                          ; Flags
                        defb 8                          ; Magic
                        defb 16                         ; MaxMagic
                        defb 0                          ; Treasure
                        defb 0                          ; MaxTreasure
                        defb 0                          ; Delay
                        defb 90                         ; iDelay
                        defb 3                          ; nArrows
                        defb 20                         ; Wounds
                        defb 0                          ; Combat
                        defb 0                          ; Direction
                        defb 0,0,0,0                    ; Cache

        ; Make sure it's sensible

        if (( *-MonsterTypes)/2 ) <> lMonsterFixed
          zeuserror "Error in definition"
        endif

; Screen address conversion

SpecTab                 defw #4000,#4020,#4040,#4060
                        defw #4080,#40A0,#40C0,#40E0
                        defw #4800,#4820,#4840,#4860
                        defw #4880,#48A0,#48C0,#48E0
                        defw #5000,#5020,#5040,#5060
                        defw #5080,#50A0,#50C0,#50E0
                        defw #0000,#0000,#0000,#0000

; Stuff shown in maze

SMess                   db "Halls Of   "                ;
                        db "The Things "                ;
                        db "           "                ;
                        db "1983..2017 "                ;
                        db "           "                ;
                        db "Things     "                ;
                        db "trained by "                ;
                        db "           "                ;
                        db "Martin     "                ;
                        db "Horsley    "                ;
                        db "           "                ;
                        db "Neil       "                ;
                        db "Mottershead"                ;
                        db "           "                ;
                        db "Simon      "                ;
                        db "Brattel    "                ;

; Maze type probabilities

ConTab                  defb   0,255,200,150,127,100, 60, 20
                        defb   0,150,100, 40, 23, 13,  7,  4
                        defb   0,200,100, 50, 30, 20, 10,  5

; Variables from here on.

Vars_Start              equ *

        if def bMyDefaults
GameCount               db JokeDelay-1                  ;
bJokeEnable             db $FF                          ;
        else
GameCount               db 0                            ;
bJokeEnable             db 0                            ; Turned OFF by default
        endif

TapeSaveRegion2Length   equ *-TapeSaveRegion2Start      ; The second block

                           ; The first block

GameType                ds 1                            ;

; Define the positions of the rings

MazeList                ds 8*512                        ;

; The monsters

MonsterList             ds nMonst * lMonst              ;

; The end of used space

Vars_End                equ *

                if Vars_End > $BFBF
                  zeuserror "Out of room!"
                else
                  zeusprint "Free code space before interrupt handler ",$BFBF - Vars_End," bytes"
                endif

                        ds $C000-*,0                    ; Clear it
                        org Vars_End                    ; And move back

TapeSaveRegion3Start    equ *                           ; The third block

                        db "Hello! Long time no see, what? 28 years? Amazing how the time flies when you're busy rotting..."
TapeSaveRegion3Length   equ *-TapeSaveRegion3Start      ; The third block

                        org $BFBF                       ;
TapeSaveRegion4Start    equ *                           ; The fourth block
                        push hl                         ;
                        push bc                         ;
                        push af                         ;

                        ld a,(ManLightDel)              ;
                        or a                            ;
                        jp z Irq_1                      ;

                        dec a                           ;
                        ld (ManLightDel),a              ;

Irq_1                   ld a,1                          ;
                        ld (IrqFlag),a                  ;

                        ld a,(MManDelay)                ;
                        dec a                           ;
                        ld (MManDelay),a                ;

                        call GameScanKeys

                        pop af                          ;
                        pop bc                          ;
                        pop hl                          ;
                        ei                              ;
                        ret                             ;

TapeSaveRegion4Length   equ *-TapeSaveRegion4Start      ; The fourth block
                           ; The fourth

Ye_End                  equ *

; We're going to put the following data at known locations

                        org $C000                       ;

                        ; This MUST be placed at $C000 - for speed some of the code relies on it

BigMazeSize             equ (7*16+1)*128                ;

BigMaze                 ds BigMazeSize,0                ;
TopLeftSanc             equ BigMaze+113                 ;

                        ; F880

; Front end vars

pCurX                   ds 1                            ;
pCurY                   ds 2                            ;
ppCurY                  ds 1                            ;

; Game options

AType                   ds 1                            ;
BType                   ds 1                            ;
CType                   ds 1                            ;
DType                   ds 1                            ;

GameBType               ds 1                            ; A copy so we can drive it in the running game

pKeyVDU                 ds 2                            ;
CurType                 ds 1                            ;
FlashpDisp              ds 2                            ;
UDKat0                  ds 1                            ;
UDKat1                  ds 1                            ;

CurFlag                 ds 1                            ;
CurrKey                 ds 1                            ;
CurrKeyAddr             ds 2                            ;

RepDel                  ds 2                            ;
RepSpeed1               ds 2                            ;
RepSpeed2               ds 2                            ;

CursorSpeed             ds 1                            ;
CursorType              ds 1                            ;
CurCol                  ds 1                            ;

pList                   ds 2                            ;

pInsert                 ds 2                            ;
pHSEnd                  ds 2                            ;

EntryF                  ds 1                            ;
EntryY                  ds 2                            ;

; Key flags                                             ;

KeyStart                equ *
KeyFire                 ds 1                            ;
KeyFireP                ds 1                            ;
KeyArrow                ds 1                            ;
KeyArrowP               ds 1                            ;
KeyLight                ds 1                            ;
KeyLightP               ds 1                            ;
KeyDrop                 ds 1                            ;
KeyDropP                ds 1                            ;
KeyClose                ds 1                            ;
KeyCloseP               ds 1                            ;
KeySword                ds 1                            ;
KeySwordP               ds 1                            ;
KeyPortal               ds 1                            ;
KeyPortalP              ds 1                            ;

Keysp                   ds 1                            ;
KeyspP                  ds 1                            ;
Key1                    ds 1                            ;
Key1P                   ds 1                            ;
Key2                    ds 1                            ;
Key2P                   ds 1                            ;
KeyFlag                 ds 1                            ;
KeyEnd                  equ *

CurrentMagic            ds 1                            ;
Wounds                  ds 1                            ;
TempStore               ds 1                            ;
ArrowCount              ds 1                            ;
TreasureCount           ds 1                            ;
SwagBag                 ds MaxTreasure                  ;
SwdPhase                ds 1                            ;
SwdPos                  ds 2                            ;
ArrDir                  ds 1                            ;
cFloor                  ds 1                            ;
DoorFlag                ds 1                            ;
NFloorFl                ds 1                            ;
UnderMan                ds 1                            ;
JFLAG                   ds 1                            ;
Stack                   ds 2                            ;
Virgin                  ds 1                            ;
MonSRange               ds 1                            ;
pNearMonster            ds 2                            ;

                        align 256                       ;
IntPage                 ds $101                         ;

pFreeProj               ds 2                            ;
pNextProj               ds 2                            ;
pPrevProj               ds 2                            ;

; Misc variables
JinkDirn                ds 1                            ;
JinkDirnUD              ds 1                            ;



Conn                    ds 1                            ;
pMan                    ds 2                            ;
nMan                    ds 2                            ;
pManLookingSquare       ds 2                            ;
OldpMan                 ds 2                            ;
OldManAngle             ds 1                            ;
pFrameX                 ds 1                            ;
pFrameY                 ds 1                            ;
MManDelay               ds 1                            ;
ManAngle                ds 1                            ;
ManOPosXY               ds 2                            ;
JustXDisp               ds 1                            ;
Seed                    ds 4                            ;
bDoorOpenKeepReq        ds 1                            ; We want to open/close a door
LightBounceCnt          ds 1                            ;
bBuilding               ds 1                            ; Flag that we are building the tower
BuildPhase              ds 1                            ; Signal progress
bManMoving              ds 1                            ;
ShowProgX               ds 1                            ;
NoiseCnt                ds 1                            ;
MoveList                ds 4                            ;
MonSAimCnt              ds 1                            ;

; Score vars

nDTs                    ds 2                            ;
nRings                  ds 1                            ;
GameScore               ds 2                            ;

EditChar                ds 1                            ;
EditUnder               ds 1                            ;
pEdit                   ds 2                            ;

; Irq

IrqFlag                 ds 1                            ;
ManLightDel             ds 1                            ;
GameLpCnt               ds 1                            ;
GameSpeed               ds 1                            ;
WallFollowDirn          ds 1                            ;

; The rings

RingTab                 ds lRingTable*8,0               ;

; The projectiles

ProjList                ds nProj * lProj                ;

                        org $FF00                       ; Last page
StackTop                equ *                           ; Top of memory

; The small maze, one byte per room. Needs to be aligned on a page

Maze                    defs #100                       ;

; We want to tell the emulator about the writeable sections

        mem_var Vars_Start,Vars_End-Vars_Start          ; Game variables
        mem_var BigMaze,$10000-BigMaze                  ; We can write this

; This command tells Zeus where to put the code it generates. As a szx file...
; Alter the path to suit your system

                        output_szx "hott.szx",$0000,Start     ; The szx file
                        output_z80 "hott.z80",$0000,Start     ; The z80 file

; Detect and report potential problems

FreeSpace               equ StackTop - Ye_End                           ; Free(ish) room

                if FreeSpace < 50
                        zeusprint "WARNING! Stack space is low!! = ",FreeSpace," bytes"
                else
                        zeusprint "Stack space = ",FreeSpace
                endif

; Warn if there are any strange options set

        if enabled bMyDefaults
          zeusprint "Warning! My Defaults!"
        endif

        if enabled bFixedMaze
          zeusprint "WARNING! Fixed maze!"
        endif

        if enabled bNoDamage
          zeusprint "WARNING! No Damage!"
        endif



