; Build the maze for a floor

BuildTheMaze            push de                         ;
                        push iy                         ;

                        ld a,(cFloor)                   ;
                        and #7                          ;
                        ld iy,ConTab                    ;
                        ld e,a                          ;
                        ld d,0                          ;
                        add iy,de                       ;

                        call CreateMaze                 ;

                        ; Are they masked?

                        ld a,(GameType)                 ; If NZ they're masked
                        or a                            ;
                        jr nz ForceMasked               ; Yes

                        ; Normal game, use option

                        ld a,(AType)                    ; Masked?
                        bit 0,a                         ;
                        jr z BTM_Exit                   ;

                        ; Yes, which floor?

ForceMasked             ld a,(cFloor)                   ; Floor
                        or a                            ;
                        jr z BTM_Exit                   ; 0 is unmasked

                        ; Look up the right mask 1 -> 1 7 -> 80

                        ld b,a                          ;
                        ld a,%00000001                  ;

HackAlign               add a,a                         ; Shift
                        djnz HackAlign                  ;

                        ld c,a                          ; Save the bit-mask

                        ld hl,vMazeMasks                ;
                        call LoadVectorHL               ;
                        ex de,hl                        ;
                        LD hl,Maze                      ;

Hack1                   ld a,(de)                       ;
                        and c                           ;
                        jr nz HackLeave

                        ld a,$FF                        ; Open this cell
                        LD (HL),A                       ;

HackLeave               inc l                           ; Loop
                        inc de                          ;
                        jr nz Hack1                     ;

BTM_Exit                pop iy                          ;
                        pop de                          ;

                        ret                             ;

; Generate the maze

Init                    ld hl,Maze                      ;
                        ld de,Maze+1                    ;
                        ld bc,#FF                       ;
                        ld (hl),0                       ;
                        ldir                            ;

                        ld a,113                        ;
                        ld hl,BigMaze                   ;
                        ld de,BigMaze+1                 ;

Initzzz                 push hl                         ;
                        push de                         ;

                        ld bc,112                       ;
                        ld (hl),#20                     ;
                        ldir                            ;

                        pop de                          ;
                        pop hl                          ;

                        ld bc,128                       ;
                        add hl,bc                       ;

                        ex de,hl                        ;
                        add hl,bc                       ;
                        ex de,hl                        ;

                        sub 1                           ;
                        jr nz,Initzzz                   ;

                        ret                             ;

Draw                    call FindMoves                  ;
                        ret c                           ;

                        call Move                       ;

                        jp Draw                         ;

CreateMaze              call Init                       ;

                        call Rand                       ;

                        ld hl,Maze                      ;
                        ld l,a                          ;

Loop                    call Draw                       ;

                        call Rnd7                       ;
                        jr nc Next                      ;

                        call FindLinks                  ;

                        call Link                       ;

Next                    call FindNext                   ;
                        ret c                           ;

                        call FindLinks                  ;
                        jp c,Next                       ;

                        call Link                       ;

                        jp Loop                         ;

FindMoves               ld de,MoveList                  ;
                        ld bc,Maze                      ;
                        call TMU                        ;
                        call TMD                        ;
                        call TML                        ;
                        call TMR                        ;
                        ld a,e                          ;
                        sub low MoveList                ; Number we found
                        cp 1                            ;
                        ret                             ;

TMU                     ld a,l                          ;
                        and #F0                         ;
                        ret z                           ;

                        ld a,l                          ;
                        add a,#F0                       ;
                        ld c,a                          ;

                        ld a,(bc)                       ;
                        or a                            ;
                        ret nz                          ;

                        ld a,1                          ;
                        ld (de),a                       ;
                        inc de                          ;
                        ret                             ;

TMD                     ld a,l                          ;
                        and #F0                         ;
                        cp #F0                          ;
                        ret z                           ;

                        ld a,l                          ;
                        add a,#10                       ;
                        ld c,a                          ;

                        ld a,(bc)                       ;
                        or a                            ;
                        ret nz                          ;

                        ld a,2                          ;
                        ld (de),a                       ;
                        inc de                          ;
                        ret                             ;

TML                     ld a,l                          ;
                        and #0F                         ;
                        ret z                           ;

                        ld a,l                          ;
                        dec a                           ;
                        ld c,a                          ;

                        ld a,(bc)                       ;
                        or a                            ;
                        ret nz                          ;

                        ld a,3                          ;
                        ld (de),a                       ;
                        inc de                          ;
                        ret                             ;

TMR                     ld a,l                          ;
                        and #0F                         ;
                        cp #0F                          ;
                        ret z                           ;

                        ld a,l                          ;
                        inc a                           ;
                        ld c,a                          ;

                        ld a,(bc)                       ;
                        or a                            ;
                        ret nz                          ;

                        ld a,4                          ;
                        ld (de),a                       ;
                        inc de                          ;
                        ret                             ;

Move                    call Random                     ;

                        add a,low MoveList              ;
                        ld e,a                          ;
                        ld a,3                          ;

                        push hl                         ;
                        push de                         ;
                        call Rnd6                       ;
                        pop de                          ;
                        pop hl                          ;

                        ld a,b                          ;
                        ld (Conn),a                     ;

                        ld a,(de)                       ;
                        dec a                           ;
                        jp z,MoveUP                     ;

                        dec a                           ;
                        jp z,MoveDOWN                   ;

                        dec a                           ;
                        jp z,MoveLEFT                   ;

MoveRIGHT               ld a,(Conn)                     ;
                        or (hl)                         ;
                        ld (hl),a                       ;

                        ld a,l                          ;
                        inc a                           ;
                        ld l,a                          ;

                        ld a,(Conn)                     ;
                        rlca                            ;
                        rlca                            ;
                        or (hl)                         ;
                        ld (hl),a                       ;
                        ret                             ;

MoveLEFT                ld a,(Conn)                     ;
                        rlca                            ;
                        rlca                            ;
                        or (hl)                         ;
                        ld (hl),a                       ;

                        ld a,l                          ;
                        dec a                           ;
                        ld l,a                          ;

                        ld a,(Conn)                     ;
                        or (hl)                         ;
                        ld (hl),a                       ;
                        ret                             ;

MoveDOWN                ld a,(Conn)                     ;
                        rrca                            ;
                        rrca                            ;
                        rrca                            ;
                        rrca                            ;
                        or (hl)                         ;
                        ld (hl),a                       ;

                        ld a,l                          ;
                        add a,#10                       ;
                        ld l,a                          ;

                        ld a,(Conn)                     ;
                        rrca                            ;
                        rrca                            ;
                        or (hl)                         ;
                        ld (hl),a                       ;
                        ret                             ;

MoveUP                  ld a,(Conn)                     ;
                        rrca                            ;
                        rrca                            ;
                        or (hl)                         ;
                        ld (hl),a                       ;

                        ld a,l                          ;
                        add a,#F0                       ;
                        ld l,a                          ;

                        ld a,(Conn)                     ;
                        rrca                            ;
                        rrca                            ;
                        rrca                            ;
                        rrca                            ;
                        or (hl)                         ;
                        ld (hl),a                       ;
                        ret                             ;

FindNext                xor a                           ;
                        ld b,a                          ;

Rst1                    inc l                           ;
                        cp (hl)                         ;
                        ret z                           ;

                        djnz Rst1                       ;

                        ret                             ;

FindLinks               ld de,MoveList                  ;
                        ld bc,Maze                      ;

                        call TryLinkUP                  ;
                        call TryLinkDOWN                ;
                        call TryLinkLEFT                ;
                        call TryLinkRIGHT               ;

                        ld a,e                          ;
                        sub low MoveList                ;
                        cp 1                            ;
                        ret                             ;

TryLinkUP               ld a,l                          ;
                        and #F0                         ;
                        ret z                           ;

                        ld a,l                          ;
                        add a,#F0                       ;
                        ld c,a                          ;

                        ld a,(bc)                       ;
                        or a                            ;
                        ret z                           ;

                        and #30                         ;
                        ret nz                          ;

                        ld a,1                          ;
                        ld (de),a                       ;
                        inc de                          ;
                        ret                             ;

TryLinkDOWN             ld a,l                          ;
                        and #F0                         ;
                        cp #F0                          ;
                        ret z                           ;

                        ld a,l                          ;
                        add a,#10                       ;
                        ld c,a                          ;

                        ld a,(bc)                       ;
                        or a                            ;
                        ret z                           ;

                        and #C0                         ;
                        ret nz                          ;

                        ld a,2                          ;
                        ld (de),a                       ;
                        inc de                          ;
                        ret                             ;

TryLinkLEFT             ld a,l                          ;
                        and #0F                         ;
                        ret z                           ;

                        ld a,l                          ;
                        dec a                           ;
                        ld c,a                          ;

                        ld a,(bc)                       ;
                        or a                            ;
                        ret z                           ;

                        and #03                         ;
                        ret nz                          ;

                        ld a,3                          ;
                        ld (de),a                       ;
                        inc de                          ;
                        ret                             ;

TryLinkRIGHT            ld a,l                          ;
                        and #0F                         ;
                        cp #0F                          ;
                        ret z                           ;

                        ld a,l                          ;
                        inc a                           ;
                        ld c,a                          ;

                        ld a,(bc)                       ;
                        or a                            ;
                        ret z                           ;

                        and #0C                         ;
                        ret nz                          ;

                        ld a,4                          ;
                        ld (de),a                       ;
                        inc de                          ;
                        ret                             ;

Link                    push hl                         ;
                        call Move                       ;
                        pop hl                          ;
                        ret                             ;

Rand                    call Rand1                      ;

                        ld a,(Seed)                     ;
                        ret                             ;

RandOnly_A              push hl                         ; Save
                        push de                         ;
                        push bc                         ;

                        call Rand1                      ;

                        ld a,(Seed)                     ;

                        pop bc                          ;
                        pop de                          ;
                        pop hl                          ;
                        ret                             ; Done

Rand1                   ld hl,(Seed+2)                  ;
                        rl l                            ;
                        rl h                            ;
                        rl l                            ;
                        rl h                            ;
                        ld c,h                          ;
                        ld a,(Seed)                     ;
                        rla                             ;
                        ld b,a                          ;
                        ld de,(Seed+1)                  ;
                        rl e                            ;
                        rl d                            ;
                        res 7,d                         ;
                        ld hl,(Seed)                    ;
                        add hl,bc                       ;
                        ld (Seed),hl                    ;
                        ld hl,(Seed+2)                  ;
                        adc hl,de                       ;
                        res 7,h                         ;
                        ld (Seed+2),hl                  ;
                        ret m                           ;
                        ld hl,Seed                      ;
Rnd1                    inc (hl)                        ;
                        ret nz                          ;
                        inc hl                          ;
                        jp Rnd1                         ;

Rnd2                    push hl                         ;
                        push de                         ;
                        push af                         ;

                        call Rand                       ;
                        and 3                           ;
                        ld b,a                          ;

                        pop af                          ;
                        pop de                          ;
                        pop hl                          ;
                        ret                             ;

Random                  dec a                           ;
                        ret z                           ;

                        dec a                           ;
                        jp z,Rnd3                       ;

                        dec a                           ;
                        jp z,Rnd4                       ;

                        call Rnd2                       ;

                        ld a,b                          ;
                        ret                             ;

Rnd3                    call Rnd2                       ;

                        ld a,b                          ;
                        and 1                           ;
                        ret                             ;

Rnd4                    ld a,2                          ;

Rnd5                    call Rnd2                       ;

                        cp b                            ;
                        jp c,Rnd5                       ;

                        ld a,b                          ;
                        ret                             ;

Rnd6                    ld b,1                          ;

                        push bc                         ;
                        call Rand                       ;
                        pop bc                          ;

                        cp (iy+dmo_Prob1)               ;
                        ret c                           ;

                        inc b                           ;
                        cp (iy+dmo_Prob2)               ;
                        ret c                           ;

                        inc b                           ;
                        ret                             ;

Rnd7                    push hl                         ;
                        push de                         ;
                        push bc                         ;

                        call Rand                       ;

                        pop bc                          ;
                        pop de                          ;
                        pop hl                          ;

                        cp (iy+dmo_Prob0)               ;
                        ret                             ;

; Draw bigmaze

DrawBigmaze             ld a,(cFloor)                   ;
                        and #7                          ;
                        jp nz Page                      ;

                        ; We have a completely empty maze

                        call Init                       ;

                        ld hl,BigMaze                   ;
                        ld b,#6F                        ;
                        ld (hl),#95                     ;

PAGE1                   inc hl                          ;
                        ld (hl),#93                     ;
                        djnz PAGE1                      ;

                        ld hl,BigMaze                   ;
                        ld b,#6F                        ;
                        ld de,128                       ;
PAGE2                   add hl,de                       ;
                        ld (hl),#9C                     ;
                        djnz PAGE2                      ;

                        jp PageC22                      ;

; Draw the bigmaze from a small maze

Page                    ld hl,Maze                      ;
                        exx                             ;
                        ld hl,BigMaze                   ;

                        ld c,#10                        ;
Room1                   ld b,#10                        ;

Room                    push bc                         ;
                        call Corner                     ;

                        push hl                         ;
                        call DrawDown                   ;
                        pop hl                          ;

                        call DrawLeft                   ;
                        inc hl                          ;

                        exx                             ;
                        inc l                           ;
                        exx                             ;

                        pop bc                          ;
                        djnz Room                       ;

                        ld de,#310                      ;
                        add hl,de                       ;

                        dec c                           ;
                        jr nz,Room1                     ;

                        ; Now draw the bottom wall

PageC22                 ld hl,BigMaze+#3800             ;
                        ld ix,BigMaze+#3800-127         ;

                        ld (hl),#99                     ;
                        inc hl                          ;

                        ld b,#6F                        ;

BottL1                  ld a,(ix)                       ;
                        ld (hl),#93                     ;

                        cp #9C                          ;
                        jr z Bottl2A                    ;

                        cp #94                          ;
                        jr nz Bottl2                    ;

Bottl2A                 set 3,(hl)                      ;

Bottl2                  inc hl                          ;
                        inc ix                          ;

                        djnz BottL1                     ;

                        ; Now the RHS inner sidewall

                        ld (hl),#9A                     ;
                        jp SideWall                     ;

DrawWall                ld bc,WallDefs                  ;
                        rlca                            ;
                        rlca                            ;
                        rlca                            ;
                        add a,c                         ;
                        ld c,a                          ;
                        ld a,b                          ;
                        adc a,0                         ;
                        ld b,a                          ;
                        ld a,6                          ;
DrawLoop                ex af,af'                       ;
                        add hl,de                       ;
                        ld a,(bc)                       ;
                        ld (hl),a                       ;
                        inc bc                          ;
                        ex af,af'                       ;
                        dec a                           ;
                        jp nz,DrawLoop                  ;
                        ret                             ;

DrawDown                exx                             ;
                        ld a,(hl)                       ;
                        exx                             ;
                        and #C                          ;
                        rrca                            ;
                        rrca                            ;
                        ld de,#80                       ;
                        call DrawWall                   ;
                        ret                             ;

DrawLeft                exx                             ;
                        ld a,(hl)                       ;
                        exx                             ;
                        and #C0                         ;
                        rlca                            ;
                        rlca                            ;
                        or 4                            ;
                        ld de,#1                        ;
                        call DrawWall                   ;
                        ret                             ;

Corner                  exx                             ;
                        ld e,9                          ;
                        ld bc,Maze                      ;
                        call WallUP                     ;
                        rl e                            ;
                        call WallDOWN                   ;

                        nop

                        rl e                            ;
                        call WallLEFT                   ;
                        rl e                            ;
                        call WallRIGHT                  ;
                        rl e                            ;
                        ld a,e                          ;
                        exx                             ;
                        cp #90                          ;
                        jr nz CornerBlank               ;

                        ld a,#20                        ;
CornerBlank             ld (hl),a                       ;
                        ret                             ;

WallUP                  ld a,l                          ;
                        and #F0                         ;
                        ret z                           ;

                        ld a,l                          ;
                        add a,#F0                       ;
                        ld c,a                          ;
                        ld a,(bc)                       ;
                        and #C                          ;
                        cp #C                           ;
                        ret                             ;

WallDOWN                ld a,(hl)                       ;
                        and #C                          ;
                        cp #C                           ;
                        ret                             ;

WallLEFT                ld a,l                          ;
                        and #F                          ;
                        ret z                           ;

                        ld a,l                          ;
                        dec a                           ;
                        ld c,a                          ;
                        ld a,(bc)                       ;
                        and #C0                         ;
                        cp #C0                          ;
                        ret                             ;

WallRIGHT               ld a,(hl)                       ;
                        and #C0                         ;
                        cp #C0                          ;
                        ret                             ;

