/*
This is a simple demonstration file for the Zeus assembler.
If you want more sustantial files they're available at www.desdes.com

These are just some jottings to help, so they'll just touch on the subjects...

(Updated for Zeus v1.6)


Here are some examples of using Zeus's expression evaluator.

Oh, the first line tells the emulator we're a nameless computer so it
doesn't put a Spectrum ROM at $0000.

Then you can assemble this code and see the results using the "Zeus Code" tab.
*/

                zeusemulate "nameless"  ; Tell the emulator we're a nameless computer

; Let us build a sin look-up table.
; A full circle in 256-steps
;

Entry   = 0
Pi      = 3.1415926
Max     = 2*Pi
Step    = Max/256

                org $100

SinTab          repeat
                  dw 32767*sin(Entry)
                  Entry=Entry+Step
                until Entry >= Max

; Fibonacci series
;

                org $400
FibLast = 0
Fib     = 1
                loop 16
                  FibNext=Fib+FibLast
                  dw FibNext
                  FibLast=Fib
                  Fib=FibNext
                lend

; Strings

                org $500


Str1    = ""
Str2    = "0123456789ABCDEF"

                repeat                          ; Loop
                  Str1="*"+Str1                 ; Put another "*" on the front
                  Str2=Str2[2 .. length(Str2)]  ; Chop the first char off it
                  db Str1+Str2                  ; Concatenate the strings
                until length(Str1)=16           ;


