; This is a basic test for the timers.
;
; Click on assemble/emulate and then select the "Timers" tab up there ^^^
;
; While on the timers tab you can double-click on the min/max displays to reset them
; (note that they will only change, if they do, after the next instruction is executed).
; And start/step/stop execution with F7 and F8

AppFirst                equ $6000                       ; First byte of code (contended memory)

                        zeusemulate "48K","ULA+"        ; Set the model and enable ULA+

; Start planting code here. (When generating a tape file we start saving from here)

                        org AppFirst                    ; Start of application

AppEntry                di                              ; Disable interrupts

                zeustimerstart 1                        ; Start timer 1

                        ld a,12                         ; Should take 7 t-states

                zeustimerstop 1                         ; And stop it again... this has timed the "ld a,12" instruction

                zeustimerstart 2                        ; Start timer 2

                        ld hl,1234                      ; Should take 10 t-states

                zeustimerstop 2                         ; And stop it again... this has timed the "ld hl,1234" instruction

                        jr AppEntry                     ; Loop so that we run them again

; Stop planting code after this. (When generating a tape file we save bytes below here)
AppLast                 equ *-1                         ; The last used byte's address

; Generate some useful debugging commands

                        profile AppFirst,AppLast-AppFirst+1     ; Enable profiling for all the code

; Setup the emulation registers, so Zeus can emulate this code correctly

Zeus_PC                 equ AppEntry                            ; Tell the emulator where to start
Zeus_SP                 equ $FF40                               ; Tell the emulator where to put the stack


