/*
If you want the symbol table saved as a file include the statement "export_sym" followed by a
file-name and, optionally, a numeric parameter which defines the format of the file.

Examples:

        export_sym "c:\fred.sym"

This would output an alphanumerically sorted symbol file where each line is in the
format "fred EQU $1234".

        export_sym "c:\fred.sym",0

This would do exactly the same. The numeric option 0 means sorted, equ included and
hex.

Examples of the possible options are:

0 -> fred EQU $002A
1 -> fred $002A
2 -> fred EQU 42
3 -> fred 42

4 .. 7  same as 0..3 but the list only includes LABELS, not VARIABLES
8 .. 11 same as 0..3 but the list only includes VARIABLES, not LABELS

16..27  same as 0 .. 11 but the list is not alpha-sorted, but in order of symbol definition

32..43  same as 0 .. 11 but the list includes local labels

64..75  same as 0 .. 11 but the list includes segment definitions

In other words the definitions are bit-fields in the option number, so it would be sensible
to use binary when specifying them:

        export_sym "c:\fred.sym",%0 0 1 00 00

would output an unsorted list in the form "fred EQU $1234" and so on...

        export_sym "c:\fred.sym",%0 1 0 00 00

Would output an sorted list in the form "fred EQU $1234" that also includes
local labels.

        export_sym "c:\fred.sym",%1 0 0 00 00

Would output an sorted list in the form "fred EQU $1234" that also includes
segment definitions.
*/

